~s magnetic field computation 

Dear colleague,

The computation code for solar magnetic fields which I have been
developing is almost ready for distribution. The present release
is for unix systems. The force-free field part is still under testing
and the code is not yet versatile enough for general use, but a
preliminary instruction manual is attached.

At the solar physics division of NAOJ/Mitaka, all the necessary 
files are placed under the directory '/usr/local/lib/magpack2'.
At your home directory, execute
     mkdir magpack2
     cd magpack2
     mkdir cntl
     cp /usr/local/lib/magpack2/cntl/* cntl
     cp /usr/local/lib/magpack2/data/* data    (for sample data)
and add '/usr/local/lib/magpack2/bin' to your command search path.

For outside users, the compressed tar-file 'magpack2-VSN.tar.Z'
(here VSN is the version number) can be obtained via anonymous ftp
on spot.mtk.nao.ac.jp (IP address=133.40.5.1). The file is under
'tar' directory. After you uncompress and retrieve the
original source files, follow the instructions given in a file
doc/install.doc. 

Manuals are located under doc/ with the names *.{doc,sj,euc}
Files with extensions sj and euc are documents in Japanese.
Before you start using the code, please read Readme.doc and credit.doc.

There might be some inconsistencies between the instructions and 
what the code actually does. Your comments are welcome in order to
improve the code and the instruction manual.

Sincerely,
Takashi Sakurai
National Astronomical Observatory of Japan

====================== Japanese text ================================

žvZsȂ\tgEFApbP[W̃}jAقڂł
܂̂ŁAR[hƋɌJ܂BĴUNIXn[N
Xe[Vp̃|eV̌vZR[hłBtH[Xt[
ꉞJ܂A܂eXg\ł͂܂B

VEȎzwnɂẮAׂẴt@C
/usr/local/lib/magpack2 ̉ɒuĂ܂B̃z[fBNg
ɂ
     mkdir magpack2
     cd magpack2
     mkdir cntl
     cp /usr/local/lib/magpack2/cntl/* cntl
     cp /usr/local/lib/magpack2/data/* data    (W̃f[^)
sA/usr/local/lib/magpack2/bin pXɉ΁As
ݒ͊łB

Õ[U[́AVEzftpT[o[ (spot.mtk.nao.ac.jp,
IP address =133.40.5.1)Aanonymous ftp ɂ magpack2-VSN.tar.Z
iVSN̓o[WԍjƂt@C̃[NXe[Vɓ]A
uncompress,tarɂt@C𕜌Adoc/install.{doc,sj,euc}
Lꂽ菇ɏ]ĊeTCgɂăCXg[sȂĂB

}jAނ̓fBNg doc/ ̉ɂA*.sj,*.euc ͓{
Ă܂BgpOɁAReadme  credit KǂłB

}jAɂ͂܂sƎv܂BoO̕񍐁Aǧ
߂̃Rg}܂B

V䑾z 䗲


