c  file allocation
c
	subroutine assign(myproc,multi)
c
	logical first
	character line*120, ast*1, op1*8, op2*120
	include 'fcntl.fc'
	include 'procs.fc'
	include 'sys.fc'
	include 'fileio.fc'
	include 'auxparam.fc'
	save first,msg0
	data first/.true./
	data ast/'*'/
c
	if(.not.first) go to 1
c  keep original msglvl
	msg0=msglvl
	do 10 i=1,nfile
	funit(i)=undef
	fname(i)=' '
	fmname(i)=' '
 10	continue
	funit(kbrd)=keyin
	funit(msgs)=msg
	funit(list)=lst
	funit(cntrol)=stdin
c
c  'local'-files are only used within the current system
c  'export'-files may be transported to other operating system
c  'text'-files are transportable
c  'fprint' supports fortran printing control
c
	fmode(rawdat) =undef
	fmode(kbrd  ) =text
	fmode(msgs  ) =text
	fmode(list  ) =fprint
	fmode(cntrol) =text
	fmode(poldeg) =export
	fmode(rmgram) =export
	fmode(imap  ) =export
	fmode(dgram ) =export
	fmode(vmgram) =export
	fmode(smgram) =export
	fmode(tmgram) =export
	fmode(mgram)  =export
	fmode(gmgram) =export
	fmode(fitsi)  =export
	fmode(fitso)  =export
	fmode(s123)   =local
	fmode(inilof) =export
	fmode(itrlof) =export
	fmode(ffbase) =local
	fmode(falpha) =text
	fmode(xvect1) =local
	fmode(xvect2) =local
	fmode(potlof) =export
	fmode(fflof)  =export
	fmode(reflof) =export
	fmode(pltlof) =export
	fmode(s1data) =text
	fmode(auxdat) =text
	fmode(psetup) =text
	fmode(footpt) =text
	fmode(evalpt) =text
	fmode(logfl ) =text
c
	do 20 j=1,nproc
	do 20 i=1,nfile
	fmunit(i,j)=undef
 20	fstat(i,j)=undef
c
	do 21 j=1,nproc
	fstat(kbrd,  j)=rdo
	fstat(cntrol,j)=rdo
	fstat(msgs,  j)=wrt
 21	fstat(list,  j)=wrt
c
c  pre-defined file usage
c
c  poldeg and rmgram are used both for input and output
c  and in order for safety, output mode is set to 'wrto'
c  if output file exists, program exits with error
c
c  files with 'usage=later' will be defined after reading
c  the first line of control data
c
	later = undef
c
c            file       process      usage
c------------------------------------------------
	fstat( auxdat, init   ) =rdo
c
	fstat( rawdat, obs2p  ) =rdo
	fstat( poldeg, obs2p  ) =wrto
c
	fstat( poldeg, pol2b  ) =rdo
	fstat( rmgram, pol2b  ) =wrto
	fstat( imap,   pol2b  ) =later
	fstat( dgram,  pol2b  ) =later
c
	fstat( rawdat, obs2b  ) =rdo
	fstat( rmgram, obs2b  ) =wrto
	fstat( imap,   obs2b  ) =later
	fstat( dgram,  obs2b  ) =later
c
	fstat( fitsi,  rfits  ) =rdo
	fstat( rmgram, rfits  ) =wrto
c
	fstat( rmgram, vector ) =rdo
	fstat( vmgram, vector ) =wrt
	fstat( s1data, vector ) =later
c
	fstat( vmgram, virial ) =later
c
	fstat( smgram, trans  ) =rdo
	fstat( tmgram, trans  ) =wrt
c
	fstat( s123,   ffinit ) =wrt
	fstat( mgram,  ffinit ) =later
	fstat( s1data, ffinit ) =later
	fstat( inilof, ffinit ) =rdwrt
	fstat( ffbase, ffinit ) =wrt
	fstat( falpha, ffinit ) =later
	fstat( xvect1, ffinit ) =wrt
	fstat( xvect2, ffinit ) =wrt
	fstat( itrlof, ffinit ) =wrt
c
	fstat( s123,   ffitr  ) =rdwrt
	fstat( ffbase, ffitr  ) =rdwrt
	fstat( itrlof, ffitr  ) =rdwrt
	fstat( xvect1, ffitr  ) =rdwrt
	fstat( xvect2, ffitr  ) =rdwrt
c
	fstat( mgram,  integp ) =later
	fstat( reflof, integp ) =later
	fstat( footpt, integp ) =later
	fstat( potlof, integp ) =wrt
	fstat( s1data, integp ) =later
c
	fstat( s123,   integf ) =rdo
	fstat( reflof, integf ) =later
	fstat( footpt, integf ) =later
	fstat( fflof,  integf ) =wrt
c
	fstat( mgram,  energy ) =later
	fstat( s1data, energy ) =later
	fstat( s123,   energy ) =later
c
	fstat( evalpt, eval   ) =rdo
	fstat( mgram,  eval   ) =later
	fstat( gmgram, eval   ) =later
	fstat( s1data, eval   ) =later
c
	fstat( mgram,  wfits  ) =rdo
	fstat( fitso,  wfits  ) =wrt
c
	fstat( mgram,  plot   ) =later
	fstat( s1data, plot   ) =later
	fstat( imap,   plot   ) =later
	fstat( dgram,  plot   ) =later
	fstat( pltlof, plot   ) =later
	fstat( psetup, plot   ) =rdo
c
	fstat( mgram,  disp   ) =later
	fstat( s1data, disp   ) =later
	fstat( imap,   disp   ) =later
	fstat( dgram,  disp   ) =later
	fstat( pltlof, disp   ) =later
	fstat( psetup, disp   ) =rdo
c
	fstat( mgram,  databk ) =rdo
	fstat( logfl,  databk ) =rdwrt
c
	fstat( mgram,  test   ) =later
	fstat( s1data, test   ) =later
	fstat( s123,   test   ) =later
c
 1	continue
	rewind (stdin)
	msglvl=msg0
c
c  read file definition section
c
 2	read(stdin,'(a)',end=90, err=91) line
c
	if(line(1:1).ne.ast) go to 2
	if(line(2:2).eq.ast) go to 3
	if(.not.first) go to 2
c  file definitions are only read once 
c
	call split3( line(2:), op1, op2, iop3, multi1,undef)
	if(errflg.ne.0) go to 9
c
c  op1 =logical file name (converted to upper case by subr.split3)
c  op2= (physical) file name
c  iop3=logical unit number
c
	do 30 i=1,nfile
	if(op1.eq.lname(i)) then
	  if(multi1.eq.undef) then
	    fname(i)=op2
	  else
	    fmname(i)=op2
	    fmunit(i,1)=multi1
c  proc.number=1 is used as a dummy argument to record multi-file flag
	  endif
	  funit(i)=iop3
	  if(msglvl.gt.2) write(lst,*)
     &	  '(subr.assign) op1,op2,iop3,multi1=',op1,op2,iop3,multi1
	  go to 2
	endif
 30	continue
c
	write(msg,*)
     &	'(subr.assign) error: illegal logical filename:',op1
	go to 9
c
c  read procedure control section
c
 3	continue
	first=.false.
	if(msglvl.gt.2) write(lst,*) '(subr.assign) myproc=',myproc
	if(myproc.eq.0) go to 5
cx	if(msglvl.gt.0) then
cx	  write(lst,'(/1x,a)')
cx     &'----------------------------------------------------------------'
cx     	  write(lst,*) '(subr.assign) starting ',lproc(myproc)
cx	endif
	if(myproc.eq.init) go to 5
c
 4	read(stdin,'(a)', err=92, end=8) line
	if(line(1:1).ne.ast) go to 4
	call upper(line(2:))
	call split2(line(2:), op1,op2, len1,len2)
	if(msglvl.gt.2) write(lst,*) '(subr.assign) op1,op2=',op1,op2
	if(op1.ne.lproc(myproc)) go to 4
	if(msglvl.gt.0) then
	  write(lst,'(/1x,a)')
     &'----------------------------------------------------------------'
     	  write(lst,*) '(subr.assign) starting ',lproc(myproc)
	endif
c
c  read the first line of control data, which contains switches
c  that specify files to be used
c
	if(myproc.eq.obs2p) then
	  read(stdin,*,end=93,err=94) msglvl
c
	else if(myproc.eq.pol2b) then
	  read(stdin,*,end=93,err=94) 
     &	    msglvl,mkimap,mkdmap
c
	else if(myproc.eq.obs2b) then
	  read(stdin,*,end=93,err=94) 
     &	    msglvl,mkimap,mkdmap
c
	else if(myproc.eq.rfits ) then
	  read(stdin,*,end=93,err=94) msglvl
c
	else if(myproc.eq.vector) then
	  read(stdin,*,end=93,err=94) msglvl
c
	else if(myproc.eq.virial) then
	  read(stdin,*,end=93,err=94) msglvl, rdvmag
c
	else if(myproc.eq.trans ) then
	  read(stdin,*,end=93,err=94) msglvl
c
	else if(myproc.eq.ffinit) then
	  read(stdin,*,end=93,err=94) msglvl, mansel,rds1,rds2
c
	else if(myproc.eq.ffitr ) then
	  read(stdin,*,end=93,err=94) msglvl
c
	else if(myproc.eq.integp) then
	  read(stdin,*,end=93,err=94) msglvl, rdfpt,irefpt,rds1,rds2
c
	else if(myproc.eq.integf) then
	  read(stdin,*,end=93,err=94) msglvl, rdfpt,irefpt
c
	else if(myproc.eq.energy) then
	  read(stdin,*,end=93,err=94) msglvl, rdmag,rds1,rds2,rds123
c
	else if(myproc.eq.eval  ) then
	  read(stdin,*,end=93,err=94) msglvl, rds1,rds2,rds123,mkmmap
c
	else if(myproc.eq.wfits ) then
	  read(stdin,*,end=93,err=94) msglvl
c
	else if(myproc.eq.plot  ) then
	  read(stdin,*,end=93,err=94)
     &	    msglvl, rdlof,rdimap,rddmap,rds1,rds2
c
	else if(myproc.eq.disp  ) then
	  read(stdin,*,end=93,err=94)
     &	    msglvl, rdlof,rdimap,rddmap,rds1,rds2
c
	else if(myproc.eq.databk) then
	  read(stdin,*,end=93,err=94) msglvl
c
	else if(myproc.eq.test  ) then
	  read(stdin,*,end=93,err=94) msglvl, rds1,rds2,rds123
	endif
c
c  set fstat after reading the switches
c
	if(mkimap) then
	           fstat( imap,   pol2b ) =wrt
	           fstat( imap,   obs2b ) =wrt
	endif
	if(mkdmap) then
	           fstat( dgram,  pol2b ) =wrt
	           fstat( dgram,  obs2b ) =wrt
	endif
	if(mkmmap) then
	           fstat( gmgram, eval  ) =wrt
	endif
	if(irefpt.gt.0 .and. irefpt.le.3 ) then
	           fstat( reflof, integp ) =rdo
	           fstat( reflof, integf ) =rdo
	endif
	if(rdfpt ) then
	           fstat( footpt, integp ) =rdo
	           fstat( footpt, integf ) =rdo
	endif
	if(rds1  ) then
	           fstat( s1data, ffinit ) =rdo
	           fstat( s1data, integp ) =rdo
	           fstat( s1data, energy ) =rdo
	           fstat( s1data, eval   ) =rdo
	           fstat( s1data, test   ) =rdo
	           fstat( s1data, plot   ) =rdo
	           fstat( s1data, disp   ) =rdo
	endif
	if(rds2  ) then
	           fstat( mgram,  ffinit ) =rdo
	           fstat( mgram,  integp ) =rdo
	           fstat( mgram,  energy ) =rdo
	           fstat( mgram,  eval   ) =rdo
	           fstat( mgram,  test   ) =rdo
	           fstat( mgram,  plot   ) =rdo
	           fstat( mgram,  disp   ) =rdo
	endif
	if(rds123) then
	           fstat( s123,   energy ) =rdo
	           fstat( s123,   eval   ) =rdo
	           fstat( s123,   test   ) =rdo
	endif
	if(rdvmag) then
	           fstat( vmgram, virial ) =rdo
	endif
	if(rdmag ) then
	           fstat( mgram,  energy ) =rdo
	           fstat( s1data, energy ) =rdo
	endif
	if(mansel) then
	           fstat( falpha, ffinit ) =rdo
	else
	           fstat( falpha, ffinit ) =wrt
	endif
	if(rdimap) fstat( imap,   plot   ) =rdo
	if(rddmap) fstat( dgram,  plot   ) =rdo
	if(rdlof)  fstat( pltlof, plot   ) =rdo
	if(rdimap) fstat( imap,   disp   ) =rdo
	if(rddmap) fstat( dgram,  disp   ) =rdo
	if(rdlof)  fstat( pltlof, disp   ) =rdo
c
c  open statements for i=1(kbrd),2(msgs),3(list) are included only if
c  they are explicitly specified so in the control file
c  this is executed only for myproc=init
c
 5	continue
	errflg=0
	lrec0=80
c
	if(myproc.eq.init) then
	  do 50 i=kbrd,list
	  if(fname(i).eq.' ') go to 50
c
	  if(funit(i).eq.undef) then
	    funit(i)=newfu(i)
	    if(errflg.gt.1) return
	  else if( funit(i).eq.keyin .or.
     &           funit(i).eq.msg .or. funit(i).eq.lst) then
	    ii=funit(i)
	    call clsfl(i)
	    funit(i)=ii
	  else
	    if(inuse(funit(i) +1).gt.0) then 
	      write(msg,910) funit(i),lname(i),lname(inuse(funit(i) +1))
 910	      format(' file unit ',i2,' for ',a,
     &             ' is already assigned to ',a)
	      errflg=2
	      return
	    endif
	  endif
	  call openfl(i,lname(i),
     &	        funit(i),fname(i),fmode(i),fstat(i,myproc),lrec0)
	  if(i.eq.kbrd) keyin=funit(i)
	  if(i.eq.msgs) msg  =funit(i)
	  if(i.eq.list) lst  =funit(i)
 50	  continue
	endif
c  end of processing kbrd, msgs, list
c
c
c  check whether necessary file names are specified in the file
c  denifition section
c  assign unit numbers if they had not been explicitly given
c  and open the specified files
c  
c  i=cntrol is not scanned
c
	multi1=0
	do 60 i=cntrol+1,nfile
c
c  skip unnecessary files for myproc-th procedure
	if(fstat(i,myproc).eq.undef) go to 60
c
c  opened file is not opened again
c  (this option is for the logfile of databook)
	if(funit(i).ne.undef) then
	  if(inuse(funit(i) +1).gt.0) go to 60
	endif
c
c  if ovwrt=1, writeonly option is disabled, and output files are
c  overwritten
	if(fstat(i,myproc).eq.wrto .and. ovwrt.eq.1)
     &	fstat(i,myproc)=wrt
c
c  ask file name if necessary
	if(fname(i).eq.' '.and. funit(i).ne.keyin .and.
     &	funit(i).ne.msg .and. funit(i).ne.lst .and.
     &	fmunit(i,1).eq.undef) 
     &	call getfn(lname(i),fname(i))
c
c  multi-file processing
c
	if(fmunit(i,1).ne.undef) then
	  if(multi.eq.0) then
c  beginning of multi-file processing
c  open namelist file and read one file name
	    fmunit(i,myproc)=newfu(i)
	    if(errflg.gt.1) return
            call openfl(i, '<'//lname(i),
     &	              fmunit(i,myproc),fmname(i),text,rdo,lrec0)
	    read(fmunit(i,myproc),'(a)',end=95,err=95) line
	    call split2(line,fname(i),fcmnt,len1,len2)
c  optional comment is returned in fcmnt of fcntl.fc
	    if(fname(i).eq.' ') go to 95
	    multi1=1
	  else 
c  read one file name
	    read(fmunit(i,myproc),'(a)',end=61,err=95) line
	    call split2(line,fname(i),fcmnt,len1,len2)
c  optional comment is returned in fcmnt of fcntl.fc
	    if(fname(i).eq.' ') go to 61
	    go to 62
c  end of multi-file processing
 61	    close(fmunit(i,myproc))
	    inuse(fmunit(i,myproc) +1)=0
	    fmunit(i,myproc)=undef
	    multi=-1
	    if(msglvl.gt.0) write(lst,*)
     &	   '(subr.assign) multi-file processing ended'
c  end of multi-file processing is notified to the caller
c  by multi=-1
	    errflg=1
	    return
 62	    continue
	  endif
	endif
c
c  the program lines for multi-file processing end here
c
	if(funit(i).eq.undef) then
c  funit not explicitly given, generate new unit number
	  funit(i)=newfu(i)
	  if(errflg.gt.1) return
	  if(i.ne.rawdat) then
	    call openfl(i,lname(i),
     &                funit(i),fname(i),fmode(i),fstat(i,myproc),lrec0)
	  else
	    inuse(funit(i)+1)=i
	  endif
c  open statement for i=rawdat is not given here, but the unit number
c  has to be reserved
c
c  in subr.openfl, open statements do not include file names explicitly
c  if fname is ' ' or '-'
c  for ibm system, fname='-' means that filename is given by a '//dd'
c  statement
c
	else
c  funit explicitly given
	  if(inuse(funit(i) +1).gt.0) then 
	    write(msg,910) funit(i),lname(i),lname(inuse(funit(i) +1))
	    errflg=2
	  endif
	  if(i.ne.rawdat) 
     &	  call openfl(i,lname(i),
     &	              funit(i),fname(i),fmode(i),fstat(i,myproc),lrec0)
	endif
 60	continue
c
	if(multi.eq.0 .and. multi1.gt.0) then
	  multi=1
	  if(msglvl.gt.0) write(lst,*)
     &	   '(subr.assign) multi-file processing started'
	endif
c  beginning of multi-file processing is notified to the caller
c  by multi=1
c
	return
c
c  no data for myproc were found
 8	errflg=1
	return
c
 9	errflg=2
	return
c
 90	write(msg,*)
     &	'(subr.assign) error: endfile while reading filenames'
	errflg=2
	return
c
 91	write(msg,*)
     &	'(subr.assign) error: i/o error while reading filenames'
	errflg=2
	return
c
 92	write(msg,*)
     &	'(subr.assign) error: i/o error while reading procedure names'
	errflg=2
	return
c
 93	write(msg,*)
     &	'(subr.assign) error: endfile while reading data for ',
     &	             lproc(myproc)
	errflg=2
	return
c
 94	write(msg,*)
     &	'(subr.assign) error: i/o error while reading data for',
     &	             lproc(myproc)
	errflg=2
	return
c
 95	write(msg,*)
     &	'(subr.assign) error: i/o error in multi-file processing for',
     &	             lproc(myproc)
	errflg=2
	return
	end
c
c  split a file definition line into three operands
c
	subroutine split3(line, op1,op2,iop3, multi1,undef)
	character*(*) line,op1,op2
	character*80 line2,line3,line4,op3
	logical isint
	integer undef
	include 'sys.fc'
c
	multi1=undef
	op2=' '
	iop3=undef
c
c  find the first word
c
	call split2(line, op1,line2, len1,len2)
	if(errflg.gt.1) return
	if(len1.eq.0) then
	  write(msg,*) '(subr.split3) error: line is blank'
	  errflg=2
	  return
	endif
	call upper(op1)
	if(len2.eq.0) return
c
	call split2(line2, op2,line3, len2,len3)
	if(errflg.gt.1) return
c 
c  multi file specification is signaled if either the second operand
c  is '<' and the third operand is a filename,
c  or the second operand is '<filename'
c
	if(op2(1:1).eq.'<') then
	  multi1=1
	  if(len2.gt.1) then 
	    op2=op2(2:)
	  else
	    line4=line3
	    call split2(line4, op2,line3, len2,len3)
	    if(errflg.gt.1) return
	  endif
	endif
c
c  if the third operand starts with '#', it is the unit number
c  otherwise it is regarded as comment
c
	if(len3.eq.0 .or. (len3.gt.0 .and. line3(1:1).ne.'#') ) return
c
	call split2(line3(2:), op3,line4, len3,len4)
	if(errflg.gt.1) return
	if(len3.gt.0) then
	  if(isint(op3,len3)) read(op3,*) iop3
	endif
	return
	end
c
c  break a line at the first non-leading blank
c
	subroutine split2(line,word1,line2, len1,len2)
c
	character*(*) line,word1,line2
	character tab*1
	include 'sys.fc'
c
	tab=char(9)
	errflg=0
	l=len(line)
	if(l.eq.0) then
	  write(msg,*) '(subr.split2) error: empty string'
	  errflg=2
	  return
	endif
	word1=' '
	line2=' '
c
      do 1 i=1,l
      if(line(i:i).eq.tab) then
        line(i:i)=' '
      endif
 1    continue
c
c  skip leading blanks if any
c
      do 10 i=1,l
      if(line(i:i).ne.' ') go to 11
 10   continue
	len1=0
	len2=0
      return
 11   i0=i
c  i0 is the position of the first non-blank character
c
c  find the end of the first word
c
      do 20 i=i0+1,l
	if(line(i:i).eq.' ') go to 21
 20	continue
	i=l+1
 21   i1=i
c  i1 is the position of the first blank after i0
      word1=line(i0:i1-1)
	len1=i1-1-i0+1
	if(i1.gt.l) then
	  line2=' '
	  len2=0
	  return
	endif
c
c  find the beginning of the second word
c
	do 30 i=i1+1,l
	if(line(i:i).ne.' ') go to 31
 30	continue
	line2=' '
	len2=0
	return
 31	i2=i
c  i2 is the position of the first non-blank after i1
	line2=line(i2:)
	len2=l-i2+1
      return
	end
c
c  split a line at a specified word
c
	subroutine split(line,word,line1,line2,len1,len2)
	character*(*) line,word,line1,line2
	include 'sys.fc'
c
	len1=0
	len2=0
	ll=len(line)
	lw=len(word)
	if(ll.eq.0) then
	  write(msg,*) '(subr.split ) error: empty line'
	  errflg=2
	  return
	endif
	if(lw.eq.0) then
	  write(msg,*) '(subr.split ) error: empty word'
	  errflg=2
	  return
	endif
	if(lw.gt.ll) then
	  write(msg,*) '(subr.split ) error: word longer than line'
	  errflg=2
	  return
	endif
c
	do 10 i=1,ll-lw+1
	if(line(i:i+lw-1).eq.word) go to 20
 10	continue
	line1=line
	line2=' '
	len1=ll
	len2=0
	return
c
 20	if(i.eq.1) then
	  line1=' '
	else
	  line1=line(1:i-1)
	endif
	len1=i-1
	if(i.eq.ll-lw+1) then
	  line2=' '
	else
	  line2=line(i+lw:ll)
	endif
	len2=ll-i-lw+1
	return
	end
c
c  check whether a string contains a valid decimal integer
c
	logical function isint(str,len1)
	character str*(*),num*10
	data num/'0123456789'/
c
	isint=.false.
	if(len1.le.0 .or. len1.gt.len(str)) return
	m=0
c
	do 10 i=1,len1
	if(m.eq.0 .and. str(i:i).eq.' ') go to 10
	m=1
	if(m.eq.2 .and. str(i:i).eq.' ') go to 10
	do 20 j=1,10
	if(str(i:i).eq.num(j:j)) go to 25
 20	continue
	return
 25	m=2
 10	continue
 	isint=.true.
	return
	end
c
	subroutine opened(lname1,funit1,fname1,access,form,status,
     &	                  other,lrec)
	integer funit1
	character lname1*(*),fname1*(*),access*(*),form*(*),
     &	          status*(*),other*(*)
	include 'sys.fc'
c
c  this routine is called from subr.openfl if msglvl>0
c
	write(lst,*) lname1,': file opened, unit=',funit1
	if(fname1.ne.' ')
     &	  write(lst,*) '  filename=',fname1(1:lenstr(fname1))
c
	if(msglvl.gt.1) then
	  if(access.eq.'direct') then
	    write(lst,*) '  form=',form,', status=',status,
     &	                 ', access=',access,', lrec=',lrec
c
	  else
	    write(lst,*) '  form=',form,', status=',status,
     &	                 ', access=',access
	  endif
	  if(other.ne.' ') write(lst,*) '  other parameters:',other
	endif
	return
c
c  this routine is called from subr.openfl
c  
	entry opnerr(lname1,funit1,fname1,access,form,status,
     &	             other,lrec)
c
	write(msg,*) lname1,': file open error, unit=',funit1
c
	if(fname1.ne.' ')
     &	  write(msg,*) '  filename=',fname1(1:lenstr(fname1))
c
	if(access.eq.'direct') then
	  write(msg,*) '  form=',form,', status=',status,
     &	               ', access=',access,', lrec=',lrec
c
	else
	  write(msg,*) '  form=',form,', status=',status,
     &	               ', access=',access
	endif
	if(other.ne.' ') write(lst,*) '  other parameters:',other
c
	if(status.eq.'new') write(msg,*)
     &	'  status=new: file should not exist'
c
	if(status.eq.'old') write(msg,*)
     &	'  status=old: file should exist'
c
	return
	end
c
c  length of character string after trimming trailing blanks
c
	function lenstr(str)
	character str*(*),tab*1
	tab=char(9)
c
	lenstr=len(str)
	if(lenstr.eq.0) return
c
	do 10 i=lenstr,1,-1
	if(str(i:i).ne.' ' .and. str(i:i).ne.tab) go to 20
 10	continue
	lenstr=0
	return
 20	lenstr=i
	return
	end
c
c  request filename to be typed-in
c
	subroutine getfn(lname1, fname1)
	character lname1*(*), fname1*(*)
	include 'sys.fc'
c
	write(msg,*) lname1,' :enter filename'
	read(keyin,'(a)') fname1
	return
	end
c
c  get new fortran unit number
c
	function newfu(lno)
c
	include 'fcntl.fc'
	include 'sys.fc'
c
	no=stdin
 1	no=no+1
	if(inuse(no +1).ne.0) go to 1
	if(no.gt.nomax) then
	  write(msg,*)
     &	  '(func.newfu ) error: no available unit number for ',
     &	  lname(lno)
	  errflg=2
	  newfu = undef
	  return
	endif
	newfu=no
c  subr.openfl will set inuse(no +1)=lno
	return
	end
c
	subroutine allocm(i1,i2,owner1)
c
	include 'sys.fc'
	include 'mdata.fc'
	character owner1*(*)
c
	do 10 i=i1,i2
	if(owner(i).ne.' ') then
	  write(msg,*) '(subr.allocm) error: memory location',i,
     &	               ' is already used by ',owner(i)
	  errflg=2
	  return
	endif
	owner(i)=owner1
 10	continue
	return
c
	entry freem(i1,i2)
	do 20 i=i1,i2
	if(owner(i).eq.' ') then
	  write(msg,*) '(subr.freem ) error: unused memory location',i,
     &	               ' is requested to be freed'
	  errflg=2
	  return
	endif
 20	owner(i)=' '
	return
	end
