c  character code conversion between ASCII and EBCDIC
c
	subroutine cconv(iconv,line)
c
	include 'sys.fc'
c
	character line*(*)
	logical first
	integer atoe,etoa
	dimension atoe(95),etoa(192)
	save first
	data first/.true./
c
c  set atoe and etoa 
c
	if(first) then
	  call setae(atoe,etoa)
	  first=.false.
	endif
c
c  convert ascii to ebcdic
c
	l=len(line)
	if(iconv.eq.2) then
	  do 10 i=1,l
	  ic=mod(ichar(line(i:i))+256,256)
cx	  if(ic.lt.0) ic=ic+256
	  n=ic-32
	  if(n.lt.0.or.n.gt.63) n=0
	  line(i:i)=char(atoe(n+1))
 10	  continue
c
c  convert ebcdic to ascii
c
	else if(iconv.eq.1) then
	  do 20 i=1,l
	  ic=mod(ichar(line(i:i))+256,256)
cx	  if(ic.lt.0) ic=ic+256
	  n=ic-64
	  if(n.lt.0) n=0
	  line(i:i)=char(etoa(n+1))
 20	  continue
	endif
	return
	end
c
c  convert lower case to upper case
c
	subroutine upper(line)
c
	include 'sys.fc'
c
	character line*(*), lc*26, uc*26
	data lc/'abcdefghijklmnopqrstuvwxyz'/
	data uc/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
c
	l=len(line)
	do 10 j=1,l
	do 11 i=1,26
	if(line(j:j).eq.lc(i:i)) then
	  line(j:j) = uc(i:i)
	  go to 12
	endif
 11	continue
 12	continue
 10	continue
	return
c
c  convert upper case to lower case
c
	entry lower(line)
	l=len(line)
	do 20 j=1,l
	do 21 i=1,26
	if(line(j:j).eq.uc(i:i)) then
	  line(j:j) = lc(i:i)
	  go to 22
	endif
 21	continue
 22	continue
 20	continue
	return
	end
c
c  byte swap
c
	subroutine swap2(idata2,nx,ny,ndim)
c
	integer*2 idata2(ndim,1)
c
	do 10 j=1,ny
	do 10 i=1,nx
 10	call sswap2(idata2(i,j))
	return
	end
c
	subroutine swap4(idata4,nx,ny,ndim)
c
	integer*4 idata4(ndim,1)
c
	do 10 j=1,ny
	do 10 i=1,nx
 10	call sswap4(idata4(i,j))
	return
	end
c
	subroutine sswap2(i2)
c
	integer*2 i2
	integer*4 i4
c
	i4=i2
	if(i4.lt.0) i4= 65536 +i4
	i4 = i4/256 + (i4-256*(i4/256))*256
	if(i4.gt.32767) i4=i4 -65536
	i2=i4
	return
	end
c
	subroutine sswap4(i4)
c
	integer*4 i4,ii4
	integer*2 i2(2),ii2
	equivalence (i2,ii4)
c
	ii4=i4
	call sswap2(i2(1))
	call sswap2(i2(2))
	ii2=i2(1)
	i2(1)=i2(2)
	i2(2)=ii2
	i4=ii4
	return
	end
