c  clear x-vector
c
	subroutine clearx
	include 'sys.fc'
	include 'ff0.fc'
	include 'fff.fc'
	integer ounit
	integer iunit1,iunit2,xold,xnew
c
	do 10 l=1,nvar
 10	xvect(l)=0.0
c
	if(msglvl.gt.1) write(lst,*) '(subr.clearx) nvar=',nvar
c
	return
c
c  write x-vector to file xvect1/2
c
	entry writex( ounit )
c
	iser=iser+1
	rewind (ounit)
	write(ounit) iser
	write(ounit) nitr,nrezon,nloop,facta,factda
	write(ounit) nvar,(xvect(l),l=1,nvar)
	write(ounit) nff,(rotb(n),alpha(n), n=1,nff)
c
	if(msglvl.gt.0) then
	  write(lst,*)
     &  '(subr.writex) iser,nitr,nrezone=',iser,nitr,nrezon
	  write(lst,*)
     &  '              nloop,facta=',nloop,facta
	  if(msglvl.gt.1) write(lst,*)
     &  '              ounit=',ounit
	endif
c
	return
c
c  read files xvect1/2 and use the newer data
c
	entry readx( iunit1, iunit2, xold, xnew )
c
	iser1=-1
	iser2=-1
	read(iunit1,end=1,err=1) iser1
 1	read(iunit2,end=2,err=2) iser2
 2	if(iser1.eq.-1 .and. iser2.eq.-1) then
	  write(msg,*) '(subr.readx ) error in reading xvectors'
	  errflg=2
	  return
	endif
c
	if(iser1.gt.iser2) then
	  xold=iunit2
	  xnew=iunit1
	  iser=iser1
	else
	  xold=iunit1
	  xnew=iunit2
	  iser=iser2
	endif
c
	read(xnew) nitr,nrezon,nloop,facta,factda
	read(xnew) nvar1,(xvect(l),l=1,nvar1)
	read(xnew) nff1,(rotb(n),alpha(n), n=1,nff1)
	if(msglvl.gt.0) then 
	  write(lst,*)
     &  '(subr.readx ) iser,nitr,nrezone=',iser,nitr,nrezon
	  write(lst,*)
     &  '              nloop,facta=',nloop,facta
	  if(msglvl.gt.1) write(lst,*) 
     &  '              xnew(input), xold(output)=',xnew,xold
	endif
c  nvar and nff read here are not used
c  those read from ffbase file are the ones actually used
	return
	end
c
c  write s1,s2,s3 sources to file s123
c
	subroutine writes( ounit )
c
	include 'sys.fc'
	include 'coord.fc'
	include 'ss.fc'
	include 's1.fc'
	include 's2.fc'
	include 's3.fc'
	include 'lparam.fc'
	include 'mparam.fc'
	include 'auxparam.fc'
	include 'solar.fc'
	include 'string.fc'
	include 'ff0.fc'
	include 'fff.fc'
	integer ounit
	integer iunits,iunitb
	rad(deg)=3.141592*deg/180.0
c
c  proc.ffitr reads s123 before the iteration and writes s123
c  after every iteration. therefore rewind is necessary
c
	rewind ounit
c
	write(ounit) ns1
	if(ns1.gt.0) write(ounit)
     &	  (aa1(n),n=1,ns1),
     &	  (el1(n),n=1,ns1),
     &	  (bn1(n),n=1,ns1),
     &	  (cj1(n),n=1,ns1),
     &	  ((xxs1(m,n),  m=1,3),n=1,ns1),
     &	  ((direc1(m,n),m=1,3),n=1,ns1),
     &	  ((xxc1(m,n),m=1,3),n=1,3)
	if(msglvl.gt.1) write(lst,*) '(subr.writes) ns1=',ns1
c
	write(ounit) ns2
	if(ns2.gt.0) then
	  write(ounit)
     &	   kindm,nx,ny,xs,ys,dx,dy,ypos,mesh,
     &	   rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	   ns20,kindl,rrss,
     &	   tsys,inst,mfile,dateo,stime,etime,ftag,title,
     &	  (aa2(n),n=1,ns2),
     &	  (flx2(n),n=1,ns2),
     &	  (flx20(n),n=1,ns20),
     &	  ((xxs2(m,n),m=1,3),n=1,ns2),
     &	  ((direc2(m,n),m=1,3),n=1,ns2),
     &	  (dotnl(n),n=1,ns2),
     &	  ((amu(m,n),m=1,3),n=1,ns2)
	  if(msglvl.gt.1) then
     	    write(lst,*) '(subr.writes) ns2,ns20=',ns2,ns20
	    write(lst,*) '  kindm       =',kindm
	    write(lst,*) '  instrument  =',inst
	    write(lst,*) '  fileid      =',mfile
	    write(lst,*) '  systime     =',tsys
	    write(lst,*) '  dateo,stime,etime=',
     &	                    dateo,',',stime,',',etime
	    write(lst,*) '  ftag        =',ftag
	    write(lst,*) '  nx,ny       =',nx,ny
	    write(lst,*) '  xs,ys       =',xs,ys
	    write(lst,*) '  dx,dy,ypos  =',dx,dy,ypos
	    write(lst,*) '  mesh        =',mesh
	    write(lst,*) '  rsp,p,b0,cl0=',rsp,pdeg,b0deg,cl0deg
	    write(lst,*) '  xtod,ytod   =',xtod,ytod
	    write(lst,*) '  title       =',title
	    write(lst,*) '  kindl       =',kindl
	    write(lst,*) '  rrss        =',rrss
	  endif
	endif
c
	write(ounit) ns3
	if(ns3.gt.0) write(ounit)
     &	  (aa3(n),n=1,ns3),
     &	  (el3(n),n=1,ns3),
     &	  (cj3(n),n=1,ns3),
     &	  ((xxs3(m,n),m=1,3),n=1,ns3),
     &	  ((direc3(m,n),m=1,3),n=1,ns3)
	if(msglvl.gt.1) write(lst,*) '(subr.writes) ns3=',ns3
c  ns3=2*lmax: mirror sources are also saved
c
	if(msglvl.eq.1) write(lst,*)
     &	  '(subr.writes) ns1,ns2,ns20,ns3=',ns1,ns2,ns20,ns3

c
	return
c
c  read s1,s2,s3 sources from file s123, and
c  read fff base vectors from file ffbase
c
	entry reads( iunits, iunitb )
c
	ns1=0
	ns2=0
	ns3=0
	nff=0
	lmax=0
	nvar=0
c
	read(iunits,end=1) ns1
	if(msglvl.gt.1) write(lst,*) '(subr.reads ) ns1=',ns1
	if(ns1.gt.0) read(iunits,end=1)
     &	  (aa1(n),n=1,ns1),
     &	  (el1(n),n=1,ns1),
     &	  (bn1(n),n=1,ns1),
     &	  (cj1(n),n=1,ns1),
     &	  ((xxs1(m,n),  m=1,3),n=1,ns1),
     &	  ((direc1(m,n),m=1,3),n=1,ns1),
     &	  ((xxc1(m,n),m=1,3),n=1,3)
c
	read(iunits,end=2) ns2
	if(ns2.gt.0) then
	  read(iunits,end=2)
     &	   kindm,nx,ny,xs,ys,dx,dy,ypos,mesh,
     &	   rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	   ns20,kindl,rrss,
     &	   tsys,inst,mfile,dateo,stime,etime,ftag,title,
     &	  (aa2(n),n=1,ns2),
     &	  (flx2(n),n=1,ns2),
     &	  (flx20(n),n=1,ns20),
     &	  ((xxs2(m,n),m=1,3),n=1,ns2),
     &	  ((direc2(m,n),m=1,3),n=1,ns2),
     &	  (dotnl(n),n=1,ns2),
     &	  ((amu(m,n),m=1,3),n=1,ns2)
          if(msglvl.gt.1) then
            write(lst,*) '(subr.reads ) ns2,ns20=',ns2,ns20
            write(lst,*) '  kindm       =',kindm
            write(lst,*) '  instrument  =',inst
            write(lst,*) '  fileid      =',mfile
            write(lst,*) '  systime     =',tsys
            write(lst,*) '  dateo,stime,etime=',
     &	                    dateo,',',stime,',',etime
            write(lst,*) '  ftag        =',ftag
            write(lst,*) '  nx,ny       =',nx,ny
            write(lst,*) '  xs,ys       =',xs,ys
            write(lst,*) '  dx,dy,ypos  =',dx,dy,ypos
            write(lst,*) '  mesh        =',mesh
            write(lst,*) '  rsp,p,b0,cl0=',rsp,pdeg,b0deg,cl0deg
            write(lst,*) '  xtod,ytod   =',xtod,ytod
            write(lst,*) '  title       =',title
            write(lst,*) '  kindl       =',kindl
            write(lst,*) '  rrss        =',rrss
          endif
	endif
c  
	xxsp(1)=0.0
	xxsp(2)=0.0
	xxsp(3)=-rsp
	prad=rad(pdeg)
	b0rad=rad(b0deg)
c  set xdu and ydu from ypos
	ypos=rad(ydeg)
	call setdu
c
	if(iabs(mesh).le.1) then
	  if(mesh.eq.0) then
	    xtod=xs+0.5*dx*float(nx-1)
	    ytod=ys+0.5*dy*float(ny-1)
	  endif
	  xxtod(1)=xtod
	  xxtod(2)=ytod
	  call projsr(xxtod,rsp)
	  call dtoc(xxtod,xxto)
        ds0=sqrt(abs(dx*dy))*0.25
	elseif(mesh.eq.2) then
	  call setas
	  ds0=sqrt(abs(dx*alofy(dy)))*0.25*rsp
	elseif(mesh.ge.3) then
	  call setar
	  ds0=sqrt(abs(dx*alofy(dy)))*0.25*rsp
	endif
c
c  set integration limits
	x1lim0=xs
	x2lim0=xs+dx*float(nx-1)
	if( iabs(mesh).le.1) then
	  y1lim0=ys
	  y2lim0=ys+dy*float(ny-1)
	  z2lim0=0.5*sqrt((x2lim0-x1lim0)**2+(y2lim0-y1lim0)**2)
	  ds0=sqrt(abs(dx*dy))*0.25
	  x1lim=x1lim0+x1del
	  x2lim=x2lim0+x2del
	  y1lim=y1lim0+y1del
	  y2lim=y2lim0+y2del
	else
	  y1lim0=alofy(ys)
	  y2lim0=alofy(ys+dy*float(ny-1))
	  if(rrss.lt.1.0.or.mod(kindl,1000).lt.100) then
	    z2lim0=rsp*0.5*sqrt((x2lim0-x1lim0)**2+(y2lim0-y1lim0)**2)
	  else
	    z2lim0=rsp*rrss -rsp
	  endif
	  z2lim0=rsp*0.5*sqrt((x2lim0-x1lim0)**2+(y2lim0-y1lim0)**2)
	  ds0=sqrt(abs(dx*alofy(dy)))*0.25*rsp
	  x1lim=x1lim0+x1del/rsp
	  x2lim=x2lim0+x2del/rsp
	  y1lim=y1lim0+y1del/rsp
	  y2lim=y2lim0+y2del/rsp
	endif
	if(z2lim.eq.0.0) z2lim=z2lim0
c
	read(iunits,end=3) ns3
	if(msglvl.gt.1) write(lst,*) '(subr.reads ) ns3=',ns3
	if(ns3.gt.0) read(iunits,end=3)
     &	  (aa3(n),n=1,ns3),
     &	  (el3(n),n=1,ns3),
     &	  (cj3(n),n=1,ns3),
     &	  ((xxs3(m,n),m=1,3),n=1,ns3),
     &	  ((direc3(m,n),m=1,3),n=1,ns3)
c
	if( iunitb.eq.0 ) go to 8
c
	read(iunitb,end=4) nff,lmax,nvar,modeff
	read(iunitb,end=4) bdc, (ls(n),    n=1,nff),
     &	  (le(n),    n=1,nff),
     &	  (bn0(n),   n=1,nff),
     &	  (ss0(n),   n=1,nff),
     &	  (ell0(n),   n=1,nff),
     &	  (rotb0(n), n=1,nff),
     &	  (alpha0(n),n=1,nff),
     &	  (dalpha(n),n=1,nff),
     &	  (bngx0(n), n=1,nff),
     &	  (bngy0(n), n=1,nff),
     &	  (rotbb0(n),n=1,nff),
     &	  ((xxs(m,n),   m=1,3),n=1,nff),
     &	  ((xxn0(m,l),  m=1,3),l=1,lmax),
     &	  ((direc0(m,l),m=1,3),l=1,lmax),
     &	  (bs0(l),l=1,lmax),
     &	  ((ve1(m,l),   m=1,3),l=1,lmax),
     &	  ((ve2(m,l),   m=1,3),l=1,lmax),
     &	  ((vf1(m,l),   m=1,3),l=1,lmax),
     &	  ((vf2(m,l),   m=1,3),l=1,lmax)
c
 8	continue
 	if(msglvl.eq.1) write(lst,*) 
     &  '(subr.reads ) ns1,ns2,ns20,ns3=',ns1,ns2,ns20,ns3
	if(iunitb.gt.0 .and. msglvl.gt.0) write(lst,*)
     &  '              nff,lmax,nvar,modeff=',nff,lmax,nvar,modeff
	return
c
 1	write(msg,*) '(subr.reads ) error in read s1'
	errflg=2
	return
 2	write(msg,*) '(subr.reads ) error in read s2'
	errflg=2
	return
 3	write(msg,*) '(subr.reads ) error in read s3'
	errflg=2
	return
 4	write(msg,*) '(subr.reads ) error in read ffbase'
	errflg=2
	return
	end
