c  calculation of force-free field by iteration
c
	subroutine fffitr( unitl, ounitb, ounits, ounitx )
c
	external jxb,djxb
	include 'sys.fc'
	include 'auxparam.fc'
	include 'ff0.fc'
	include 'fff.fc'
	include 'mdata.fc'
c
	integer unitl,ounitb,ounits,ounitx
c
	if(msglvl.eq.0) then
	  ipr=-1
	else if(msglvl.eq.1) then
	  ipr=0
	else
	  ipr=1
	endif
c
c! here rdata area has to be cleared
c
	almax0=0.0
	almax=0.0
	facta1=0.0
	do 1000 n=1,nff
	almax0=max(almax0,abs(alpha0(n)))
	almax =max(almax, abs(alpha(n)) )
	facta1=min(facta1,abs(alpha(n)/alpha0(n)))
 1000	continue
c
	if(modeff.eq.1) then
c  here, facta1 should be equal to facta in file xvector1/2
c  if facta has been explicitly given in fffmain from stdin,
c  alpha's should be updated
c  if facta1=0, all alpha's=0
	  if(facta1.gt.0.0) then
	    do 1100 n=1,nff
 1100	alpha(n)=alpha(n)*facta/facta1
	  endif
	endif
c
	if(itrmax.eq.0) then
	  nloop=1
	else if(nloop.lt.1) then
c  estimate nloop
	  if(modeff.eq.1) then
	    aux=0.0
	    do 1200 n=1,nff
	    dalpha(n)= sign( 3.141592/ell0(n), alpha0(n))
	    aux=max(aux,abs(alpha0(n)-alpha(n))/abs(factda*dalpha(n)))
 1200	continue
	    nloop= aux +1.5
	  else
	    facta=almax/almax0
	    do 1300 n=1,nff
 1300	dalpha(n)=3.141592/almax0
	    nloop = (almax0-almax)/(factda*dalpha(1)) +1.5
	  endif
	endif
c
	nloop1=nloop
	do 2000 nl=1,nloop1
c
	limit=itrmax
	if(modeff.eq.1) then
	  do 2100 n=1,nff
 	  alpha(n)=alpha(n)+factda*dalpha(n)
	  if(abs(alpha(n)).gt.abs(alpha0(n))) alpha(n)=alpha0(n)
 2100	  continue
	else
	  facta=facta+factda*dalpha(1)/almax0
	  if(facta.gt.1.0) facta=1.0
	endif
c
	if (rezone .and. nitr.gt.0) then
	  write(lst,*) '(subr.fffitr) rezoning'
	  call sets3
	  call spllof( unitl )
	  call fffini( unitl, ounitb )
	  if(errflg.gt.1) return
	  call clearx
	endif
c
	if(nvar*(nvar+2).gt.MX*MY*MD+MX*MY*MZ) then
	  write(lst,*)
     &	  '(subr.fffitr) insufficient working space (required,actual)=',
     &	  nvar*(nvar+2),MX*MY*MD+MX*MY*MZ
	  errflg=2
	  return
	endif
c
	nitr=nitr+1
	if(msglvl.gt.0) then
	  write(lst,*) '(subr.fffitr) nvar,nitr,nloop=',
     &	                nvar,nitr,nloop
     	  write(lst,*) '              facta=',facta
	endif
	call mnnl(jxb,djxb,nvar,xvect,gnorm,gvect,epsfff,delta,step0,
cc	call mnnl(jxb,jxb,nvar,xvect,gnorm,gvect,epsfff,delta,step0,
     &	          limit,ipr,wdata)
	if(limit.lt.0) go to 3000
c
	nloop=max(nloop-1,1)
	call writex(ounitx)
	call writes(ounits)
c
	if(limit.gt.0.and.facta.ge.1.0) go to 3000
 2000	continue
 3000	continue
	if(limit.lt.0) then
	  write(lst,*) '(subr.fffitr) error in iteration'
	  errflg=2
	  return
	endif
c
	return
	end
c
c     list of nodal points
c
	subroutine lstnod(x,g,h)
c
	include 'sys.fc'
	include 'ff0.fc'
	include 'fff.fc'
	dimension x(NVAR0),g(NVAR0),h(NVAR0)
c
	write(lst,100) facta
 100	format(/1x,'(subr.lstnod) facta=',1pe10.2)
c
	do 1000 n=1,nff
	l1=ls(n)
	l2=le(n)
	tw=0.5*abs(alpha(n))*ell(n)
	fn=g(2*lmax+n)
	if(modeff.eq.1) then
	  write(lst,110) n,rotb(n),rotb0(n),alpha0(n),alpha(n),tw
 110	format(/2x, i3,5x,'rotb=',1pe10.2,3x,'rotb0=',e10.2,
     &              3x,'alpha=(',2e10.2,')','twist=',e10.2)
	else
	  write(lst,120) n,rotb(n),rotbb(n),rotbb0(n),fn,tw
 120	format(/2x, i3,5x,'rotb=',1pe10.2,3x,'rotbb=',e10.2,
     &	        3x,'rotbb0=',e10.2,3x,'diff(rotbb)=',e10.2)
	endif
c
	write(lst,130)
 130	format(2x, t10,'x1',t19,'x2',t28,'h1',t37,'h2',t46,'xn',
     &	       t55,'yn',t64,'zn',t73,'bs')
	write(lst,200) (xxs(m,n),m=1,3)
 200	format(41x,1p3e9.2)
c
	do 1200 ll=l1,l2
	bs=sqrt(bbn(1,ll)**2+bbn(2,ll)**2+bbn(3,ll)**2)
	write(lst,300) ll,x(2*ll-1),x(2*ll),h(2*ll-1),h(2*ll),
     &	                 (xxn(m,ll),m=1,3),bs
 300	format(2x, i3,1p8e9.2)
 1200	continue
 1000	continue
c
	return
	end
