c  calculation of scalar potential psi
c
c
	subroutine pot(xx,psi)
c
	include 'sys.fc'
	include 'coord.fc'
	include 'ss.fc'
	include 's1.fc'
	include 's2.fc'
	include 's3.fc'
	include 'lparam.fc'
	include 'auxparam.fc'
c
	integer*4 kindl1
	dimension xx(3),xx1(3),xx2(3),xx0(3)
      dimension xxo1(3),xxo2(3),xxi1(3),xxi2(3),vn1(3),vn2(3),
     &        xxout(3),xxin(3)
c
	dimension am(7),dm(7)
	data am,dm/-2.953108,12.43286,-21.80518,12.82543,1.0,-0.5,0.5,
     &              3.534030,2.762288,2.066811,1.649880,0.5,1.0,0.0/
c  sum(am)=0.5, flux=3.14
	data rc/10.0/, pi/3.141592/
c
	psi=0.0
c
c  s2-source
c
        kindl1=mod(kindl,1000)
	if(ns2.le.0) return
c
c  plane, face on
c  or
c  plane, Bn=given
c  in the latter case n-axis may not be along the  z-direction
c
	if(kindl1.eq.0 .or. kindl1.eq.1) then
	  do 2000 l=1,ns2
	  pp=0.0
	  if(flx2(l).eq.0.0) go to 2000
	  rc2=( (xx(1)-xxs2(1,l))**2
     &	      + (xx(2)-xxs2(2,l))**2
     &	      + (xx(3)-xxs2(3,l))**2 )/aa2(l)**2
	  if(single) then
	    n1=7
	    n2=7
	  else if(rc2.lt.rc*rc) then
	    n1=1
	    n2=4
	  else
	    n1=5
	    n2=6
	  endif
c
	  do 2090 n=n1,n2
	  xx1(1)=xx(1)-xxs2(1,l) + aa2(l)*dm(n)*direc2(1,l)
	  xx1(2)=xx(2)-xxs2(2,l) + aa2(l)*dm(n)*direc2(2,l)
	  xx1(3)=xx(3)-xxs2(3,l) + aa2(l)*dm(n)*direc2(3,l)
	  r2=xx1(1)**2+xx1(2)**2+xx1(3)**2
	  r=sqrt(r2)
	  pp=pp+am(n)/r
 2090	  continue
	  psi=psi+pp*flx2(l)/pi
 2000	  continue
c
c  plane, BL=given
c
	else if (kindl1.eq.11) then
	  do 2100 l=1,ns2
	  pp=0.0
	  if(flx2(l).eq.0.0) go to 2100
	  rc2=( (xx(1)-xxs2(1,l))**2
     &	      + (xx(2)-xxs2(2,l))**2
     &	      + (xx(3)-xxs2(3,l))**2 )/aa2(l)**2
	  if(single) then
	    n1=7
	    n2=7
	  else if(rc2.lt.rc*rc) then
	    n1=1
	    n2=4
	  else
	    n1=5
	    n2=6
	  endif
c
	  do 2190 n=n1,n2
	  xx1(1)=xx(1)-xxs2(1,l) + aa2(l)*dm(n)*direc2(1,l)
	  xx1(2)=xx(2)-xxs2(2,l) + aa2(l)*dm(n)*direc2(2,l)
	  xx1(3)=xx(3)-xxs2(3,l) + aa2(l)*dm(n)*direc2(3,l)
	  r2=xx1(1)**2+xx1(2)**2+xx1(3)**2
	  r=sqrt(r2)
	  r3=r2*r
	  dr=dlg(1)*xx1(1)+dlg(2)*xx1(2)+dlg(3)*xx1(3)
	  den=r+dr
	  rm=amu(1,l)*xx1(1)+amu(2,l)*xx1(2)+amu(3,l)*xx1(3)
	  pp=pp+am(n)*(rm/den+dotnl(l))/r
 2190	  continue
	  psi=psi+pp*flx2(l)/pi
 2100	  continue
c
c  spherical, Bn=given
c
	else if (kindl1.eq.2 .or. kindl1.eq.102 .or. kindl1.eq.103) then
	  do 2200 l=1,ns2
	  pp=0.0
	  if(flx2(l).eq.0.0) go to 2200
	  rc2=( (xx(1)-xxs2(1,l))**2
     &	      + (xx(2)-xxs2(2,l))**2
     &	      + (xx(3)-xxs2(3,l))**2 )/aa2(l)**2
	  if(single) then
	    n1=7
	    n2=7
	  else if(rc2.le.rc*rc) then
	    n1=1
	    n2=4
	  else
	    n1=5
	    n2=6
	  endif
c
	  xx0(1)=xx(1)-xxsp(1)
	  xx0(2)=xx(2)-xxsp(2)
	  xx0(3)=xx(3)-xxsp(3)
	  r0=sqrt(xx0(1)**2+xx0(2)**2+xx0(3)**2)
	  do 2290 n=n1,n2
	  xx1(1)=xx(1)-xxs2(1,l) + aa2(l)*dm(n)*direc2(1,l)
	  xx1(2)=xx(2)-xxs2(2,l) + aa2(l)*dm(n)*direc2(2,l)
	  xx1(3)=xx(3)-xxs2(3,l) + aa2(l)*dm(n)*direc2(3,l)
	  rn=xx0(1)*direc2(1,l)+xx0(2)*direc2(2,l)+xx0(3)*direc2(3,l)
	  r1=sqrt(xx1(1)**2+xx1(2)**2+xx1(3)**2)
	  if(rn.gt.0.0) then
	    pp=pp+am(n)*(1.0/r1-0.5/rsp*alog((r0+rn)/(r1+rn-rsp)))
	  else
	    pp=pp+am(n)*(1.0/r1+0.5/rsp*alog((r0-rn)/(r1-rn+rsp)))
	  endif
 2290	  continue
	  psi=psi+pp*flx2(l)/pi
c
c  inclusion of source surface
c
	  if( (kindl1.eq.102 .or. kindl1.eq.103) .and. rrss.gt.1.0) then
	    xxout(1)=xx0(1)- aout*direc2(1,l)
	    xxout(2)=xx0(2)- aout*direc2(2,l)
	    xxout(3)=xx0(3)- aout*direc2(3,l)
	    xxin (1)=xx0(1)- ain *direc2(1,l)
	    xxin (2)=xx0(2)- ain *direc2(2,l)
	    xxin (3)=xx0(3)- ain *direc2(3,l)
	    rout=sqrt(xxout(1)**2+xxout(2)**2+xxout(3)**2)
	    rin =sqrt(xxin (1)**2+xxin (2)**2+xxin (3)**2)
c
	    if(rn.ge.0.0) then
	      ppp=-amin/rin 
     &	     -amout*(1.0/rout-1.0/rsp*alog((r0+rn)/(rin+rn-ain)))
cx   &	     -amout*(1.0/rout-1.0/rsp*alog((r0+rn)/(rin+rn-rsp)))
cx  corrected 00/10/17
	    else
	      ppp=-amin/rin 
     &	     -amout*(1.0/rout+1.0/rsp*alog((r0-rn)/(rin-rn+ain)))
cx   &	     -amout*(1.0/rout+1.0/rsp*alog((r0-rn)/(rin-rn+rsp)))
cx  corrected 00/10/17
	    endif
	    psi=psi +ppp*flx2(l)/pi
	  endif
 2200	  continue
c
c  spherical, BL=given
c
	else if (kindl1.eq.12 .or. kindl1.eq.112) then
	  do 2300 l=1,ns2
	  pp=0.0
	  if(flx2(l).eq.0.0) go to 2300
	  rc2=( (xx(1)-xxs2(1,l))**2
     &	      + (xx(2)-xxs2(2,l))**2
     &	      + (xx(3)-xxs2(3,l))**2 )/aa2(l)**2
	  if(single) then
	    n1=7
	    n2=7
	  else if(rc2.lt.rc*rc) then
	    n1=1
	    n2=4
	  else
	    n1=5
	    n2=6
	  endif
c
	  vn1(1)=direc2(1,l)
	  vn1(2)=direc2(2,l)
	  vn1(3)=direc2(3,l)
	  vn2(1)=vn1(1)-2.0*dotnl(l)*dlg(1)
	  vn2(2)=vn1(2)-2.0*dotnl(l)*dlg(2)
	  vn2(3)=vn1(3)-2.0*dotnl(l)*dlg(3)
	  do 2390 n=n1,n2
	  xx1(1)=xx(1)-xxs2(1,l) + aa2(l)*dm(n)*vn1(1)
	  xx1(2)=xx(2)-xxs2(2,l) + aa2(l)*dm(n)*vn1(2)
	  xx1(3)=xx(3)-xxs2(3,l) + aa2(l)*dm(n)*vn1(3)
	  xx2(1)=xx(1)-xxs2(1,l)+2.0*dotnl(l)*rsp*dlg(1)
     &	        +aa2(l)*dm(n)*vn2(1)
	  xx2(2)=xx(2)-xxs2(2,l)+2.0*dotnl(l)*rsp*dlg(2)
     &	        +aa2(l)*dm(n)*vn2(2)
	  xx2(3)=xx(3)-xxs2(3,l)+2.0*dotnl(l)*rsp*dlg(3)
     &	        +aa2(l)*dm(n)*vn2(3)
	  r1=sqrt(xx1(1)**2+xx1(2)**2+xx1(3)**2)
	  r2=sqrt(xx2(1)**2+xx2(2)**2+xx2(3)**2)
	  rm=amu(1,l)*xx1(1)+amu(2,l)*xx1(2)+amu(3,l)*xx1(3)
	  dr=dlg(1)*(xx(1)-xxsp(1))
     &	    +dlg(2)*(xx(2)-xxsp(2))
     &	    +dlg(3)*(xx(3)-xxsp(3))
	  dr1=dlg(1)*xx1(1)+dlg(2)*xx1(2)+dlg(3)*xx1(3)
	  dr2=dlg(1)*xx2(1)+dlg(2)*xx2(2)+dlg(3)*xx2(3)
	  if(dr.ge.0.0) then
	    sig = 1.0
	    den1=r1+dr1
	    den2=r2+dr2
	  else
	    sig =-1.0
	    den1=r1-dr1
	    den2=r2-dr2
	  endif
	  pp=pp+am(n)*(
     &	  dotnl(l)*(1.0/r1+1.0/r2)
     &	 +rm*sig*(1.0/r1/den1-1.0/r2/den2)
     &	 +0.5*sig/rsp*alog(den2/den1)
     &	         )
 2390	continue
c
	  psi=psi+pp*flx2(l)/pi
c
	  if(kindl1.eq.112 .and. rrss.gt.1.0) then
c
	    xx0(1)=xx(1)-xxsp(1)
	    xx0(2)=xx(2)-xxsp(2)
	    xx0(3)=xx(3)-xxsp(3)
	    xxo1(1)=xx0(1)-aout*vn1(1)
	    xxo1(2)=xx0(2)-aout*vn1(2)
	    xxo1(3)=xx0(3)-aout*vn1(3)
	    xxo2(1)=xx0(1)-aout*vn2(1)
	    xxo2(2)=xx0(2)-aout*vn2(2)
	    xxo2(3)=xx0(3)-aout*vn2(3)
	    xxi1(1)=xx0(1)-ain *vn1(1)
	    xxi1(2)=xx0(2)-ain *vn1(2)
	    xxi1(3)=xx0(3)-ain *vn1(3)
	    xxi2(1)=xx0(1)-ain *vn2(1)
	    xxi2(2)=xx0(2)-ain *vn2(2)
	    xxi2(3)=xx0(3)-ain *vn2(3)
c
	    ro1=sqrt(xxo1(1)**2+xxo1(2)**2+xxo1(3)**2)
	    ro2=sqrt(xxo2(1)**2+xxo2(2)**2+xxo2(3)**2)
	    ri1=sqrt(xxi1(1)**2+xxi1(2)**2+xxi1(3)**2)
	    ri2=sqrt(xxi2(1)**2+xxi2(2)**2+xxi2(3)**2)
	    dro1=dlg(1)*xxo1(1)+dlg(2)*xxo1(2)+dlg(3)*xxo1(3)
	    dro2=dlg(1)*xxo2(1)+dlg(2)*xxo2(2)+dlg(3)*xxo2(3)
	    dri1=dlg(1)*xxi1(1)+dlg(2)*xxi1(2)+dlg(3)*xxi1(3)
	    dri2=dlg(1)*xxi2(1)+dlg(2)*xxi2(2)+dlg(3)*xxi2(3)
c
	    if(dr.ge.0.0d0) then
	      deni1 = ri1+dri1
	      deni2 = ri2+dri2
	      sig= 1
	    else
	      deni1 = ri1-dri1
	      deni2 = ri2-dri2
	      sig=-1
	    endif
	    deno1 = ro1-dro1
	    deno2 = ro2+dro2
c
	    amout=0.5
	    amin= -(rsp/aout)*amout
	    ppp= 0.5d0*amin/rsp*sig*log(deni1/deni2)
     &	        -0.5d0*amout/rsp*log(deno1*deno2)
	    psi=psi+ppp*flx2(l+ns2)/pi
	  endif
c
 2300	  continue
	endif
 2900	continue
	return
	end
c
c  calculation of vector potential a(1-3)
c
	subroutine vpot(xx,a,isw1,isw3)
      include 'sys.fc'
      include 'coord.fc'
      include 'ss.fc'
      include 's1.fc'
      include 's2.fc'
      include 's3.fc'
      include 'ff0.fc'
      include 'fff.fc'
      include 'lparam.fc'
c
      dimension xx(3),a(3),aa(3),cu(3)
c
	do 10 m=1,3
 10	aa(m)=0.0
c
c  isw = 1 : on
c        0 : selective
c              ksw.ne.0 : on
c              ksw =  0 : off
c       -1 : off
c
c  s1-source
c
	if(isw1.lt.0) go to 1900
	if(ns1.le.0) go to 1900
c
	do 1000 l=1,ns1
	if(cj1(l).eq.0.0) go to 1000
	if(isw1.eq.0.and.ksw1(l).eq.0) go to 1000
	z=direc1(1,l)*(xx(1)-xxs1(1,l))
     &	 +direc1(2,l)*(xx(2)-xxs1(2,l))
     &	 +direc1(3,l)*(xx(3)-xxs1(3,l))
	cu(1)=xx(1)-xxs1(1,l)-z*direc1(1,l)
	cu(2)=xx(2)-xxs1(2,l)-z*direc1(2,l)
	cu(3)=xx(3)-xxs1(3,l)-z*direc1(3,l)
	c=cu(1)**2+cu(2)**2+cu(3)**2
	if(c.ne.0.0) then
	  c=sqrt(c)
	  cu(1)=cu(1)/c
	  cu(2)=cu(2)/c
	  cu(3)=cu(3)/c
	endif
	call vpots(c,z,aa1(l),el1(l),af)
	aa(1)=aa(1)+af*cj1(l)*(direc1(2,l)*cu(3)-direc1(3,l)*cu(2))
	aa(2)=aa(2)+af*cj1(l)*(direc1(3,l)*cu(1)-direc1(1,l)*cu(3))
	aa(3)=aa(3)+af*cj1(l)*(direc1(1,l)*cu(2)-direc1(2,l)*cu(1))
 1000	continue
 1900	continue
c
c  s3-source
c
c  normalized az: jz roughly gaussian
c  total current=1
c  radius=1
c
	if(ns3.le.0) go to 3900
	if(isw3.lt.0) go to 3900
c
	do 3000 l=1,ns3
	if(cj3(l).eq.0.0) go to 3000
	if(isw3.eq.0.and.ksw3(l).eq.0) go to 3000
	z=direc3(1,l)*(xx(1)-xxs3(1,l))
     &	 +direc3(2,l)*(xx(2)-xxs3(2,l))
     &	 +direc3(3,l)*(xx(3)-xxs3(3,l))
	cu(1)=xx(1)-xxs3(1,l)-z*direc3(1,l)
	cu(2)=xx(2)-xxs3(2,l)-z*direc3(2,l)
	cu(3)=xx(3)-xxs3(3,l)-z*direc3(3,l)
	c=cu(1)**2+cu(2)**2+cu(3)**2
	if(c.eq.0.0) then
	  c=sqrt(c)
	  cu(1)=cu(1)/c
	  cu(2)=cu(2)/c
	  cu(3)=cu(3)/c
	endif
c
	call vpotc(c,z,aa3(l),el3(l),az)
c
	aa(1)=aa(1)+az*cj3(l)*direc3(1,l)
	aa(2)=aa(2)+az*cj3(l)*direc3(2,l)
	aa(3)=aa(3)+az*cj3(l)*direc3(3,l)
 3000	continue
 3900	continue
c
	do 5000 m=1,3
 5000	a(m)=aa(m)
	return
	end
c
c  vector potential of current tube
c
	subroutine vpotc(c0,z0,a0,hh0,az)
c
c  (c0,z0): cylindrical coordinate
c  a0: radius of the tube
c  hh0: full length of the tube
c  az: z-component of vector potential
c
	include 'auxparam.fc'
	dimension am(6),dm(6)
	data am,dm/-2.953108,12.43286,-21.80518,12.82543,  1.0,-0.5,
     &	            3.534030,2.762288, 2.066811,1.649880,  0.5,1.0/
	data rc/10.0/
	c=c0/a0
	c2=c*c
	z=abs(z0)/a0
	h=(hh0/a0)/2.0
	az=0.0
	if(z.le.h) then
	  if(single) then
	    n1=7
	    n2=7
	  else if(c.lt.rc) then
	    n1=1
	    n2=4
	  else
	    n1=5
	    n2=6
	  endif
	  do 3110 n=n1,n2
 3110	  az=az+2.0*am(n)*alog( (h+dm(n)+z+sqrt(c2+(h+dm(n)+z)**2))
     &	                 *(h+dm(n)-z+sqrt(c2+(h+dm(n)-z)**2))
     &	                 /(dm(n)+sqrt(c2+dm(n)**2))**2 )
	else
	  if(single) then
	    n1=7
	    n2=7
	  else if(c*c+(z+h)*(z+h).lt.rc*rc) then
	    n1=1
	    n2=4
	  else
	    n1=5
	    n2=6
	  endif
	  do 3120 n=n1,n2
 3120	  az=az+2.0*am(n)*alog( (z+dm(n)+h+sqrt(c2+(z+dm(n)+h)**2))
     &	                 /(z+dm(n)-h+sqrt(c2+(z+dm(n)-h)**2)) )
	endif
	return
	end
c
c  vector potential of solenoid coil
c
	subroutine vpots(c0,z0,a0,hh0,af)
c
c  vector potential af at cylindrical coordinates (c0,z0)
c  hh0 : full length of the coil
c  z0  : height above the top of the coil
c  a0  : radius
c  total current ( integrated in z ) = 1.0
c  dipole moment 3.14*a0*a0*cj = 1.0  when a0-->0.0
c
	implicit real*8(d)
	real*4 df
	logical first
	include 'sys.fc'
	dimension cf(10,10),f(20),df(20),fh(10)
	dimension zp(10,10),wp(10,10)
	save first,cf,fh,c1,c2,c3,c4
	data first/.true./
	data pi/3.141592/
c
	data zp/10*0.0,
     2	.57735027,-.57735027, 8*0.0,
     3	.77459667,-.77459667, 8*0.0,
     4	.86113631,-.86113631,.33998104,-.33998104, 6*0.0,
     5	.90617984,-.90617984,.53846931,-.53846931, 6*0.0,
     6	.93246951,-.93246951,.66120939,-.66120939,.23861919,-.23861919,
     &	4*0.0,
     7	.94910791,-.94910791,.74153119,-.74153119,.40584515,-.40584515,
     &	4*0.0,
     8	.96028986,-.96028986,.79666648,-.79666648,.52553241,-.52553241,
     &	.18343464,-.18343464, 2*0.0,
     9	.96816024,-.96816024,.83603111,-.83603111,.61337143,-.61337143,
     &	.32425342,-.32425342, 2*0.0,
     1	.97390653,-.97390653,.86506337,-.86506337,.67940957,-.67940957,
     &	.43339539,-.43339539,.14887434,-.14887434/
	data wp/2.0, 9*0.0,
     2	2*1.0, 8*0.0,
     3	2*.55555556,  .88888889, 7*0.0,
     4	2*.34785485,2*.65214515, 6*0.0,
     5	2*.23692689,2*.47862867,  .56888889, 5*0.0,
     6	2*.17132449,2*.36076157,2*.46791393, 4*0.0,
     7	2*.12948497,2*.27970539,2*.38183005,  .41795918, 3*0.0,
     8	2*.10122854,2*.22238103,2*.31370665,2*.36268378, 2*0.0,
     9	2*.08127439,2*.18064816,2*.26061070,2*.31234708, .33023936,0.0,
     1	2*.06667134,2*.14945135,2*.21908636,2*.26926672,2*.29552422/
c
	dcelik(d)=dak0+d*(dak1+d*(dak2+d*dak3))
     &	         -(dbk0+d*(dbk1+d*(dbk2+d*dbk3)))*dlog(d)
	dcelie(d)=1.0d0+d*(dae1+d*(dae2+d*dae3))
     *	         -d*(dbe1+d*(dbe2+d*dbe3))*dlog(d)
	data dak0,dak1,dak2,dak3,dbk0,dbk1,dbk2,dbk3/
     1	  1.386294361d0, 0.097932891d0, 0.054544409d0, 0.032024666d0,
     2	  0.500000000d0, 0.124750742d0, 0.060118519d0, 0.010944912d0/,
     3	dae1,dae2,dae3,dbe1,dbe2,dbe3/
     4	  0.444792040d0, 0.085099193d0, 0.040905094d0,
     5	  0.249697949d0, 0.081502240d0, 0.013829990d0/
c
	if(first) then
	  c1=3./4.
	  c2=75./128.
	  c3=245./512.
	  c4=6615./16384.
	  f(1)=1.0
	  do 10 l=1,19
 10	  f(l+1)=f(l)*float(l)
	  df(1)=1.0
	  do 20 l=1,19
 20	  df(l+1)=df(l)*float(2*l+1)
	  cf(1,1)=1.0
	  do 30 ll=2,10
	  l=ll-1
	  do 30 ii=1,ll
	  i=ii-1
	  fct=1.0
	  li1=l-i+1
	  cc=0.0
	  do 40 kk=1,li1
	  k=kk-1
	  cc=cc+fct*df(l+k+1)/(f(2*k+1)*f(li1-k)*f(i+1))
	  fct=-2.0*fct
 40	  continue
	  cf(ii,ll)=cc/float(2*(l-i)+1)
 30	  continue
	  first=.false.
	endif
c
	if(a0.eq.0.0) then
	  if(hh0.eq.0.0) then
c
c  dipole
c
	    r=sqrt(c0*c0+z0*z0)
	    af=c0/r**3
c
	  else
c
c  monopole pair
c
	    r=sqrt(c0*c0+(z0+hh0)**2)
	    af=(z0+hh0)/r
	    r=sqrt(c0*c0+z0*z0)
	    af=(af-z0/r)/hh0
	    if(c0.ne.0.0) af=af/c0
	    if(a0.ne.0.0) af=af*a0*a0*pi
	  endif
	  return
	endif
c
	c=c0/a0
	z =z0 /a0
	hh=hh0/a0
	h=0.5*hh
	r0=(2.0*h*h+2.0*h+0.72)/(h*h+1.7*h+0.4)*sqrt(1.0+h*h)
	if((c/r0)**2+((z+h)/(r0*1.35))**2.gt.1.0) then 
	  if(h.gt.80.0) then
c
c  monopole pair
c
	    if(msglvl.gt.0) write(lst,*)
     &	      '(subr.vpots ) warning: too large hh0 (',hh0,
     &	      '), replaced with  monopole pair'
	    r=sqrt(c0*c0+(z0+hh0)**2)
	    af=(z0+hh0)/r
	    r=sqrt(c0*c0+z0*z0)
	    af=(af-z0/r)/hh0
	    if(c0.ne.0.0) af=af/c0
	    if(a0.ne.0.0) af=af*a0*a0*pi
	    return
	  endif
c
c  distant zone : multipole expansion
c
	  zz=z+h
	  rr=c*c+zz*zz
	  ri=1.0/rr
	  r=sqrt(rr)
	  costh=zz/r
	  sinth=c/r
	  ff=2.0*pi*ri*sinth
	  h2=h*h
	  fh(1)=1.0
	  pd=1.0
	  p0=1.0
	  p1=costh
	  af=0.5*ff
	  if(af.lt.1.0e-30) return
	  ic=0
	  do 1000 l=1,9
	  p2=(float(4*l-1)*costh*p1-float(2*l-1)*p0)/float(2*l)
	  pd=pd+float(4*l+1)*p2
	  ff=-0.5*ff*ri
	  fh(l+1)=fh(l)*h2
	  l1=l+1
	  afd=0.0
	  do 1100 i1=1,l1
 1100	  afd=afd+cf(i1,l1)*(fh(l1-i1+1)*ff)
	  afd=afd*pd/float((2*l+1)*(2*l+2))
	  af=af+afd
	  if(abs(afd).gt.1.0e-4*abs(af)) then
	    ic=0
	  else
	    if(ic.eq.1) return
	    ic=1
	  endif
	  p0=p2
	  p1=(float(4*l+1)*costh*p2-float(2*l)*p1)/float(2*l+1)
 1000	  continue
	  write(lst,*)
     &	'(subr.vpots ) warning: multipole expansion not converged'
	  write(lst,*) '  c,z,h=', c,z,h
c
	  return
c
c  near zone : gauss integration
c
	else
	  zmin=0.01
	  a=1.0
	  af=0.0
	  zz=z
	  fact=1.0
	  if(z.ge.0.0.or.z.le.-hh) then
	    z1=abs(z+h)-h
	    z2=abs(z+h)+h
	    if(z.ge.0.0) then
	  ic=1
	    else
	  ic=-1
	    endif
	  else
	    z1=0.0
	    z2=z+hh
	    ic=1
	  endif
 2200	  continue
	  za=0.8
	  if(c.gt.1.0) za=c-0.2
c
	  zb=amin1(za,z2)
	  rr=(zb-z1)/za
	  if (h.lt.1.0e-4) then
	    nn=1
	  else if (rr.lt.0.125) then
	    nn=2
	  else if (rr.lt.0.25) then
	    nn=3
	  else if (rr.lt.0.5) then
	    nn=4
	  else
	    nn=5
	  endif
	  if(.not.(rr.lt.0.0.and.h.ge.1.0e-4) ) then
	    if(h.ge.1.0e-4) fact=(zb-z1)/hh
	    do 2500 n=1,nn
	    if(nn.ne.1) zz=z1+(zb-z1)*(zp(n,nn)+1.0)/2.0
	    ak2=4.0*c/((a+c)**2+zz*zz)
	    if(ak2.gt.0.125) then
c
	  dc=c
	      dz=zz
	      da=a
	      dk1=((da-dc)**2+dz**2)/((da+dc)**2+dz**2)
	      dk=dcelik(dk1)
	      de=dcelie(dk1)
	      afd=0.0
	      if(abs(a-c).lt.1.0 .and. h.ge.1.0e-4)
     &	        afd=alog(4.0/((a-c)**2+zz**2))*(1.0-abs(a-c))
	      af=af+(4.0/sqrt(abs(c*ak2))*((0.5d0+0.5d0*dk1)*dk-de)-afd)
     &	        *0.5*fact*wp(n,nn)
c
	    else
	      afd=0.0
	      if(abs(a-c).lt.1.0 .and. h.ge.1.0e-4)
     &	        afd=alog(4.0/((a-c)**2+zz**2))*(1.0-abs(a-c))
	      af=af+
     &	      (pi*c*(1.0+ak2*(c1+ak2*(c2+ak2*(c3+ak2*c4))))
     &	      /sqrt((a+c)**2+zz**2)**3-afd)*0.5*fact*wp(n,nn)
c
	    endif
 2500	    continue
	    if(abs(a-c).lt.1.0 .and. h.ge.1.0e-4)
     &	      af=af+(zb*alog(4.0/((a-c)**2+zb**2))
     &	        -z1*alog(4.0/((a-c)**2+z1**2))
     &	        +2.0*(zb-z1)
     &	        -2.0*abs(a-c)
     &	         *(atan2(zb,abs(a-c))-atan2(z1,abs(a-c)))
     &	        )*(1.0-abs(a-c))/hh
	  endif
	  if(h.lt.1.0e-4) return
c
	  zb=amax1(za,z1)
	  rr=za*(z2-zb)/(z2*zb)
	  if (rr.lt.0.0) then
	    if(abs(z+h).ge.h) return
	    if(ic.eq.-1) return
	    ic=-ic
	    z2=-z
	    go to 2200
	  endif
c
	  if (rr.lt.0.125) then
	    nn=2
	  else if (rr.lt.0.25) then
	    nn=3
	  else if (rr.lt.0.5) then
	    nn=4
	  else
	    nn=5
	  endif
c
	  rr=rr/za
	  do 2700 n=1,nn
	  zi=1.0/z2+rr*(zp(n,nn)+1.0)/2.0
	  zz=1.0/zi
	  ak2=4.0*c/((a+c)**2+zz*zz)
	  if(ak2.gt.0.125) then
c
	    dc=c
	    dz=zz
	    da=a
	    dk1=((da-dc)**2+dz**2)/((da+dc)**2+dz**2)
	    dk=dcelik(dk1)
	    de=dcelie(dk1)
	    af=af+4.0/sqrt(abs(c*ak2))*((0.5d0+0.5d0*dk1)*dk-de)
     &	      *0.5*rr*zz*zz*wp(n,nn)/hh
	  else
c
	    af=af+pi*c*(1.0+ak2*(c1+ak2*(c2+ak2*(c3+ak2*c4))))
     &	      /sqrt((a+c)**2+zz**2)**3*0.5*rr*zz*zz*wp(n,nn)/hh
	  endif
 2700	  continue
	endif
c
	end
