;  relation between latitude(al) and y-value in S and R coordinates
;  -halfpi <= al <= halfpi
;  -halfpi <= y <= halfpi

;
;  al as a function of y
;
function alofy, y

      halfpi=0.5*3.141592
      al=y

      loc = where (y ge halfpi, count)
      if count gt 0 then al(loc) = halfpi
      loc = where (y le -halfpi, count)
      if count gt 0 then al(loc) = -halfpi
      loc = where (y ge -halfpi and y lt halfpi, count)
      if count gt 0 then al(loc) =halfpi*sin(y(loc))
      return, al
end

