; make a half-size data by picking up region of strong fields

pro cuthalf,mparam,rdata, oldparam=oldparam,olddata=olddata

	xs=mparam.xs
	ys=mparam.ys
	nx=mparam.nx
	ny=mparam.ny
	dx=mparam.dx
	dy=mparam.dy

	kz = kloc(mparam,/z)
	gc = gcenter(abs(rdata(*,*,kz)))
	nxh = nx/2
	nyh = ny/2
	ixs = ( gc(0) - nxh/2 ) > 0
	iys = ( gc(1) - nyh/2 ) > 0
	ixe = ixs +nxh-1
	iye = iys +nyh-1
	xs = xs + dx*float(ixs-1)
	ys = ys + dy*float(ixs-1)

	oldparam = mparam
	olddata = rdata
	rdata = fltarr(nxh,nyh,8)

	specstr = defspecs(nspec)
	for lspec = 0, nspec-1 do begin
		k = mparam.status.(lspec)
		if ( k ge 0 ) then rdata(*,*,k) = olddata(ixs:ixe,iys:iye,k)
	endfor

	mparam.xs = xs
	mparam.ys = ys
	mparam.nx = nxh
	mparam.ny = nyh

	print,'sub-area x=',ixs,ixe,'   y=',iys,iye,' is extracted' 
	return
end
