;+
; NAME :	deflh2
; PURPOSE :
;	define field line header part-2
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	lhdr2 = deflh2()
; INPUTS :
;	none
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	lhdr2 (structure)
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;-
;------------------------------------------------------------------------
;
function deflh2
;
	str4=string(' ',format='(a4)')
	str8=string(' ',format='(a8)')
	str12=string(' ',format='(a12)')
	str16=string(' ',format='(a16)')

	lof2={lhdr2, $
		kindl:str8, $
		nbytel:str4, $
		ncomp:str4, $
		xfactor:str12, $
		bfactor:str12, $
		lfile:str8, $
		mtag:str16, $
		ltag:str16 }

	return, lof2
end
