;+
; NAME :	deflh3
; PURPOSE :
;	define field-line header part-3
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	lhdr3 = deflh3()
; INPUTS :
;	none
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
;	none
; OUTPUTS :
;	lhdr3 (structure)
; COMMON BLOCKS : 	none
; SIDE EFFECTS : 	none
; RESTRICTIONS :	none
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;-
;------------------------------------------------------------------------
;
function deflh3
;
; definition of MAGPACK2 field line header part-3
;
	lof3={lhdr3, $
		rrss:   string(' ', format='(a12)'), $
		chksum:	string(' ', format='(a12)'), $
		dummy:  string(' ',format='(a56)') }
	return, lof3
end
