pro neighbor, index, i,j,nx,ny,rgn,unsearched,level0
	level=level0+1
; print,i,j,level
	if i gt 0 and index(i-1,j) eq unsearched then begin
		index(i-1,j)=rgn
		neighbor, index,i-1,j,nx,ny,rgn,unsearched,level
	endif
	if j gt 0 and index(i,j-1) eq unsearched then begin
		index(i,j-1)=rgn
		neighbor, index,i,j-1,nx,ny,rgn,unsearched,level
	endif
	if i lt nx-1 and index(i+1,j) eq unsearched then begin
		index(i+1,j)=rgn
		neighbor, index,i+1,j,nx,ny,rgn,unsearched,level
	endif
	if j lt ny-1 and index(i,j+1) eq unsearched then begin
		index(i,j+1)=rgn
		neighbor, index,i,j+1,nx,ny,rgn,unsearched,level
	endif
;	if i gt 0 and j gt 0 and index(i-1,j-1) eq unsearched then begin
;		index(i-1,j-1)=rgn
;		neighbor, index,i-1,j-1,nx,ny,rgn,unsearched,level
;	endif
;	if i lt nx-1 and j lt ny-1 and index(i+1,j+1) eq unsearched then begin
;		index(i+1,j+1)=rgn
;		neighbor, index,i+1,j+1,nx,ny,rgn,unsearched,level
;	endif
;	if i gt 0 and j lt ny-1 and index(i-1,j+1) eq unsearched then begin
;		index(i-1,j+1)=rgn
;		neighbor, index,i-1,j+1,nx,ny,rgn,unsearched,level
;	endif
;	if i lt nx-1 and j gt 0 and index(i+1,j-1) eq unsearched then begin
;		index(i+1,j-1)=rgn
;		neighbor, index,i+1,j-1,nx,ny,rgn,unsearched,level
;	endif
	return
end

pro flipneighbor, index,isign,bx,by,i,j,nx,ny,rgn,level0
	level=level0+1
	sig0=isign(i,j)
	bx0=bx(i,j)*sig0
	by0=by(i,j)*sig0
	if i gt 0 and index(i-1,j) eq rgn and isign(i-1,j) eq 0 then begin
		if (bx(i-1,j)-bx0)^2+(by(i-1,j)-by0)^2 lt $
		   (bx(i-1,j)+bx0)^2+(by(i-1,j)+by0)^2 then $
			isign(i-1,j)=1 else isign(i-1,j)=-1
print,'i-1',i,j,bx0,by0,bx(i-1,j)*isign(i-1,j),by(i-1,j)*isign(i-1,j)
		flipneighbor, index,isign,bx,by,i-1,j,nx,ny,rgn,level
	endif
	if j gt 0 and index(i,j-1) eq rgn and isign(i,j-1) eq 0 then begin
		if (bx(i,j-1)-bx0)^2+(by(i,j-1)-by0)^2 lt $
		   (bx(i,j-1)+bx0)^2+(by(i,j-1)+by0)^2 then $
			isign(i,j-1)=1 else isign(i,j-1)=-1
print,'j-1',i,j,bx0,by0,bx(i,j-1)*isign(i,j-1),by(i,j-1)*isign(i,j-1)
		flipneighbor, index,isign,bx,by,i,j-1,nx,ny,rgn,level
	endif
	if i lt nx-1 and index(i+1,j) eq rgn and isign(i+1,j) eq 0 then begin
		if (bx(i+1,j)-bx0)^2+(by(i+1,j)-by0)^2 lt $
		   (bx(i+1,j)+bx0)^2+(by(i+1,j)+by0)^2 then $
			isign(i+1,j)=1 else isign(i+1,j)=-1
print,'i+1',i,j,bx0,by0,bx(i+1,j)*isign(i+1,j),by(i+1,j)*isign(i+1,j)
		flipneighbor, index,isign,bx,by,i+1,j,nx,ny,rgn,level
	endif
	if j lt ny-1 and index(i,j+1) eq rgn and isign(i,j+1) eq 0 then begin
		if (bx(i,j+1)-bx0)^2+(by(i,j+1)-by0)^2 lt $
		   (bx(i,j+1)+bx0)^2+(by(i,j+1)+by0)^2 then $
			isign(i,j+1)=1 else isign(i,j+1)=-1
print,'j+1',i,j,bx0,by0,bx(i,j+1)*isign(i,j+1),by(i,j+1)*isign(i,j+1)
		flipneighbor, index,isign,bx,by,i,j+1,nx,ny,rgn,level
	endif
	return
end

pro flip, index,isign,bx,by,rgncount

	sz=size(index)
	nx=sz(1)
	ny=sz(2)
	isign=0*index
	bt2 = bx*bx+by*by
	level=0
	for rgn=1,rgncount do begin
		loc = where(index eq rgn)
		dummy=max(bt2(loc),loc0)
		i = loc(loc0) mod nx
		j = loc(loc0) / ny
		isign(i,j)=1
		flipneighbor, index,isign,bx,by,i,j,nx,ny,rgn,level
	endfor
	return
end

pro floodfill, index, rgncount, counts, minmember=minmember
	if not keyword_set(minmember) then minmember=1

	border=0
	unsearched=-1
	sz=size(index)
	nx=sz(1)
	ny=sz(2)
	level=0
	rgn=0
	for j=0,ny-1 do for i=0,nx-1 do begin
		if index(i,j) eq unsearched then begin
			rgn=rgn+1
			index(i,j) = rgn
			neighbor,index,i,j,nx,ny,rgn,unsearched,level
		endif
	endfor
	rgncount = rgn
	counts = intarr(rgncount+1)

	loc = where(index eq unsearched, count)
	if count gt 0 then begin
		index(loc)=0
		print,'4-pixel search did not detect ',count,' points'
	endif

;	border pixels : index=0
;	detected regions : index=1--rgncount

	for rgn=0,rgncount do begin
		loc=where(index eq rgn, count)
		if count lt minmember and rgn ne border then begin
			index(loc)=border
			counts(rgn)=0
		endif else counts(rgn) = count
	endfor

	rgn=0
	for rgn1=1,rgncount do begin
		if counts(rgn1) gt 0 then begin
			loc=where(index eq rgn1)
			rgn=rgn+1
			index(loc)=rgn
			counts(rgn)=counts(rgn1)
		endif
	endfor
	rgncount=rgn
	counts=counts(0:rgncount)
	return
end

btlim=100.0
seed=1111L
bx=randomn(seed,10,10)*5*btlim
by=randomn(seed,10,10)*5*btlim
index=intarr(10,10)-1
;	loc=where(bx*bx + by*by lt btlim^2)
;	index(loc)=0
index=0*index
index(2:3,2:3)=-1
index(5:8,5:8)=-1
; index(6:7,6:7)=0
index(2:3,8)=-1
floodfill,index,rgncount,counts,minmember=4
flip, index,isign,bx,by,rgncount
erase
print,index,format='(10i3)'
print,isign,format='(10i3)'
plotvec, bx,by,rbtmin=0.01
plotvec,bx*isign,by*isign,rbtmin=0.01,/arrow
end
