;  relation between latitude(al) and y-value in S and R coordinates
;  -halfpi <= al <= halfpi
;  -halfpi <= y <= halfpi

;  y as a function of al

function yofal, al

      halfpi=0.5*3.141592
      y=al

      loc = where (al ge halfpi, count)
      if count gt 0 then y(loc) = halfpi
      loc = where (al le -halfpi, count)
      if count gt 0 then y(loc) = -halfpi
      loc = where (al ge -halfpi and al lt halfpi, count)
      if count gt 0 then y(loc) =asin(al(loc)/halfpi)
      return, y
end

