~s magnetic field computation 

Dear colleague,

The computation code for solar magnetic fields which I have been
developing is almost ready for distribution. The present release
is for Unix systems. The force-free field part is still under testing
and the code is not yet versatile enough for general use, but a
preliminary instruction manual is attached.

The source code in compressed tar-file is available via anonymous ftp
on spot.mtk.nao.ac.jp (IP address=133.40.5.1). The name of the file is
tar/magpack2-VSN.tar.Z, where VSN is a version number.

After you uncompress and retrieve the original source files, follow the
instructions given in the retrieved file doc/install.doc. Before you start
using the code, please read doc/credit.doc. When the code is upgraded,
a new file with the next version number will be placed at the same
location.

There might be some inconsistencies between the instructions and 
what the code actually does. Your comments are welcome in order to
improve the code and the instruction manual.

This mail is sent to those who had received the old version of the code,
and to those who have requested the new version of the code.


Sincerely,
Takashi Sakurai
National Astronomical Observatory of Japan

Distribution:
Yohkoh TeamBB 
J.Brosius jbrosius@solar.stanford.edu
E.Schmahl ed@astro.umd.edu
H.Zirin hz@sundog.caltech.edu
B.Schmieder schmieder@mesioa.obspm.fr
J.Harvey jharvey@noao.edu
A.Skumanich sku@ncar.ucar.edu
R.Willson rfwillson@solar.stanford.edu
T.Bastian tbastian@nrao.edu
R.Canfield canfield@uhifa.ifa.hawaii.edu
A.Gary gary@ssl.msfc.nasa.gov
J.Wang wjx@bao01.bao.ac.cn
B.Kliem bkliem@aip.de
A.Hofmann ahofmann@aip.de
K.Shibasaki shibasak@nro.nao.ac.jp
Y.Choi choi@nro.nao.ac.jp
V.Martinez-Pillet vmp@iac.es
Y.Yan yan@spot.mtk.nao.ac.jp
X.Zhao zhao@quake.stanford.edu
A.Cacciani cacciani@roma1.infn.it
P.Liewer pauly@spaceport.jpl.nasa.gov

