c  for a given Carrington rotation number,
c  calculate the date when Carrington longitude 180 deg
c  is at the central meridian
c
c  rotno = Carrington rotation number
c  date = 'yyyymmdd'
c  time = 'hh:00:00' (not accurate to min/sec)
c
	include 'sys.fc'
	character date*8, time*8, chr*80
	integer rotno
c
	keyin  = 5
	lst    = 6
	msg    = msgini()
	chr='0'
        if(myargc().eq.1) call myargv(1,chr)
        if(chr.eq.'1') then
          msglvl=1
        else if(chr.eq.'2') then
          msglvl=2
        else if(chr.eq.'3') then
          msglvl=3
        else
          msglvl=0
        endif
c
	write(msg,*) 'enter Carrington rotation number'
	read(keyin,*) rotno
	call carcmp(rotno, date, time)
	write(lst,*) '(proc.cardate) Carrington rotation number',rotno
	write(lst,100) 'longitude=180 deg on ', 
     &	  date(1:4),date(5:6),date(7:8),time(1:2), ' UT'
 100	format(1x,a,a4,'/',a2,'/',a2,2x,a2, a)
	stop
	end
