c  graphic interface : cgi subroutines
c
c  this program does not forlow the conventional fortran77
c  in that variable names longer than 6 characters are used
c
	subroutine dispm( iunitp, iunitl, mfname, lfname )
c
	include 'sys.fc'
	include 'ss.fc'
	include 'mdata.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'mparam.fc'
	include 'string.fc'
	include 'fileio.fc'
	include 'fline.fc'
	include 'graph.fc'
c
	parameter (NLVL=20)
c
	integer iunit, iunitp, iunitl
	dimension xf(5),yf(5),ixp(2),iyp(2),xx(3),
     &	          xxc4(3,4),xxc40(3,4)
	dimension dlp(NLVL),dlm(NLVL),blp(NLVL),blm(NLVL),
     &	          flp(NLVL),flm(NLVL),alp(NLVL),alm(NLVL),
     &	          slp(NLVL),slm(NLVL),dummy(NLVL)
	real intlvl(NLVL),jlp(NLVL),jlm(NLVL)
	dimension iovr(4),isw(NFMAX)
	dimension xp(ML),yp(ML),zp(ML),hp(ML)
	equivalence (xp(1),xyzr(1,1))
	equivalence (yp(1),xyzr(1,2))
	equivalence (zp(1),xyzr(1,3))
	equivalence (hp(1),xyzr(1,4))
c
	character esc*1, cls*10, cll*10, home*6, strid*8,keybuf*10,
     &	buf*10, dumstr*8, comma*1, str*50, commnt*80,
     &	chrh*1, chrc*1, lpbuf*50,
     &	title1*80, title2*80, title3*80, title4*80,
     &	files*80, mfname*(*), lfname*(*)
	character*5 strx,stry,strz
	dimension kxlist(MZ),kylist(MZ),kzlist(MZ),
     &	          strx(MZ),stry(MZ),strz(MZ)
c
	logical update
	logical ask,arrow,vt100,lonlat,limb,clip
	logical redraw,first,ready
	integer redmap,bluemap,whitemap,greenmap,
     &	  graylvl,cuelvl
	dimension nc(2),kc(2),arrow(2),chrc(2),nv(2),kx(2),ky(2)
c
	xconv(x)=gfact*(x-gxc) +xfc
	yconv(y)=gfact*(y-gyc) +yfc
	rad(deg)=3.141592/180.0*deg
c
	data kxlist/MZ*0/, kylist/MZ*0/, kzlist/MZ*0/
	data strx/MZ*'     '/, stry/MZ*'     '/, strz/MZ*'     '/
c
	do 10 i=1,NFMAX
 10	isw(i)=1
c
c  DEC VT100 terminal control
	esc=char(27)
	home=esc//'[1;1H'
	cls=home//esc//'[2J'
	cll=home//esc//'[2K'
	vt100=.false.
c  vt100=.true. in order to avoid scroll
cx	vt100=.true.
c
	ask= stdin.eq.keyin
	first=.true.
	comma=','
c
c  abs(lpout) : 1=portrait
	lpout=0
	if(ask) write(msg,*) 
     &	       'output mode? 0=graphics, 1=graphics+LBP, -1=LBP'
	read(stdin,*) lpout
	if(ask) write(msg,*) cls
c
c  gmode=0 : fixed view angle
c        1 : arbitrary view angle and scaling
c  (gmode=2 is also used internally)
c
	gmode=0
	if(ask) write(msg,*)
     &	'enable coordinate transform? 0=no, 1=yes'
	read(stdin,*) gmode
c
	do 20 i=1,3
 20	iovr(i)=0
	iovr(4)=2
c  default is to reset cl0deg unless mesh=4
c
	if(ask) write(msg,*) 
     &	'calculate rsp,p,b0,cl0 from calendar? 0=no, 1=yes'
	read(stdin,*) iovr
	if(tsys.ne.' '.and.dateo.ne.' '.and.stime.ne.' ') then
	  call suncal(tsys,dateo,stime,sdist,rspc,pc,b0c,cl0c,
     &	              doy,irotno)
	  if(iovr(1).eq.1) rsp=arcsec*rspc
	  if(iovr(2).eq.1 .and. pdeg.eq.ydeg) then
	    pdeg=pc
	    ydeg=pdeg
	    prad=0.0
	    ypos=0.0
	    call setdu
c  setdu uses ypos
	  endif
	  if(iovr(3).eq.1) b0deg=b0c
	  if(iovr(4).eq.1) cl0deg=cl0c
	  if(iovr(1).eq.2) rsp=arcsec*rsun
	  if(iovr(2).eq.2 .and. pdeg.eq.ydeg) then
	    pdeg=0.0
	    ydeg=0.0
	    prad=0.0
	    ypos=0.0
	    call setdu
	  endif
	  if(iovr(3).eq.2) b0deg=0.0
	  if(iovr(4).eq.2 .and. mesh.ne.4) cl0deg=0.0
	  cl0=rad(cl0deg)
	  if(mesh.eq.4) then
	    cl0eff=cl0
	  else
	    cl0eff=0.0
	  endif
	endif
c
c  sizecm=x-width of screen in cm
c  default sizecm = 16cm, resolution unit=0.01cm
c  scale is the scaling factor, cm / unit length(=10^4 km)
c  if scale =0, observed region is scaled to fill the display window
c
	sizecm=16.0
	scale=0.0
	if(ask) write(msg,*) 'enter display size (cm) and scale factor'
	read(stdin,*) sizecm,scale
c
c  current version number of input file
	iver0 = 2
c  check version number
	read(iunitp,*) strid,iver1
	call upper(strid)
	if(strid.ne.'PSETUP') then
	  write(msg,*) 
     &	  '(subr.dispm ) error: this is not the psetup file'
	  errflg=2
	  return
	endif
	if(iver1.ne.iver0) then
	  write(msg,*)
     &	  '(subr.dispm ) error: version of psetup should be',
     &	  iver0
	  errflg=2
	  return
	endif
c
c  y-offset in cm = yoffcm
c  line separation in cm = vmicm
c  character size in cm = chrcm
c  eye distance = eyed
c  mesh separation in cm in plotting arrows = asepcm
c
	yoffcm=4.0
	chrcm = 0.35
	clip=.false.
	asepcm=0.4
c  order of input changed on 2000/10/09 to lpname,lpdev
	read(iunitp,*) lpname, lpdev
c  take care for old format
	if(lpname(1:1).eq.'/') then
	  lpbuf=lpname
	  lpname=lpdev
	  lpdev=lpbuf
	endif
	read(iunitp,*) meshl, yoffcm, vmicm, chrcm
	read(iunitp,*) eyed,clip
	read(iunitp,*) asepcm
	devcm=100.0
	xsize = devcm*sizecm
	yoff = yoffcm*devcm
	ysize = xsize + yoff
	yfsize = xsize
	vmi = vmicm*devcm
	chrsiz = chrcm*devcm
	arrsep = asepcm*devcm
c
	write(title1,400) inst,dateo,stime,etime,tsys,mfile
 400	format(a8,2x,a8,1x,a8,' - ',a8,'(',a6,')',2x,a8,24x)
c
c  read parameters for plotting from iunitp
c  contour levels should be from the smallest to the largest values in
c  order to detect level over(under)flows
c  if number of levels are <0, automatic level adjustment will be made
c
	rblmin=0.01
	nbl=-5
	read(iunitp,*) rblmin,nbl,blp
	do 30 i=1,NLVL
 30	blm(i)=-blp(i)
	rdmin=0.01
	ndl=-5
	read(iunitp,*) rdmin,ndl,dlp
	do 31 i=1,NLVL
 31	dlm(i)=-dlp(i)
	rimin=0.3
	nint=-5
	read(iunitp,*) rimin,nint,intlvl
c  intensity is normalized to nearly 1
	rjmin=0.01
	njl=-5
	read(iunitp,*) rjmin,njl,jlp
	do 32 i=1,NLVL
 32	jlm(i)=-jlp(i)
	rfmin=0.01
	nfl=-5
	read(iunitp,*) rfmin,nfl,flp
	do 33 i=1,NLVL
 33	flm(i)=-flp(i)
	ramin=0.01
	nal=-5
	read(iunitp,*) ramin,nal,alp
	do 34 i=1,NLVL
 34	alm(i)=-alp(i)
	rsmin=0.01
	nsl=-5
	read(iunitp,*) rsmin,nsl,slp
	do 35 i=1,NLVL
 35	slm(i)=-slp(i)
	btmax0=1000.0
	rbtmin=0.1
	read(iunitp,*) btmax0,rbtmin
	btmin0=btmax0*abs(rbtmin)
c
c  if rbtmin<0, bars displayed will be for btmin<bt<btmax
c  where btmax(min) are max(min) values of the data bt
c  if rbtmin>0, bars displayed are for btmin0<bt<btmax0
c
c  number of gray levels, line width
	graylvl=64
	cuelvl=16
	fwidth=2.0
	read(iunitp,*) graylvl,cuelvl,fwidth
c
c  parameters for depth cuing of field lines
	hmax0=20.0
	rcue=0.5
	read(iunitp,*) hmax0,rcue
c
c  initialize display
c
	call initialize(lpout)
c
	call vdcextent(0,0,int(xsize),int(ysize) )
	call viewportunits(1)
c*	NEWS 1720
c*	call viewport(200,400+int(ysize),200+int(xsize),400)
c*	NEWS 3460
	call viewport(0,int(ysize),int(xsize),0)
c
c  line width
	call linefwidth(1.0)
c  interiostyle 2=solid
	call interiorstyle(2)
c  markertype 2=dot
	call markertype(2)
c  character height in vdc space, unit = 0.01 cm
	call chrheight(int(chrsiz))
c  character width/height ratio
	call chrwidth(1.0)
c  normal spacing = 0
cx	call chrspacing(0.05)
c
c  set color table
c  background is assumed to be black
c  white is color No.1 (default foreground color)
	call colortable(white, 1, 255,255,255)
	call colortable(red,   1, 255,128,  0)
	call colortable(green, 1,   0,255,  0)
	call colortable(blue,  1,   0,128,255)
	call colortable(yellow,1, 255,255,  0)
	call colortable(pink,  1, 255,  0,255)
	call colortable(cyan,  1,   0,255,255)
	call colortable(black, 1,   0,  0,  0)
	redmap=8
	n=redmap
	mult=256/graylvl
	do 40 i=1,graylvl
	call colortable(n,1,mult*(i-1),0,0)
 40	n=n+1
	bluemap=n
	do 41 i=1,graylvl
	call colortable(n,1,0,0,mult*(i-1))
 41	n=n+1
	whitemap=n
	do 42 i=1,graylvl
	call colortable(n,1,mult*(i-1),mult*(i-1),mult*(i-1))
 42	n=n+1
	greenmap=n
	multg=256/cuelvl
	do 43 i=1,cuelvl
	call colortable(n,1,0,multg*(i-1),0)
 43	n=n+1
c
c  obtain data list
c  nxy=number of vector data
c  nz =number of scalar data
c
	call mklist(nxy,nz,kxlist,kylist,kzlist,strx,stry,strz)
	if(msglvl.gt.2) then
	  write(lst,*) '(subr.dispm ) mklist:'
	  write(lst,*) '  nxy,nz=',nxy,nz
	  write(lst,*) '  kxlist=',kxlist
	  write(lst,*) '  kylist=',kylist
	  write(lst,*) '  kylist=',kylist
	  write(lst,*) '  strx=',strx
	  write(lst,*) '  stry=',stry
	  write(lst,*) '  strz=',strz
	endif
c
c  meshl specifies initial projection mode
c  default value of meshl = 2 (by subr.initc)
c  if fieldline file is avaiable, meshl is overridden by kindli
c 
	mlof0=0
	if(iunitl.gt.0) then
	  mlof0=1
	  update=.true.
	  chksm1=chksum
c  chksm1 is the check sum of s1data which has been read
c  in the main program
	  call readlh(iunitl,update)
	  meshl=mod(kindli,10)
	  if(ftag.ne.mtag) then
	    write(lst,*) '(subr.dispm ) warning: ftag .ne. mtag'
	    write(lst,*) '  ftag=',ftag
	    write(lst,*) '  mtag=',mtag
	  endif
	  if(ns1.gt.0 .and. (chksum.ne.chksm1)) then
	    write(lst,*)
     &   '(subr.dispm ) warning: mismatch in checksum of s1data'
	  endif
c
	else
	  mlof0=0
	endif
c
	mesho=0
	if(mesh.eq.-1) mesh=0
	if(gmode.eq.0) then
	  if(mesh.ge.1.and.mesh.le.4 .and.
     &	     meshl.ge.0.and.meshl.le.4) then
	    call transm(kindm,mesh, kindm,mesho)
	    if(msglvl.gt.1) write(lst,*)
     &	                 '(subr.dispm ) subr.transm called'
	  endif
c  if meshl<0, transm is not called.
c  this feature can be used to plot contours of data
c  as if they were in 2-D cartesian 
c  since meshl is overwritten by kindl, meshl<0 can result
c  only when field line file is not read
c
	else
	  if(mesh.eq.1.and.meshl.gt.1 .or.
     &	     mesh.gt.1.and.(meshl.eq.0.or.meshl.eq.1)) then
	    call transm(kindm,mesh, kindm,meshl)
	    if(msglvl.gt.1) write(lst,*)
     &	                 '(subr.dispm ) subr.transm called'
	  else if(meshl.lt.0) then
	    write(msg,*) 'error: gmode=1 and meshl<0',meshl
	    errflg=2
	    return
	  endif
	endif
c
	rotdeg=0.0
	zdeg=0.0
	xdeg=0.0
	dxc1=0.0
	dyc1=0.0
c
	dx0=dx
	dy0=dy
c  dx0 and dy0 are physical lengths, while dx and dy may be
c  spherical coordinates
c
	if(nx.eq.0.and.ny.eq.0) then
c  reads1 sets dx=xe-xs, dy=ye-ys in cartesian coord.
	  dxy=min(abs(dx),abs(dy))/100.0
	  dxy0=dxy
	else
	  if(mesh.le.1 .or. meshl.lt.0) then
	    dxy=min(abs(dx),abs(dy))
	    dxy0=dxy
	  else if(mesh.ge.2.and.meshl.ge.0) then
	    dx0=dx*rsp
	    dy0=alofy(dy)*rsp
	    dxy0=min(abs(dx0),abs(dy0))
	    dxy=min(abs(dx),abs(alofy(dy)))
	  endif
	  dxy0=max(1.0,float(min(nx,ny))/50.0)*dxy0/3.0
	  dxy =max(1.0,float(min(nx,ny))/50.0)*dxy/3.0
	endif
c
c  four corners of observed region
c
	xf(1)=xs
	yf(1)=ys
	xf(2)=xs+dx*float(max(1,nx-1))
	yf(2)=yf(1)
	xf(3)=xf(2)
	yf(3)=ys+dy*float(max(1,ny-1))
	xf(4)=xf(1)
	yf(4)=yf(3)
	xf(5)=xf(1)
	yf(5)=yf(1)
c  xf and yf are in D-coordinates if mesh=0
c
	if(meshl.lt.0) then
	  do 50 n=1,4
	  xxc4(1,n)=xf(n)
	  xxc4(2,n)=yf(n)
 	  xxc4(3,n)=0.0
 50	  continue
	else if(mesh.eq.0) then
	  do 51 n=1,4
	  call dtoc2(xf(n),yf(n), xxc4(1,n),xxc4(2,n))
	  call projsr(xxc4(1,n), rsp)
 51	  continue
        else if(mesh.eq.1) then
	  do 52 n=1,4
          xxc4(1,n)=xf(n)
          xxc4(2,n)=yf(n)
          xxc4(3,n)=0.0
          call ttoc(xxc4(1,n),xxc4(1,n))
 52	  continue
	else if(mesh.ge.2.and.meshl.ge.0) then
	  call transf(mesh,mesho,
     &	              nx, ny, xs, ys, dx, dy,
     &	              nx1,ny1,xs1,ys1,dx1,dy1,xe1,ye1)
	  xxc4(1,1)=xs1
	  xxc4(2,1)=ys1
	  xxc4(1,2)=xe1
	  xxc4(2,2)=xxc4(2,1)
	  xxc4(1,3)=xxc4(1,2)
	  xxc4(2,3)=ye1
	  xxc4(1,4)=xxc4(1,1)
	  xxc4(2,4)=xxc4(2,3)
	  do 53 n=1,4
	  call dtoc2(xxc4(1,n),xxc4(2,n), xxc4(1,n),xxc4(2,n))
	  call projsr(xxc4(1,n), rsp)
 53	  continue
	endif
	do 54 n=1,4
	do 54 i=1,3
 54	xxc40(i,n)=xxc4(i,n)
c
c  xxc4 are in C-coordinates
c
c  drawable area
c  (xfl,xfr) = lower left corner
c  (yfl,yfr) = upper right corner
c  (xfc,yfc) = center of window
c
c  clipping window
c  (xclipl,yclipb) = lower left corner
c  (xclipr,yclipt) = upper right corner
c
	xfl=0.0
	xfr=xsize
	yfl=0.0
	yfr=yfsize
	xfc=0.5*(xfl+xfr)
	yfc=0.5*(yfl+yfr)
	gxc = 0.25*(xxc4(1,1)+xxc4(1,2)+xxc4(1,3)+xxc4(1,4))
	gyc = 0.25*(xxc4(2,1)+xxc4(2,2)+xxc4(2,3)+xxc4(2,4))
c
	if(scale.gt.0.0) then
	  gfact=devcm*scale
	  scale1=scale
	else
	  gfact = min( xsize / (abs(xxc4(1,2)-xxc4(1,1))
     &	                 + abs(xxc4(1,4)-xxc4(1,1)) ),
     &	         yfsize / (abs(xxc4(2,2)-xxc4(2,1))
     &	                 + abs(xxc4(2,4)-xxc4(2,1)) ) )
	  scale1=gfact/devcm
	endif
c
	xclipl = gfact*(min(xxc4(1,1),xxc4(1,4)) -gxc) +xfc
	xclipr = gfact*(max(xxc4(1,2),xxc4(1,3)) -gxc) +xfc
	yclipb = gfact*(min(xxc4(2,1),xxc4(2,2)) -gyc) +yfc
	yclipt = gfact*(max(xxc4(2,3),xxc4(2,4)) -gyc) +yfc
c
	if(msglvl.gt.2) then 
	  write(lst,*) 'mesh,meshl=',mesh,meshl
	  write(lst,*) 'xxc4(1)=',(xxc4(m,1),m=1,3)
	  write(lst,*) 'xxc4(2)=',(xxc4(m,2),m=1,3)
	  write(lst,*) 'xxc4(3)=',(xxc4(m,3),m=1,3)
	  write(lst,*) 'xxc4(4)=',(xxc4(m,4),m=1,3)
	  write(lst,*) 'gxc,gyc=',gxc,gyc
	endif
c
	mauto=0
	if(ask) then
	  if(vt100) write(msg,*) cls
	  write(msg,100)
     &'select 0(manual), 1(standard-sequence), or 2(local-sequence) : '
 100	  format(2x, a,$)
	endif
	read(stdin,*) mauto
	if(mauto.eq.1) then
	  iunit=iunitp
	  ask=.false.
	elseif(mauto.eq.2) then
	  iunit=stdin
	  ask=.false.
	else
	  iunit=keyin
	  ask=.true.
	endif
c
	iredrw=0
	keybuf=' '
	buf=' '
	iptr=0
 1	continue
	if(redraw()) go to 1
c
	mlof=0
	mregn=0
	mfram=0
	mglobe=0
	mi=0
	kc(1)=0
	kc(2)=0
	kh=0
	kx(1)=0
	ky(1)=0
	kx(2)=0
	ky(2)=0
	title2=' '
	title3=' '
	title4=' '
	commnt=' '
	isp=1
c
c  rotation angle and view angles
c
	if(gmode.eq.1) then
	  if(vt100) write(msg,100) cls
	  write(msg,100)
     &	  'enter rotation and view angles (rotr,rotz,rotx) '
	endif
 91	if(gmode.eq.1 .or. .not.ask)
     &	  read(iunit,*,end=97) rotdeg, zdeg,xdeg
	if(gmode.eq.1 .and. .not.ask) 
     &	write(msg,*) rotdeg,zdeg,xdeg
c  if eof, try keyin
	if(gmode.eq.1) then
	  if(vt100) write(msg,100) cls
c  the unit of dxc1 and dyc1 is ulen (=10^4 km)
	  write(msg,100)
     &	  'enter scale factor(=0.0 for reset), offset (dx,dy) '
	endif
	if(gmode.eq.1 .or. .not.ask)
     &	  read(iunit,*,end=99) scale,dxc1,dyc1
	if(gmode.eq.1 .and. .not.ask) 
     &	write(msg,*) scale,dxc1,dyc1
c
	if(gmode.eq.1) then
	  if(rotdeg.ne.0.0 .or. zdeg.ne.0.0 .or. 
     &	     xdeg.ne.0.0 .or. scale.ne.0.0) then
	    clip=.false.
	  else
cx	    clip=.true.
	    clip=clip
	  endif
c
	  call setmat(rotdeg, zdeg,xdeg)
	  do 55 n=1,4
 55	  call rotpt(xxc40(1,n),xxc4(1,n))
	  gxc = 0.25*(xxc4(1,1)+xxc4(1,2)+xxc4(1,3)+xxc4(1,4))
     &	      -dxc1
	  gyc = 0.25*(xxc4(2,1)+xxc4(2,2)+xxc4(2,3)+xxc4(2,4))
     &	      -dyc1
c
	  if(scale.gt.0.0) then
	    gfact=devcm*scale
	    scale1=scale
	  else
	    gfact = min( xsize / (abs(xxc4(1,2)-xxc4(1,1))
     &	                   + abs(xxc4(1,4)-xxc4(1,1)) ),
     &	           yfsize / (abs(xxc4(2,2)-xxc4(2,1))
     &	                   + abs(xxc4(2,4)-xxc4(2,1)) ) )
	    if(scale.lt.0.0) gfact=gfact*abs(scale)
	    scale1=gfact/devcm
	  endif
	endif
c
	if(gmode.eq.0) then
	  write(title4,300) scale1
	else
	  write(title4,310) rotdeg,zdeg,xdeg,scale1
	endif
 300	format('SCALE FACTOR=',f8.4)
 310	format('ROTR=',f6.1,4x,'(ROTZ,ROTX)=',2f6.1,4x,
     &	  'SCALE FACTOR=',f8.4)
c
c  selection of items to be displayed
c
c  location of observed region
c
	ki=kiloc()
	if(meshl.ge.0) then
	  if(vt100) write(msg,100) cls
	  write(msg,100)
     &	       'location of observed area : 0=skip, 1=plot '
	endif
c
	if(.not.ask .or. meshl.ge.0) read(iunit,*,end=99) mregn
	if(meshl.lt.0) mregn=0
	if(.not.ask .and. meshl.ge.0) write(msg,*) mregn
 4	if(meshl.ge.0) then
	  if(mregn.eq.1) then
 3	    call dispr(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	         title1,rsp,pdeg,b0deg,cl0deg,
     &	         ki,xxc4,
     &	         white,yellow)
c  the index ki rather than the data array rdata(*,*,ki) is passed to
c  dispr because ki might be 0
c
	    call text(int(xfl), int(ysize-5.0*vmi), title4(1:40) )
c  print title4(1:40), which does not include scale factor
	    if(redraw()) go to 3
	    go to 9100
	  endif
	endif
c
c  halftone map
c
	if(nz.gt.0) then
	  if(vt100) write(msg,100) cls
	  write(msg,110)
     &	  'halftone map : 0=skip', (comma,n,strz(n),n=1,nz)
 110    format(2x, a,5(a1,i2,'=',a5, $))
	endif
	nh=0
	chrh=' '
	if(.not.ask .or. nz.gt.0) read(iunit,*,end=99) nh
	if(nz.eq.0) nh=0
	if(.not.ask .and. nz.gt.0) write(msg,*) nh
	if(nh.gt.0 .and. nh.le.nz) then
	  kh=kzlist(nh)
	  chrh=strz(nh)(1:1)
	endif
c
c  contour map
c
	if(nz.gt.0) then
	  if(vt100) write(msg,100) cls
	  write(msg,110)
     &	  'contour map : 0=skip', (comma,n,strz(n),n=1,nz)
	endif
	nc(1)=0
	nc(2)=0
	chrc(1)=' '
	chrc(2)=' '
	if(.not.ask .or. nz.gt.0) read(iunit,'(a)',end=99) buf
	if(nz.eq.0) buf=' '
	if(.not.ask .and. nz.gt.0) write(msg,'(a)') buf
	buf=buf(1:9)//'/'
	read(buf,*) nc(1),nc(2)
	if(nc(1).gt.0 .and. nc(1).le.nz) then
	  kc(1)=kzlist(nc(1))
	  chrc(1)=strz(nc(1))(1:1)
	endif
	if(nc(2).gt.0 .and. nc(2).le.nz) then
	  kc(2)=kzlist(nc(2))
	  chrc(2)=strz(nc(2))(1:1)
	endif
c
c  vector map
c
	if(nxy.gt.0) then
	  if(vt100) write(msg,100) cls
	  write(msg,120) 'vector map : 0=skip',
     &	    (comma,n,strx(n),stry(n),n=1,nxy)
 120  format(2x, a,5(a1,i2,'=(',a5,',',a5,') ', $))
	endif
	nv(1)=0
	nv(2)=0
	arrow(1)=.true.
	arrow(2)=.true.
	if(.not.ask .or. nxy.gt.0) read(iunit,'(a)',end=99) buf
	if(nxy.eq.0) buf=' '
	if(.not.ask .and. nxy.gt.0) write(msg,'(a)') buf
	buf=buf(1:9)//'/'
	read(buf,*) nv(1),nv(2)
	if(nv(1).lt.0) then
	  nv(1)=-nv(1)
	  arrow(1)=.false.
	endif
	if(nv(1).gt.0 .and. nv(1).le.nxy) then
	  kx(1)=kxlist(nv(1))
	  ky(1)=kylist(nv(1))
	endif
	if(nv(2).lt.0) then
	  nv(2)=-nv(2)
	  arrow(2)=.false.
	endif
	if(nv(2).gt.0 .and. nv(2).le.nxy) then
	  kx(2)=kxlist(nv(2))
	  ky(2)=kylist(nv(2))
	endif
c
c  intensity in dots
c
	if(ki.gt.0) then
	  if(vt100) write(msg,100) cls
	  write(msg,100) 'intensity in dots: 0=skip, 1=plot '
	endif
	if(.not.ask .or. ki.gt.0) read(iunit,*,end=99) mi
	if(ki.le.0) mi=0
	if(.not.ask .and. ki.gt.0) write(msg,*) mi
c
c  longitude/latitude circles
c
	if(meshl.ge.0) then
	  if(vt100) write(msg,100) cls
	  write(msg,100) 'longitude/latitude circles: 0=skip, 1=plot '
	endif
	if(.not.ask .or. meshl.ge.0) read(iunit,*,end=99) mglobe
	if(meshl.lt.0) mglobe=0
	if(.not.ask .and. meshl.ge.0) write(msg,*) mglobe
c
c  border of observed region
c
	if(vt100) write(msg,100) cls
	write(msg,100) 'border of observed region: 0=skip, 1=plot '
	read(iunit,*,end=99) mfram
	if(.not.ask) write(msg,*) mfram
c
c  field lines
c
	if(mlof0.eq.1) then
	  if(vt100) write(msg,100) cls
	  write(msg,100)
     &	'field lines : 0=skip, 1=plot all, 2=closed, 3=open '
	endif
	if(.not.ask .or. mlof0.gt.0) read(iunit,*,end=99) mlof
	if(mlof0.eq.0) mlof=0
	if(.not.ask .and. mlof0.gt.0) write(msg,*) mlof
c  secret command!
	if(mlof.gt.3) then
	  if(mlof0.eq.1) then
	    if(vt100) write(msg,100) cls
	    write(msg,100)
     &	   'enter isw (0=skip, line thickness>0, line numbers<0) '
	  if(.not.ask .or. mlof0.gt.0) read(iunit,*,end=99) isw
	  endif
	endif
c
c  beginning of drawing
c
 2	continue
c
c  scale indicator (longer than 3mm, shorter than 30mm)
c
	if(meshl.lt.0) go to 2000
	ixp(1)=xfr-2.0*devcm
	iyp(1)=yfr+0.5*devcm
	gauge=gfact/devcm*(rsp*1.0e9)/(rsun*ulen)
	call textcolor(white,0,0)
	if(gauge.lt.0.3) then
	  gauge=10.0*gauge
	  call text(ixp(1),iyp(1),'10**5 KM')
	else if (gauge.gt.3.0) then
	  gauge=gauge/10.0
	  call text(ixp(1),iyp(1),'10**3 KM')
	else
	  call text(ixp(1),iyp(1),'10**4 KM')
	endif
	call linecolor(white,0,0)
	call linefwidth(2.0)
	ixp(1)=ixp(1)-int(0.2*devcm)
	iyp(1)=iyp(1)
	ixp(2)=ixp(1)-int(gauge*devcm)
	iyp(2)=iyp(1)
	call polyline(2,ixp,iyp)
	ixp(2)=ixp(1)
	iyp(2)=iyp(1)+int(0.1*devcm)
	iyp(1)=iyp(1)-int(0.1*devcm)
	call polyline(2,ixp,iyp)
	ixp(1)=ixp(1)-int(gauge*devcm)
	ixp(2)=ixp(1)
	call polyline(2,ixp,iyp)
	call linefwidth(1.0)
c
c  half-tone map
c
 2000	if(kh.le.0) go to 3000
	valmax=framax(rdata(1,1,kh),nx,ny,MX)
	if(chrh.eq.'V') then
	  rmin=rdmin
	  valmin=rmin*valmax
	  call disphalftone(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &		MX,rdata(1,1,kh),valmin,valmax,bluemap,redmap,
     &		graylvl)
	else if(chrh.eq.'I') then
	  rmin=rimin
	  valmin=rmin*valmax
	  call disphalftone(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &		MX,rdata(1,1,kh),valmin,valmax,whitemap,bluemap,
     &		graylvl)
	else if(chrh.eq.'B') then
	  rmin=rblmin
	  valmin=rmin*valmax
	  call disphalftone(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &		MX,rdata(1,1,kh),valmin,valmax,redmap,bluemap,
     &		graylvl)
	else if(chrh.eq.'J') then
	  rmin=rjmin
	  valmin=rmin*valmax
	  call disphalftone(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &		MX,rdata(1,1,kh),valmin,valmax,redmap,bluemap,
     &		graylvl)
	else if(chrh.eq.'F') then
	  rmin=rfmin
	  valmin=rmin*valmax
	  call disphalftone(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &		MX,rdata(1,1,kh),valmin,valmax,redmap,bluemap,
     &		graylvl)
	else if(chrh.eq.'A') then
	  rmin=ramin
	  valmin=rmin*valmax
	  call disphalftone(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &		MX,rdata(1,1,kh),valmin,valmax,redmap,bluemap,
     &		graylvl)
	else
	  rmin=rsmin
	  valmin=rmin*valmax
	  call disphalftone(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &		MX,rdata(1,1,kh),valmin,valmax,whitemap,bluemap,
     &		graylvl)
	endif
	imin=100.0*rmin
	write(title3(isp:),220) strz(nh),imin
 220	format('HALFTONE:',a5,'  PEAK TO ',i2,'%')
	isp=isp+30
c
c  intensity in dots
c
 3000 if(mi.ne.1.or.ki.le.0) go to 3500
	call fillcolor(yellow,0,0)
	call markercolor(yellow,0,0)
	call linecolor(yellow,0,0)
	call dispdot(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	     MX,rdata(1,1,ki),intlvl)
c
c  solar limb and longitude/latitude circles
c
 3500	if(mglobe.eq.1) then
	  lonlat=.true.
	else
	  lonlat=.false.
	endif
	limb=meshl.ne.0
	call linecolor(yellow,0,0)
	call sphere(xxsp,rsp,cl0eff,xxc4,dxy0,lonlat,limb,clip)
c  if limb=T, solar limb is drawn
c  if clip=T, long./lat. circles are only drawn inside the
c  observed region
c
c  contour plot
c
 4000	if(kc(1).eq.0) go to 5000
	if(kc(2).eq.0) then
	  ncc=1
	else
	  ncc=2
	endif
c
	do 4900 ic=1,ncc
	call linefwidth(1.0)
	nodot=0
	mkdot=1
c  dotted lines are generated in subr.cntr2, without using
c  linetype(dotted)
	call linetype(solid)
	if(chrc(ic).eq.'I') then
	  call linecolor(yellow,0,0)
	  call lvl125(nx,ny,MX,rdata(1,1,kc(ic)),nint,intlvl,dummy,str)
	  nlevel=iabs(nint)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,intlvl,nodot,dxy,idata4)
c
	else if(chrc(ic).eq.'V') then
	  if(ic.eq.1) then
	    call linecolor(blue,0,0)
	  else
	    call linecolor(cyan,0,0)
	  endif
	  call lvl125(nx,ny,MX,rdata(1,1,kc(ic)),ndl,dlp,dlm,str)
	  nlevel=iabs(ndl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,dlp,nodot,dxy,idata4)
	  if(ic.eq.1) then
	    call linecolor(red,0,0)
	  else
	    call linecolor(pink,0,0)
	  endif
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,dlm,mkdot,dxy,idata4)
c
	else if(chrc(ic).eq.'B') then
	  if(ic.eq.1) then
	    call linecolor(red,0,0)
	  else
	    call linecolor(pink,0,0)
	  endif
	  call lvl125(nx,ny,MX,rdata(1,1,kc(ic)),nbl,blp,blm,str)
	  nlevel=iabs(nbl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,blp,nodot,dxy,idata4)
	  if(ic.eq.1) then
	    call linecolor(blue,0,0)
	  else
	    call linecolor(cyan,0,0)
	  endif
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,blm,mkdot,dxy,idata4)
c
	else if(chrc(ic).eq.'J') then
	  if(ic.eq.1) then
	    call linecolor(red,0,0)
	  else
	    call linecolor(pink,0,0)
	  endif
	  call lvl125(nx,ny,MX,rdata(1,1,kc(ic)),njl,jlp,jlm,str)
	  nlevel=iabs(njl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,jlp,nodot,dxy,idata4)
	  if(ic.eq.1) then
	    call linecolor(blue,0,0)
	  else
	    call linecolor(cyan,0,0)
	  endif
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,jlm,mkdot,dxy,idata4)
c
	else if(chrc(ic).eq.'F') then
	  if(ic.eq.1) then
	    call linecolor(red,0,0)
	  else
	    call linecolor(pink,0,0)
	  endif
	  call lvl125(nx,ny,MX,rdata(1,1,kc(ic)),nfl,flp,flm,str)
	  nlevel=iabs(nfl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,flp,nodot,dxy,idata4)
	  if(ic.eq.1) then
	    call linecolor(blue,0,0)
	  else
	    call linecolor(cyan,0,0)
	  endif
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,flm,mkdot,dxy,idata4)
c
	else if(chrc(ic).eq.'A') then
	  if(ic.eq.1) then
	    call linecolor(red,0,0)
	  else
	    call linecolor(pink,0,0)
	  endif
	  call lvl125(nx,ny,MX,rdata(1,1,kc(ic)),nal,alp,alm,str)
	  nlevel=iabs(nal)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,alp,nodot,dxy,idata4)
	  if(ic.eq.1) then
	    call linecolor(blue,0,0)
	  else
	    call linecolor(cyan,0,0)
	  endif
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,alm,mkdot,dxy,idata4)
c
	else
	  if(ic.eq.1) then
	    call linecolor(red,0,0)
	  else
	    call linecolor(pink,0,0)
	  endif
	  call lvl125(nx,ny,MX,rdata(1,1,kc(ic)),nsl,slp,dummy,str)
	  nlevel=iabs(nsl)
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,slp,nodot,dxy,idata4)
	  if(ic.eq.1) then
	    call linecolor(blue,0,0)
	  else
	    call linecolor(cyan,0,0)
	  endif
	  call cntr2(nx,ny,xs,ys,dx,dy,MX,rdata(1,1,kc(ic)),
     &	       nlevel,slm,mkdot,dxy,idata4)
c
	endif
c
	if(ic.eq.1) then
	  write(title2,200) strz(nc(1))
 200	  format('CONTOURS:', a5, '  LEVELS=')
	  title2(25:)=str
	else
	  write(title2(60:),230) strz(nc(2))
 230	  format('OVERLAY:',a5)
	  write(commnt,240) str
 240	  format('OVERLAY LEVELS=',a)
	  call text(int(xfl), int(ysize-6.0*vmi), commnt)
	endif
 4900	continue
c
c
c  transverse field -- line segments
c
 5000	if(kx(1).eq.0.or.ky(1).eq.0) go to 6000
	if(kx(2).eq.0.or.ky(2).eq.0) then
	  ntt=1
	else
	  ntt=2
	endif
c
	do 5900 it=1,ntt
	if(rbtmin.gt.0.0) then
	  btmax=btmax0
	  btmin=btmin0
	else
	  btmax=0.0
	  do 5100 i=1,nx
	  do 5100 j=1,ny
	  bt=sqrt(rdata(i,j,kx(it))**2+rdata(i,j,ky(it))**2)
	  if(bt.gt.btmax) btmax=bt
 5100	  continue
	  btmin=btmax*abs(rbtmin)
	endif
	call linecolor(white,0,0)
	call fillcolor(white,0,0)
c
c  set arrow=true for vectorized data
	arrow(it)=arrow(it).and.mod(kindm,10).gt.2
	if(.not.arrow(it)) call linefwidth(2.0)
	if(mod(kindm,10).eq.6 .and. kx(it).ne.kxploc())
     &	  arrow(it)=.false.
	call dispbar(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	             kx(it),ky(it),kz,
     &	             btmin,btmax,arrow(it),arrsep)
c  kz may be 0, so that indices rather than rdata(*,*,kz) etc are passed
c
	write(title3(isp:),250) strx(nv(it)),stry(nv(it)),btmax,btmin
 250	format('VECTORS:',2a5,'MAX,MIN=',2f5.0)
	isp=isp+40
c
 5900	continue
c
c  frame
c
c  arguments of pline2 should be D-coordinates
 6000	if(mfram.ne.1) go to 6500
	call linefwidth(1.0)
	call linecolor(white,0,0)
	if(gmode.eq.0) then
	  call pline2(5, xf,yf)
	else
	  do 6100 n=1,4
	  alen=sqrt( (xf(n+1)-xf(n))**2
     &	           + (yf(n+1)-yf(n))**2 )
	  np=min(int(alen/dxy),ML)
	  do 6200 ip=1,np
	  xp(ip)=xf(n)+(xf(n+1)-xf(n))*float(ip-1)/float(np-1)
	  yp(ip)=yf(n)+(yf(n+1)-yf(n))*float(ip-1)/float(np-1)
 6200	  continue
 6100	  call pline2(np, xp,yp)
	endif
c
c  title
c
 6500	continue
	call textcolor(white,0,0)
	ipos=lenstr(mfname)
	if(iunitl.gt.0) then
	  files='FILES='//mfname(1:ipos+1)//lfname
	else
	  files='FILES='//mfname(1:ipos+1)
	endif
	call text(int(xfl), int(ysize-1.0*vmi), files )
	call text(int(xfl), int(ysize-2.0*vmi), title1)
	call text(int(xfl), int(ysize-3.0*vmi), title2)
	call text(int(xfl), int(ysize-4.0*vmi), title3)
	call text(int(xfl), int(ysize-5.0*vmi), title4)
c
c  field lines
c
	msav=msglvl
	if(.not.first .and. msglvl.lt.2) msglvl=0
	if(mlof0.eq.0 .or. mlof.eq.0) go to 9000
	call linefwidth(fwidth)
	update=.false.
	call readlh(iunitl,update)
	first=.false.
	ic=0
c
 1100	continue
	ic=ic+1
	call readl(iunitl,np,xyzp)
	if(np.eq.0) go to 9000
	if(isw(ic).eq.0) go to 1100
	if(isw(ic).ge.1) call linefwidth(fwidth*float(isw(ic)))
c
	hmax=0.0
	eps=0.005*rsp
	do 1200 n=1,np
	xp(n)=xyzp(1,n)
	yp(n)=xyzp(2,n)
	zp(n)=xyzp(3,n)
	hp(n)=height(xyzp(1,n),meshl)
	hmax=max(hmax,hp(n))
 1200	continue
c
	if(mod(mlof,10).eq.2 .and.
     &	  (hp(1).gt.eps .or. hp(np).gt.eps) ) go to 1100
	if(mod(mlof,10).eq.3 .and.
     &	  hp(1).lt.eps .and. hp(np).lt.eps) go to 1100
	if(isw(ic).lt.0) then
	  if(isw(ic).eq.-1) n=1
	  if(isw(ic).eq.-2) n=np/2
	  if(isw(ic).eq.-3) n=np
	  xx(1)=xp(n)
	  xx(2)=yp(n)
	  xx(3)=zp(n)
	  if(gmode.eq.1) call rotpt(xx,xx)
	  if(gmode.eq.2) call pers(xx,xx)
	  ixp(1)=xconv(xx(1))
	  iyp(1)=yconv(xx(2))
	  call textcolor(white,0,0)
	  write(buf,'(i3)') ic
	  call text(ixp(1),iyp(1),buf)
	endif
c
	do 1300 n=2,np
c
c  intensity cuing
c  loops taller than hmax0: footpoint brightness is grmax*rcue and
c  brightens toward loop top and saturates to grmax far from footpoints
c  shorter loops: loop top brightness is grmax, and dims toward
c  footpoints
c
	grmax=cuelvl-1
	if(hmax.gt.hmax0) then
	  lcolr=grmax*(rcue + (1.0-rcue)*hp(n)/hmax0 )
	else
	  lcolr=grmax*(rcue + (1.0-rcue)*(hp(n)+hmax0-hmax)/hmax0 )
	endif
	if(lcolr.lt.0) lcolr=0
	if(lcolr.gt.grmax) lcolr=grmax
c
	call linecolor(greenmap+lcolr,0,0)
	call pline3(2,xp(n-1),yp(n-1),zp(n-1))
c  arguments of pline3 should be C-coordinates
 1300	continue
c
	if(msglvl.gt.2) then
	  read(keyin,'(a)') dumstr
	endif
	go to 1100
c
 9000	continue
	msglvl=msav
c
	call linefwidth(1.0)
 9100	if(redraw()) go to 2
	if(iredrw.eq.0) then
	  if(vt100) write(msg,100) cll
	  if(lpout.eq.0) then
	    write(msg,*) 'enter 1(restart),9(end) : '
	  else
	    write(msg,*) 'enter 1(restart),2(hardcopy),9(end) : '
	  endif
c  write statement here should complete output by crlf,
c  thereby avoiding interference with kbhit
c  therefore format 100 is not used here
	endif
c
c  idling loop: wait for keyboard input and redraw request
c
 9150	continue
	if(ask) then
 9200	  if(redraw()) then
	    iredrw=1
	    if(mregn.eq.1) go to 4
	    go to 2
	  endif
	  if(.not.ready(keybuf,iptr,mode1)) go to 9200
	else
	  read(iunit,*,end=98) mode1
	  write(msg,*) mode1
	endif
	iredrw=0
c
c  erase screen and restart
	if(mode1.eq.1) then
	  call clear
	  go to 1
c  hardcopy
	else if (lpout.ne.0 .and. mode1.eq.2) then
	  if(ask.and.commnt.eq.' ') then
            write(msg,*) 'enter comment : '
	    read(iunit,'(a)') commnt
	    call text(int(xfl), int(ysize-6.0*vmi), commnt)
	  endif
	  call hcopy
	  go to 9100
c  end of plot
	else if(mode1.eq.9) then
	  go to 99
	else
	  iunit=keyin
	  ask=.true.
	  mauto=0
	  go to 9100
	endif
c
 97	if(iunit.eq.keyin) go to 99
	iunit=keyin
	ask=.true.
	mauto=0
	go to 1
c
 98	if(iunit.eq.keyin) go to 99
	iunit=keyin
	ask=.true.
	mauto=0
	go to 9150
c
 99	call clear
	call terminate
	if(mfname.ne.' ') 
     &	write(lst,*) 'magnetogram id=',mfile,
     &	', filename=',mfname(1:lenstr(mfname))
	if(iunitl.gt.0.and.lfname.ne.' ') 
     &	write(lst,*) 'field lines id=',lfile,
     &	', filename=',lfname(1:lenstr(lfname))
	return
c
	end
c
	logical function ready(keybuf,iptr,mode1)
c
	character*(*) keybuf
c
c  kbhit returns the input character code, or -1 if no input exists
c
	ready =.false.
c
	ic = kbhit()
	if(ic.lt.0) return
	if(ic.eq.8.or.ic.eq.127) then
	  if(iptr.gt.0) iptr=iptr-1
	  return
	else if (ic.ne.10) then
	  iptr=iptr+1
	  keybuf(iptr:iptr)=char(ic)
	  return
	else if(iptr.gt.0) then
	  read(keybuf(1:iptr),*) mode1
	  keybuf=' '
	  iptr=0
	endif
	ready=.true.
	return
	end
c
c  interface to polyline subroutine
c  gmode=0 : fixed view angle
c        1 : arbitrary view angle and scaling
c        2 : draw solar limb (pline3, use pers instead of rotpt)
c
	subroutine pline2(np,xp,yp)
c
c  this subroutine is for contour plot
c  (xp,yp) are given in D-coordinates if mesh=0
c
	include 'graph.fc'
	include 'fline.fc'
	include 'coord.fc'
	dimension xp(np),yp(np),zp(np),ixp(ML),iyp(ML),xx(3)
c  ML is defined in fline.fc
	logical l1,l2,visibl
	equivalence (ixp(1),xyzr(1,5))
	equivalence (iyp(1),xyzr(1,6))
c
	xconv(x)=gfact*(x-gxc) +xfc
	yconv(y)=gfact*(y-gyc) +yfc
c
c  subr.sphere uses xyzr(*,1-3) 
c
	if(np.le.1) return
	l1=.false.
	idelta=1
c
	do 10 n=1,np
c
	if(gmode.eq.0) then
	    call dtoc2(xp(n),yp(n), xx(1),xx(2))
        else if(gmode.eq.1) then
          if(mesh.eq.0) then
	    call dtoc2(xp(n),yp(n), xx(1),xx(2))
            call proj(xx,meshl)
c
c  mesh=1 and meshl=1
          else if(mesh.eq.1) then
            xx(1)=xp(n)
            xx(2)=yp(n)
            xx(3)=0.0
            call ttoc(xx,xx)
c
c  mesh=2 and meshl=2,3,4
          else if(mesh.eq.2) then
            call stoc(xp(n),alofy(yp(n)),0.0, xx)
c
c  mesh=3,4 and meshl=2,3,4
          else if(mesh.eq.3.or.mesh.eq.4) then
            call rtoc(xp(n),alofy(yp(n)),0.0, xx)
          endif
          call rotpt(xx,xx)
        endif
c
	ixp(n)=xconv(xx(1))
	iyp(n)=yconv(xx(2))
	l2=   ixp(n).ge.xclipl-idelta
     &	.and. ixp(n).le.xclipr+idelta
     &	.and. iyp(n).ge.yclipb-idelta
     &	.and. iyp(n).le.yclipt+idelta
	if(gmode.eq.1) l2=l2.and.visibl(xx)
	if(l1.and.l2) call polyline(2,ixp(n-1),iyp(n-1))
	l1=l2
 10	continue
	return
c
	entry fill2(np, xp,yp)
c
c  this subroutine is for halftone maps
c  (xp,yp) are given in D-coordinates 
c
	if(np.le.1) return
cx	l1=.true.
	l1=.false.
	idelta=1
c
	do 20 n=1,np
c
	if(gmode.eq.0) then
	    call dtoc2(xp(n),yp(n), xx(1),xx(2))
	else if(gmode.eq.1) then
	  if(mesh.eq.0) then
	    call dtoc2(xp(n),yp(n), xx(1),xx(2))
	    call proj(xx,meshl)
c
c  mesh=1 and meshl=1
	  else if(mesh.eq.1) then
	    xx(1)=xp(n)
	    xx(2)=yp(n)
	    xx(3)=0.0
	    call ttoc(xx,xx)
c
c  mesh=2 and meshl=2,3,4
	  else if(mesh.eq.2) then
	    call stoc(xp(n),alofy(yp(n)),0.0, xx)
c
c  mesh=3,4 and meshl=2,3,4
	  else if(mesh.eq.3.or.mesh.eq.4) then
	    call rtoc(xp(n),alofy(yp(n)),0.0, xx)
	  endif	
c
	  call rotpt(xx,xx)
	endif
	ixp(n)=xconv(xx(1))
	iyp(n)=yconv(xx(2))
	l2=   ixp(n).ge.xclipl-idelta
     &	.and. ixp(n).le.xclipr+idelta
     &	.and. iyp(n).ge.yclipb-idelta
     &	.and. iyp(n).le.yclipt+idelta
	if(gmode.eq.1) l2=l2.and.visibl(xx)
cx	l1=l2.and.l1  all points should be inside the window
	l1=l2.or.l1
 20   continue
	if(l1) call polygon(np,ixp,iyp)
	return
c
	entry pline3(np,xp,yp,zp)
c
c  this subroutine is for field line plot and for spherical grid
c  (xp,yp,zp) are in C-coordinates
c
	if(np.le.1) return
	l1=.false.
	idelta=1
c
	do 30 n=1,np
	xx(1)=xp(n)
	xx(2)=yp(n)
	xx(3)=zp(n)
	if(gmode.eq.1) call rotpt(xx,xx)
	if(gmode.eq.2) call pers(xx,xx)
	ixp(n)=xconv(xx(1))
	iyp(n)=yconv(xx(2))
	l2=   ixp(n).ge.xclipl-idelta
     &	.and. ixp(n).le.xclipr+idelta
     &	.and. iyp(n).ge.yclipb-idelta
     &	.and. iyp(n).le.yclipt+idelta
     &	.and. visibl(xx)
	if(l1.and.l2) call polyline(2,ixp(n-1),iyp(n-1))
	l1=l2
 30	continue
	return
c
	entry fill3(np,xp,yp,zp)
c
c  this subroutine is for bar plot (bars with some widths)
c  (xp,yp,zp) are in C-coordinates
c
	if(np.le.1) return
	l1=.false.
	idelta=1
c
	do 40 n=1,np
	xx(1)=xp(n)
	xx(2)=yp(n)
	xx(3)=zp(n)
	if(gmode.eq.1) call rotpt(xx,xx)
	if(gmode.eq.2) call pers(xx,xx)
	ixp(n)=xconv(xx(1))
	iyp(n)=yconv(xx(2))
	l2=   ixp(n).ge.xclipl-idelta
     &	.and. ixp(n).le.xclipr+idelta
     &	.and. iyp(n).ge.yclipb-idelta
     &	.and. iyp(n).le.yclipt+idelta
     &	.and. visibl(xx)
	if(gmode.eq.1) l2=l2.and.visibl(xx)
	l1=l2.or.l1
 40	continue
	if(l1) call polygon(np,ixp,iyp)
	return
c
	entry pline5(np,xp,yp,zp,xp1,yp1)
c
c  this subroutine is for N,S,E,W marks
c  (xp,yp,zp) are in C-coordinates
c
	l1=.false.
	idelta=1
c
	do 50 n=1,np
	xx(1)=xp(n)
	xx(2)=yp(n)
	xx(3)=zp(n)
	if(gmode.eq.1) call rotptv(xx,xx)
	ixp(n)=xconv(xx(1))
	iyp(n)=yconv(xx(2))
	l2=   ixp(n).ge.xclipl-idelta
     &	.and. ixp(n).le.xclipr+idelta
     &	.and. iyp(n).ge.yclipb-idelta
     &	.and. iyp(n).le.yclipt+idelta
cx	if(n.eq.1) then
cx	  xp1=ixp(1)
cx	  yp1=iyp(1)
cx	endif
	if(l1.and.l2) call polyline(2,ixp(n-1),iyp(n-1))
	l1=l2
 50	continue
	xp1=ixp(1)
	yp1=iyp(1)
	return
c
	end
c
c  half tone map
c  number of intensity levels = graylvl 
c
	subroutine disphalftone(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	           ndim,rdata,
     &	           blmin,blmax,pmap,mmap,graylvl)
c
	include 'graph.fc'
	dimension rdata(ndim,ndim),xp(4),yp(4)
	integer pmap,mmap,graylvl
	real loglvl
c
c  assume 1.5mm is the size of elementary filling pattern
	ndx=max(1.0,dx0/(0.15*devcm/gfact) +0.51)
	ndy=max(1.0,dy0/(0.15*devcm/gfact) +0.51)
	ddx=dx/float(ndx)
	ddy=dy/float(ndy)
	delta1=0.02*devcm/gfact*(dx/dx0)
c
	do 1000 i=2,nx
	do 1000 j=2,ny
	do 1000 ii=1,ndx
	do 1000 jj=1,ndy
	ex=(float(ii)-0.5)/float(ndx)
	ey=(float(jj)-0.5)/float(ndy)
	b00= loglvl(rdata(i-1,j-1),blmin,blmax)
	b10= loglvl(rdata(i  ,j-1),blmin,blmax)
	b01= loglvl(rdata(i-1,j  ),blmin,blmax)
	b11= loglvl(rdata(i  ,j  ),blmin,blmax)
	bb=b00+(b10-b00)*ex+(b01-b00)*ey+(b00+b11-b10-b01)*ex*ey
	ibb=bb*float(graylvl-1)
	if(ibb.gt.0.and.ibb.lt.graylvl)
     &	        call fillcolor(pmap+ibb,0,0)
	if(ibb.lt.0.and.ibb.gt.-graylvl)
     &	        call fillcolor(mmap-ibb,0,0)
	xp0 = xs + dx*float(i-2) + ddx*float(ii-1)
	yp0 = ys + dy*float(j-2) + ddy*float(jj-1)
	dfx=min(ddx,dx-ddx*float(ii-1)) +delta1
	dfy=min(ddy,dy-ddy*float(jj-1)) +delta1
	xp(1)=xp0
	yp(1)=yp0
	xp(2)=xp0+dfx
	yp(2)=yp0
	xp(3)=xp0+dfx
	yp(3)=yp0+dfy
	xp(4)=xp0
	yp(4)=yp0+dfy
	if(ibb.ne.0) call fill2(4, xp,yp)
 1000 continue
	return
	end
c
c  intensity map with dots
c  intlvl(1) < intensity             -- no dots
c  intlvl(2) < intensity < intlvl(1) -- one dot in 5x5 area
c  intlvl(3) < intensity < intlvl(2) -- 4  dots in 5x5 area
c  intlvl(4) < intensity < intlvl(3) -- 13 dots in 5x5 area
c              intensity < intlvl(4) -- ignore (maybe beyond the limb)
c
	subroutine dispdot(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	           ndim,rdata,
     &	           intlvl)
c
	include 'sys.fc'
	include 'graph.fc'
	dimension rdata(ndim,ndim),idot(5,5,3),xp(4),yp(4)
	real intlvl(4)
c
	data idot/12*0,1,12*0,
     &	           5*0,0,1,0,1,0,5*0,0,1,0,1,0,5*0,
     &	           1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1/
	idd0=5
	valmax=frmean(rdata,nx,ny,ndim)
c
c  assume 2mm is the size of elementary dot patterns
	ndx=max(1.0,dx0/(0.2*devcm/gfact) +0.51)
	ndy=max(1.0,dy0/(0.2*devcm/gfact) +0.51)
	ddx=dx/float(ndx)
	ddy=dy/float(ndy)
	delta1=0.02*devcm/gfact
c
	do 1000 i=2,nx
	do 1000 j=2,ny
	do 1000 ii=1,ndx
	do 1000 jj=1,ndy
	ex=(float(ii)-0.5)/float(ndx)
	ey=(float(jj)-0.5)/float(ndy)
	a00=rdata(i-1,j-1)
	a10=rdata(i  ,j-1)
	a01=rdata(i-1,j  )
	a11=rdata(i  ,j  )
	val=a00+(a10-a00)*ex+(a01-a00)*ey+(a00+a11-a10-a10)*ex*ey
	val=val/valmax
c  val = normalized intensity
	xp0 = xs + dx*float(i-2) + ddx*float(ii-1)
	yp0 = ys + dy*float(j-2) + ddy*float(jj-1)
	if(val.gt.intlvl(1)) go to 1000
	if(val.lt.intlvl(4)) then
	  go to 1000
cx	  dfx=min(ddx,dx-ddx*float(ii-1)) +delta1
cx	  dfy=min(ddy,dy-ddy*float(jj-1)) +delta1
cx	  xp(1)=xp0
cx	  yp(1)=yp0
cx	  xp(2)=xp0+dfx
cx	  yp(2)=yp0
cx	  xp(3)=xp0+dfx
cx	  yp(3)=yp0+dfy
cx	  xp(4)=xp0
cx	  yp(4)=yp0+dfy
cx	  call fill2(4, xp,yp)
	endif
	if(val.gt.intlvl(2)) then
	  lvl=1
	else if(val.gt.intlvl(3)) then
	  lvl=2
	else
	  lvl=3
	endif
c
c  arguments of pline2 should be D-coordinates
	do 1100 iii=1,idd0
	do 1100 jjj=1,idd0
	if(idot(iii,jjj,lvl).eq.0) go to 1100
	  xp(1) = xp0 + ddx*float(iii-1)/float(idd0)
	  yp(1) = yp0 + ddy*float(jjj-1)/float(idd0)
	  xp(2) = xp(1)
	  yp(2) = yp(1)
	  call pline2(2,xp,yp)
 1100 continue
 1000 continue
	return
	end
c
c  plot bars
c
	subroutine dispbar(nx,ny,xs,ys,dx,dy,dx0,dy0,
     &	           kx,ky,kz, 
     &	           btmin,btmax,arrow,arrsep)
c
	include 'sys.fc'
	include 'coord.fc'
	include 'graph.fc'
	include 'mdata.fc'
	dimension xp(5),yp(5),zp(5),xx(3)
	real loglvl
	logical arrow
c
c  arrsep is minimum arrow separation
c  grid size of arrow plotting is dx*ndxar, dy*ndyar
	ndxar=arrsep/(dx0*gfact)
	ndyar=arrsep/(dy0*gfact)
	if (ndxar.lt.1) ndxar=1
	if (ndyar.lt.1) ndyar=1
c
c  arrow size = 1mm
	asize=0.1*devcm/gfact*(dx/dx0) 
	f=0.4
c  minimum length of bars = 0.5mm
	ww=0.05*devcm/gfact*(dx/dx0)
	dx1=dx*float(ndxar)
	dy1=dy*float(ndyar)
	dbmax=sqrt(dx1**2+dy1**2)
c
	do 1000 i=2,nx-1,ndxar
	do 1000 j=2,ny-1,ndyar
c
	xp(1) = xs + dx*float(i-1)
	yp(1) = ys + dy*float(j-1)
	if(gmode.eq.0) then
	    call dtoc2(xp(1),yp(1), xx(1),xx(2))
        else if(gmode.eq.1) then
          if(mesh.eq.0) then
	    call dtoc2(xp(1),yp(1), xx(1),xx(2))
            call proj(xx,meshl)
c
c  mesh=1 and meshl=1
          else if(mesh.eq.1) then
            xx(1)=xp(1)
            xx(2)=yp(2)
            xx(3)=0.0
            call ttoc(xx,xx)
c
c  mesh=2 and meshl=2,3,4
          else if(mesh.eq.2) then
            call stoc(xp(1),alofy(yp(1)),0.0, xx)
c
c  mesh=3,4 and meshl=2,3,4
          else if(mesh.eq.3.or.mesh.eq.4) then
            call rtoc(xp(1),alofy(yp(1)),0.0, xx)
          endif
        endif
c
	bt=sqrt(rdata(i,j,kx)**2+rdata(i,j,ky)**2)
	db=dbmax*loglvl(bt,btmin,btmax)
	if(db.lt.ww) go to 1000
	ux=rdata(i,j,kx)/bt
	uy=rdata(i,j,ky)/bt
	dxx=ux*db
	dyy=uy*db
	if(kz.gt.0) then
	  dzz=db*rdata(i,j,kz)/bt
	else
	  dzz=0.0
	endif
	vx=-uy
	vy= ux
c
	if(arrow) then 
c
c  (ux,uy) and (vx,vy) are orthogonal
c  arguments of pline3 should be C-coordinates
	  xp(1) = xx(1) - 0.5*dxx
	  xp(2) = xx(1) + 0.5*dxx
	  yp(1) = xx(2) - 0.5*dyy
	  yp(2) = xx(2) + 0.5*dyy
	  zp(1) = xx(3) - 0.5*dzz
	  zp(2) = xx(3) + 0.5*dzz
	  xp(4) = xp(2)
	  yp(4) = yp(2)
	  zp(4) = zp(2)
	  xp(3)=xp(2) - (asize*ux + f*asize*vx)
	  yp(3)=yp(2) - (asize*uy + f*asize*vy)
	  zp(3)=zp(2)
	  xp(5)=xp(2) - (asize*ux - f*asize*vx)
	  yp(5)=yp(2) - (asize*uy - f*asize*vy)
	  zp(5)=zp(2)
cx	  call pline2(2,xp,yp)
cx	  call pline2(3,xp(3),yp(3))
	else
cx	  width=dbmax*loglvl(bt,btmax,10.0*btmax)
	  xp(1) = xx(1) + (-0.5*dxx + 0.5*vx*width)
	  xp(2) = xx(1) + ( 0.5*dxx + 0.5*vx*width)
	  yp(1) = xx(2) + (-0.5*dyy + 0.5*vy*width)
	  yp(2) = xx(2) + ( 0.5*dyy + 0.5*vy*width)
	  zp(1) = xx(3) - 0.5*dzz
	  zp(2) = xx(3) + 0.5*dzz
cx	  if(width.lt.1.0) go to 1100
	  xp(3) = xx(1) + ( 0.5*dxx - 0.5*vx*width)
	  xp(4) = xx(1) + (-0.5*dxx - 0.5*vx*width)
	  yp(3) = xx(2) + ( 0.5*dyy - 0.5*vy*width)
	  yp(4) = xx(2) + (-0.5*dyy - 0.5*vy*width)
	  zp(3) = zp(2)
	  zp(4) = zp(1)
	  xp(5)=xp(1)
	  yp(5)=yp(1)
	  zp(5)=zp(1)
cx	  call fill2(5,xp,yp)
cx	  go to 1000
cx 1100	  call pline2(2,xp,yp)
	endif
c
c  in order to make 3D transform, call pline3
c  xp,yp,zp are in C-coordinates
	if (arrow) then
	  call pline3(2,xp,yp,zp)
	  call pline3(3,xp(3),yp(3),zp(3))
	else
	  width=dbmax*loglvl(bt,btmax,10.0*btmax)
	  if(width.lt.1.0) then
	    call pline3(2,xp,yp,zp)
	  else
	    call fill3(5,xp,yp,zp)
	  endif
	endif
c
 1000 continue
	return
	end
