c  dump fieldline file
c
	program dumpl
c
	include 'sys.fc'
	include 'coord.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	include 'fline.fc'
	include 'lparam.fc'
c
	integer iul,oul,oup,lmask(NFMAX)
	character*80 fname1,fname2,fnamep,chr
	logical update
	data lmask/NFMAX*1/
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	chr='0'
        if(myargc().eq.1) call myargv(1,chr)
        if(chr.eq.'0') then
          msglvl=0
        else if(chr.eq.'1') then
          msglvl=1
        else if(chr.eq.'2') then
          msglvl=2
        else if(chr.eq.'3') then
          msglvl=3
        else
          msglvl=1
        endif
c
	include 'sysconf.cfg'
	call initfc
	lst = lstini()
c
	if(mycode.eq.0 .or. myint.eq.0) stop
c
	lrec0=80
	iul=98
	oul=97
	oup=96
c
	write(msg,*) '(prog.dumpl ) enter fieldline file name for input'
	read(keyin,'(a)') fname1
	call openfl(other1,'DUMPL',iul,fname1,export,rdo,lrec0)
	if(errflg.gt.1) stop
c
	write(msg,*)
     &	'(prog.dumpl ) enter listing file name',
     &	' (default=screen)'
	fnamep=' '
	read(keyin,'(a)') fnamep
	if(fnamep.ne.' ') then
	  call openfl(other2,'LISTL',oup,fnamep,text,wrt,lrec0)
	  if(errflg.gt.1) stop
	else
	  oup=lst
	endif
c
	npmax=100000
	npstep=1
	update=.true.
	msg0=msglvl
	msglvl=2
	call readlh(iul,update)
	msglvl=msg0
	nbytel=sign(nbytli,myint)
	ncomp=ncompi
	ftag=mtag
	mfile=lfile
        if(iabs(nbytel).eq.2) then
          factx=0.02
          factb=0.2
        else
          factx=0.01*1.0e-4
          factb=0.1 *1.0e-4
        endif
c
c  In this program, no magnetogram is read so that ftag and mfile
c  are empty.
c  In subr.writel, mtag is again set to ftag and lfile is set to mfile.
c
 1	continue
	update=.false.
	call readlh(iul,update)
	if(errflg.gt.1) stop
	mesh=mod(kindli,10)
	if(mesh.gt.2) mesh=2
	if(msg0.le.1) msglvl=0
	write(msg,*)
     &  'enter 0(number count), 1(simple), 2(full listing),'
	write(msg,*) '      3(copy), 9(end)'
	read(keyin,*) mode
c
c  if mode=-1 or -2, heights instead of z-values are listed, by
c  supplying the value of rsp (if mesh.ge.2)
c
	if(mode.eq.9) stop
c
	if(mode.eq.-1.or.mode.eq.-2) then
	  prad=0.0
	  b0rad=0.0
	  cl0=0.0
	  cl0eff=0.0
	  call setdu
	  if(mesh.eq.1) then
	    write(msg,*) 'enter rsp,xtod,ytod'
	    read(keyin,*) rsp,xtod,ytod
	    xxtod(1)=xtod
	    xxtod(2)=ytod
	    call projsr(xxtod,rsp)
	    call dtoc(xxtod,xxto)
	    call settu
	  else if (mesh.eq.2) then
	    write(msg,*) 'enter rsp'
	    read(keyin,*) rsp
	    xxsp(1)=0.0
	    xxsp(2)=0.0
	    xxsp(3)=-rsp
	    call setas
	  endif
	endif
c
	if(iabs(mode).eq.2) then
	  write(msg,*) 'enter mask array (0=skip,1=print)'
	  read(keyin,*) lmask
	  write(msg,*) 'enter npmax and npstep (do n=1,npmax,npstep)'
	  read(keyin,*) npmax,npstep
	endif
	if(mode.eq.3) then
	  write(msg,*) 'enter mask array (0=skip,1=copy)'
	  read(keyin,*) lmask
	  write(msg,*) 'enter resampling interval (1 or larger integer)'
	  npstep=1
	  read(keyin,*) npstep
	  write(msg,*) 'enter output file name'
	  read(keyin,'(a)') fname2
	  call openfl(other3,'DUMPL',oul,fname2,export,wrt,lrec0)
	  if(errflg.gt.1) stop
	  call writlh(oul)
	endif
	nlof1=0
	nlof2=0
c
 2	call readl(iul,np,xyzp)
	if(np.le.1) go to 3
	nlof1=nlof1+1
c
	if(mode.eq.1 .or. (mode.eq.2.and.lmask(nlof1).ne.0)) then
	  if(iabs(ncompi).eq.8) then
	    write(lst,100) nlof1,np,abs(xyzp(4,np))
	    if(oup.ne.lst) write(oup,100) nlof1,np,abs(xyzp(4,np))
 100	format(/2x,i3,2x,'np=',i4,2x,'length=',1p7e11.3)
	    write(lst,200)
	    if(oup.ne.lst) write(oup,200)
 200	    format(/2x, t8,'x',t19,'y',t30,'z',
     &	           t41,'bx',t52,'by',t63,'bz',t74,'bs')
	  else
	  write(lst,110) nlof1,np
	  if(oup.ne.lst) write(oup,110) nlof1,np
 110    format(/2x,i3,2x,'np=',i4)
	    write(lst,210)
	    if(oup.ne.lst) write(oup,210)
 210	    format(/2x, t8,'x',t19,'y',t30,'z')
	  endif
	endif
c
	if(mode.eq.-1 .or. (mode.eq.-2.and.lmask(nlof1).ne.0)) then
	  if(iabs(ncompi).eq.8) then
	    write(lst,100) nlof1,np,abs(xyzp(4,np))
	    if(oup.ne.lst) write(oup,100) nlof1,np,abs(xyzp(4,np))
	    write(lst,205)
	    if(oup.ne.lst) write(oup,205)
 205	    format(/2x, t8,'x',t19,'y',t30,'h',
     &	           t41,'bx',t52,'by',t63,'bz',t74,'bs')
	  else
	    write(lst,110) nlof1,np
	    if(oup.ne.lst) write(oup,110) nlof1,np
	    write(lst,215)
	    if(oup.ne.lst) write(oup,215)
 215	    format(/2x, t8,'x',t19,'y',t30,'h')
	  endif
	endif
c
	if(mode.eq.-1.or.mode.eq.-2) then
	  do 1000 n=1,np
 1000	  xyzp(3,n)=height(xyzp(1,n),mesh)
	endif
c
	if(iabs(mode).eq.1) then
	  if(iabs(ncompi).eq.8) then
	    write(lst,300)
     &	((xyzp(m,n),m=1,3),(xyzp(m,n),m=5,8), n=1,np,np-1)
	    if(oup.ne.lst) 
     &	write(oup,300)
     &	((xyzp(m,n),m=1,3),(xyzp(m,n),m=5,8), n=1,np,np-1)
 300	    format(2x, 1p7e11.3/(2x, 7e11.3))
	  else
	    write(lst,310) ((xyzp(m,n),m=1,3),n=1,np,np-1)
	    if(oup.ne.lst)
     &	write(oup,310) ((xyzp(m,n),m=1,3),n=1,np,np-1)
 310	    format(2x, 1p7e11.3/(2x, 7e11.3))
	  endif
c
	else if(iabs(mode).eq.2 .and. lmask(nlof1).ne.0) then
	  if(iabs(ncompi).eq.8) then
	    write(lst,300) ((xyzp(m,n),m=1,3),(xyzp(m,n),m=5,8),
     &	n=1,min(np,npmax),npstep)
	    if(oup.ne.lst) write(oup,300)
     &    ((xyzp(m,n),m=1,3),(xyzp(m,n),m=5,8),n=1,min(np,npmax),npstep)
	  else
	    write(lst,310)
	    if(oup.ne.lst) write(oup,310)
     &    ((xyzp(m,n),m=1,3),n=1,min(np,npmax),npstep)
	  endif
c
	else if(mode.eq.3 .and. lmask(nlof1).ne.0) then
	  j=0
	  do 1100 n=1,np,npstep
	  j=j+1
	  n1=n
	  do 1100 i=1,iabs(ncompi)
 1100	  xyzp(i,j)=xyzp(i,n)
	  if(n1.ne.np) then 
	    j=j+1
	    do 1200 i=1,iabs(ncompi)
 1200	    xyzp(i,j)=xyzp(i,np)
	  endif
	  np=j
	  nlof2=nlof2+1
	  call writel(oul,np,xyzp)
	endif
	go to 2
c
 3	write(lst,*) 'number of field lines in input file=',nlof1
	if(mode.eq.3) then
	  write(lst,*) 'number of field lines in output file=',nlof2
	  call writel(oul,0,xyzp)
	endif
	go to 1
c
	end
