c  dump magnetogram file
c
	program dumpm
c
	include 'sys.fc'
	include 'mdata.fc'
	include 'mparam.fc'
	include 'coord.fc'
	include 'solar.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'string.fc'
	logical update
	integer ium,oup,kdest(NSPEC0)
	character*80 fname1,fnamep,chr
c
	keyin  = 5
	stdin  = 10
	lst    = 6
	msg    = msgini()
	errflg = 0
	chr='0'
	if(myargc().eq.1) call myargv(1,chr)
	if(chr.eq.'0') then
	  msglvl=0
	else if(chr.eq.'1') then
	  msglvl=1
	else if(chr.eq.'2') then
	  msglvl=2
	else if(chr.eq.'3') then
	  msglvl=3
	else
	  msglvl=1
	endif
c
	include 'sysconf.cfg'
c
	call initfc
	lst = lstini()
c
c  these are not initialized in initfc
	nxmax=MX
	nymax=MY
c
	if(mycode.eq.0 .or. myint.eq.0) stop
c
	lrec0=80
	ium=98
	oup=97
c
	write(msg,*)
     &	'(prog.dumpm ) enter magnetogram file name for input'
	read(keyin,'(a)') fname1
	call openfl(other1,'DUMPM',ium,fname1,export,rdo,lrec0)
	if(errflg.gt.1) stop
c
      write(msg,*)
     &      '(prog.dumpm ) enter listing file name',
     &      ' (default=screen)'
      fnamep=' '
      read(keyin,'(a)') fnamep
      if(fnamep.ne.' ') then
        call openfl(other2,'LISTM',oup,fnamep,text,wrt,lrec0)
        if(errflg.gt.1) stop
      else
        oup=lst
      endif
c
	update=.true.
	do 10 n=1,NSPEC0
 10	kloc(n)=0
	do 20 k=1,MZ
	kmem(k)=0
	lspecs(k)=0
 20	continue
	nframe=0
	nbinx=1
	nbiny=1
c
	call inmh(ium,update)
	if(errflg.gt.1) stop
	write(lst,*)
     &	 '(prog.dumpm ) kindm,mesh,nframe=',kindmi,mesh,nframi
	call printm(nbytmi,nx,ny,xs,ys,dx,dy,ydeg,
     &	rsp,pdeg,b0deg,cl0deg,xtod,ytod,
     &	tsys,inst,wavel,mfile,dateo,stime,etime,ftag,title)
c
	do 1000 iframe=1,nframi
	do 30 lspec1=1,NSPEC0
 30	kdest(lspec1)=1
	call inm(ium,kdest)
	write(lst,*) 'data=',specst(lspecs(1)),
     &	', factor=',factm(lspecs(1))
c
	mode=0
	write(lst,*)
     &	'(prog.dumpm ) print data? (0=no, 1=partial dump, 2=full dump)'
	read(keyin,*) mode
	if(mode.eq.2) then
c
	  rmax=framax(rdata(1,1,1),nx,ny,MX)
	  write(lst,*) 'data=',specst(lspecs(1)),
     &	', factor=',factm(lspecs(1))
c
	  if(factm(lspecs(1)).eq.1.0 .and. iabs(nbytmi).eq.2) then 
	    do 2000 j=1,ny
	    write(lst,*) 'j=',j
	    write(lst,100) (idata2(i,j),i=1,nx)
	    if(oup.ne.lst) then
	      write(oup,*) 'j=',j
	      write(oup,100) (idata2(i,j),i=1,nx)
	    endif
 2000	    continue
c
	  else if(factm(lspecs(1)).eq.1.0 .and. iabs(nbytmi).eq.4) then 
	    do 2100 j=1,ny
	    write(lst,*) 'j=',j
	    write(lst,100) (idata4(i,j),i=1,nx)
	    if(oup.ne.lst) then
	      write(oup,*) 'j=',j
	      write(oup,100) (idata4(i,j),i=1,nx)
	    endif
 2100	  continue
c
	  else if(factm(lspecs(1)).gt.1.0 .and. rmax.lt.1.0e7) then
	    do 2200 j=1,ny
	    write(lst,*) 'j=',j
	    write(lst,200) (rdata(i,j,1),i=1,nx)
	    if(oup.ne.lst) then
	      write(oup,*) 'j=',j
	      write(oup,200) (rdata(i,j,1),i=1,nx)
	    endif
 2200	    continue
c
	  else if(factm(lspecs(1)).ge.1.0e-1 .and. rmax.lt.1.0e6) then
	    do 2300 j=1,ny
	    write(lst,*) 'j=',j
	    write(lst,210) (rdata(i,j,1),i=1,nx)
	    if(oup.ne.lst) then
	      write(oup,*) 'j=',j
	      write(oup,210) (rdata(i,j,1),i=1,nx)
	    endif
 2300	    continue
c
	  else if(factm(lspecs(1)).ge.1.0e-2 .and. rmax.lt.1.0e5) then
	    do 2400 j=1,ny
	    write(lst,*) 'j=',j
	    write(lst,220) (rdata(i,j,1),i=1,nx)
	    if(oup.ne.lst) then
	      write(oup,*) 'j=',j
	      write(oup,220) (rdata(i,j,1),i=1,nx)
	    endif
 2400	    continue
c
	  else if(factm(lspecs(1)).ge.1.0e-3 .and. rmax.lt.1.0e4) then
	    do 2500 j=1,ny
	    write(lst,*) 'j=',j
	    write(lst,230) (rdata(i,j,1),i=1,nx)
	    if(oup.ne.lst) then
	      write(oup,*) 'j=',j
	      write(oup,230) (rdata(i,j,1),i=1,nx)
	    endif
 2500	    continue
c
	  else 
	    do 2600 j=1,ny
	    write(lst,*) 'j=',j
	    write(lst,300) (rdata(i,j,1),i=1,nx)
	    if(oup.ne.lst) then
	      write(oup,*) 'j=',j
	      write(lst,300) (rdata(i,j,1),i=1,nx)
	    endif
 2600	    continue
c
	  endif
c
 100	  format(1h ,10i7)
 200	  format(1h ,10f7.0)
 210	  format(1h ,10f7.1)
 220	  format(1h ,10f7.2)
 230	  format(1h ,10f7.3)
 300	  format(1h ,1p10e8.1)
c
	else if(mode.eq.1) then
 1100	  write(lst,*) '(prog.dumpm ) enter i,j (i=0:next data)'
	  read(keyin,*) i,j
	  if(i.eq.0) go to 1000
	  write(lst,*) 'i,j,rdata=',i,j,rdata(i,j,1)
	  go to 1100
	endif
 1000	continue
c
	stop
	end
