c  system-dependent programs : IBM version (for FACOM OS IV fortran77)
c
c  code conversion table
c
	subroutine setae(atoe,etoa)
c
	integer atoe,etoa,atoe1,etoa1,etoa2
	dimension atoe(95),atoe1(95)
	dimension etoa(192),etoa1(96),etoa2(96)
c
c  atoe1, etoa1, etoa2 are defined by data statements 
	include 'convi.fi'
c
	do 10 i=1,95
 10	atoe(i)=atoe1(i)
	do 20 i=1,96
	etoa(i)=etoa1(i)
	etoa(i+96)=etoa1(i)
 20	continue
	return
	end
c
c  initial value of msg
c
	integer function msgini()
	msgini=6
	return
	end
c
c  make date & time tag (yy/mm/ddhh:mm:ss)
c  declare "character*16 mktag" in the calling program.
c
	character*16 function mktag()
c
	character str*8
	integer*4 itime
c
c  str='yy-mm-dd' (8 byte long)
	call date(str)
	str(3:3)='/'
	str(6:6)='/'
c  itime in msec
	call time(itime)
	itime=itime/1000
	ih=itime/3600
	im=mod(itime/60,60)
	is=mod(itime,60)
	write(mktag,100) str,ih,im,is
 100	format(a8,i2.2,':',i2.2,':',i2.2)
	return
	end
c
c  determine the unit of recl in direct access unformatted i/o
c  i1= unit of record length in bytes when recl=1
c  i1=0 means that number of transferred data is determined
c     by the i/o list and not restricted to record length
c  i2= unit of record length in bytes when recl=2
c
c  write/read check of direct access formatted i/o
c  i3.ne.0 means that at least one code mismatch is found
c
c  file-99 is created for working space
c
c  return values are not used because formatted i/o in ibm systems
c  can handle binary data
c
	subroutine getrl(i1,i2,i3)
	include 'sys.fc'
	character wbuf*16,blank*16,rbuf*16,codes(256)*1
	dimension istat(4,2),nbytes(4)
	data istat/8*0/, nbytes/1,2,4,8/
c
	wbuf='0123456789ABCDEF'
	iu=99
	if(msglvl.gt.1) write(lst,*) '(subr.getrl )'
c
	do 1 lrec=1,2
	open(iu,access='direct',form='unformatted',recl=lrec,
     &	     status='scratch')
c
	do 2 nbyt=1,4
	nbyte=nbytes(nbyt)
	write(iu,rec=1,err=90) wbuf(1:nbyte)
	if(msglvl.gt.2)
     &	  write(lst,*) '  recl=',lrec,nbyte,' byte(s) written'
	rbuf=blank
	read(iu,rec=1,err=90) rbuf(1:nbyte)
	if(msglvl.gt.2) write(lst,*) '  read results:',rbuf(1:nbyte)
	istat(nbyt,lrec)=1
 90	continue
c
 2	continue
	close (iu, status='delete')
 1	continue
c
	if(msglvl.gt.1) 
     &	  write(lst,*) '  direct access unformatted i/o:'
	if(istat(4,1).eq.1) then 
	  if(msglvl.gt.1) 
     &      write(lst,*) 
     &	      '    file is regarded as byte strings if recl=1'
	  i1=0
	else if(istat(3,1).eq.1) then
	  if(msglvl.gt.1) 
     &      write(lst,*) '    recl=1 means record length=4 bytes'
	  i1=4
	else if(istat(2,1).eq.1) then
	  if(msglvl.gt.1)
     &      write(lst,*) '    recl=1 means record length=2 bytes'
	  i1=2
	else if(istat(1,1).eq.1) then
	  if(msglvl.gt.1)
     &	    write(lst,*) '    recl=1 means record length=1 byte'
	  i1=1
	else 
	  if(msglvl.gt.1)
     &	    write(lst,*) '    recl=1: all in error'
	  i1=-1
	endif
	if(istat(4,2).eq.1) then
	  if(msglvl.gt.1)
     &	    write(lst,*) '    recl=2 means record length=2*4 bytes'
	  i2=4
	else if(istat(3,2).eq.1) then
	  if(msglvl.gt.1)
     &	    write(lst,*) '    recl=2 means record length=2*2 bytes'
	  i2=2
	else if(istat(2,2).eq.1) then
	  if(msglvl.gt.1)
     &	    write(lst,*) '    recl=2 means record length=2*1 bytes'
	  i2=1
	else
	  if(msglvl.gt.1)
     &	    write(lst,*) '    recl=2: all in error'
	  i2=-1
	endif
c
c  read-after-write check (formatted i/o)
c
	if(msglvl.gt.1) 
     &	  write(lst,*) '  direct access formatted i/o:'
	do 10 i=1,256
 10	codes(i)=char(i-1)
c
	open(iu,form='formatted',access='direct',recl=256,
     &	     status='scratch')
	write(iu,100,rec=1) codes 
	read(iu,100,rec=1) codes
 100	format(128a1,128a1)
c
	i3=0
	do 20 i=1,256
	iw=mod(ichar(char(i-1))+256,256)
	ir=mod(ichar(codes(i)) +256,256)
 	if(codes(i).ne.char(i-1)) then
	  if(msglvl.gt.1) write(lst,*)
     &	    '    code mismatch: write=',iw,' read=',ir
	  i3=i3+1
	endif
 20	continue
c
	if(i3.eq.0.and.msglvl.gt.1) 
     &    write(lst,*) '    no code mismatch in read-after-write check'
	close( iu, status='delete')
	return
	end
c
c  dummy procedures for iargc and getarg
c
	function myargc()
	iargc=0
	return
	end
c
	subroutine myargv(k,str)
	character str*(*)
	return
	end
c
c  print dots on the screen
c
        subroutine dots(msg,i)
c
	character*1 dot(80)
	save loc
	data loc/1/
c
        if(i.eq.1) then
	  do 10 j=1,80
 10	  dot(j)=' '
          write(msg,100)
	  loc=1
        else if(i.lt.0) then
          write(msg,100)
	  loc=1
        else
	  dot(loc)='.'
          write(msg,200) (dot(j),j=1,loc)
	  if(loc.lt.70) then
	    loc=loc+1
	  else
	    loc=1
	  endif
        endif
        return
 100    format(/' ')
 200    format('+',80a1)
        end
c
c  banner statement of fortran language
c
        character*30 function lang()
        lang=' (IBM Fortran)'
        return
        end

