c  JxB force
c
	subroutine jxb(idif0,x,gnorm,g)
c
	include 'sys.fc'
	include 'coord.fc'
	include 'mparam.fc'
	include 'ff0.fc'
	include 'fff.fc'
	include 'ss.fc'
	include 's3.fc'
c
	external range
c
	logical range,ldummy,numdif
	dimension dd(3),bb(3),b(3),wk(3)
	dimension x(1),g(1)
c
	isw=1
	noddif=0
	lofdif=0
	idif=0
	numdif=.false.
	go to 1
c
c  subr.mnnl calls djxb in the following sequence:
c	for j=1,2,,,,nvar
c     x0=x
c	x(j)=x0(j)+dx
c	call djxb(j,x,f,g)
c	x(j)=x0(j)-dx
c	call djxb(j,x,f,g)
c	x(j)=x0(j)
c	call djxb(-j,x,f,g)
c
	entry djxb(idif1,x,gnorm,g)
c
	numdif=.true. 
	idif=idif1
	if( iabs(idif).gt.2*lmax ) then
	  lofdif=iabs(idif)-2*lmax
	  noddif=0
	  isw=1
	else if ( iabs(idif).gt.0 ) then
	  lofdif=0
	  noddif=(iabs(idif)-1)/2+1
	  isw=0
	else
	  lofdif=0
	  noddif=0
	  isw=1
	endif
c
c  noddif=differentiating node number
c  lofdif=differentiating line-of-force number
c
 1	continue
	lmax2=2*lmax
	ns3=lmax2
	do 10 l=1,nvar
 10	g(l)=0.0
	do 20 l=1,lmax2
 20	ksw3(l)=isw
c
	if( modeff.eq.1 ) then
c  curl(bh) is specified
	  do 30 n=1,nff
cx	  if( abs(alpha(n)+dalpha(n)).lt.abs(alpha0(n)) ) then
cx	    alpha(n)=alpha(n)+dalpha(n)
cx	  else
cx	    alpha(n)=alpha0(n)
cx	  endif
	  rotb(n)=bn0(n)*alpha(n)
 30	  continue
c
	else if(modeff.eq.2) then
c  curl(bh) is adjusted so that curl[bn(bh-bhp)] is continuous
	  do 40 n=1,nff
	  rotb(n)=x(lmax2+n)
 40	  alpha(n)=rotb(n)/bn0(n)
	endif
c
	if(isw.eq.0.and.noddif.gt.0) then
c  set ksw3=1 for elements moved
	  do 50 n=1,nff
	  if(noddif.eq.le(n)) then
	    nodep=0
	    nodem=0
	    do 60 l=ls(n),le(n)
	    ksw3(l)=1
 60	    ksw3(l+lmax)=1
	  else if(noddif.ge.ls(n) .and. noddif.lt.le(n)) then
	    nodep=noddif+1
	    nodem=noddif
	    ksw3(nodep)=1
	    ksw3(nodep+lmax)=1
	    ksw3(nodem)=1
	    ksw3(nodem+lmax)=1
	  endif
 50	  continue
	endif
c
	ldpeek=-1
	lpeek=-1
	if(numdif.and.iabs(idif1).eq.ldpeek) then
	  write(lst,*) 
	  write(lst,*) 'djxb: idif1,noddif,isw=',idif1,noddif,isw
	  write(lst,*) 'ksw3=',(ksw3(lll),lll=1,lmax2)
	endif
c
c  calculate new node positions
c
	do 1000 n=1,nff
	l1=ls(n)
	l2=le(n)
	wk(1)=(xxn0(1,l2)-xxs(1,n))
	wk(2)=(xxn0(2,l2)-xxs(2,n))
	wk(3)=(xxn0(3,l2)-xxs(3,n))
	wkl=sqrt(wk(1)**2+wk(2)**2+wk(3)**2)
	wk(1)=wk(1)/wkl
	wk(2)=wk(2)/wkl
	wk(3)=wk(3)/wkl
c  wk is the unit vector from start to end points of a field line
c  wkl is the separation between start and end points
c
	do 1100 l=l1,l2
	if(ksw3(l).eq.0) go to 1100
c
c  rexp=factor of homologous expansion
	rexp=(wk(1)*(xxn0(1,l)-xxs(1,n))
     &	     +wk(2)*(xxn0(2,l)-xxs(2,n))
     &	     +wk(3)*(xxn0(3,l)-xxs(3,n)) )/wkl
	if(l.eq.l2) rexp=0.0
c
	xxn(1,l)=xxn0(1,l)+x(2*l -1)*ve1(1,l )+x(2*l )*ve2(1,l )
     &	         +rexp*(x(2*l2-1)*ve1(1,l2)+x(2*l2)*ve2(1,l2))
	xxn(2,l)=xxn0(2,l)+x(2*l -1)*ve1(2,l )+x(2*l )*ve2(2,l )
     &	         +rexp*(x(2*l2-1)*ve1(2,l2)+x(2*l2)*ve2(2,l2))
	xxn(3,l)=xxn0(3,l)+x(2*l -1)*ve1(3,l )+x(2*l )*ve2(3,l )
     &	         +rexp*(x(2*l2-1)*ve1(3,l2)+x(2*l2)*ve2(3,l2))
	if(l.eq.l2) call proj(xxn(1,l), mesh)
c
	ldummy=range(xxn0(1,l), h1)
	ldummy=range(xxn(1,l),h2)
	if(h2.lt.-1.0e-3 .and. isw.eq.1) then
	  aux=h1/(h1-h2)
	  if(idif.eq.0) write(lst,*)
     &	'(subr.jxb   )',l,'-th node is below the boundary'
	  errfff=1
	  xxn(1,l)=xxn0(1,l)+aux*(
     &	      x(2*l -1)*ve1(1,l )+x(2*l )*ve2(1,l )
     &	     +rexp*(x(2*l2-1)*ve1(1,l2)+x(2*l2)*ve2(1,l2)))
	  xxn(2,l)=xxn0(2,l)+aux*(
     &	      x(2*l -1)*ve1(2,l )+x(2*l )*ve2(2,l )
     &	     +rexp*(x(2*l2-1)*ve1(2,l2)+x(2*l2)*ve2(2,l2)))
	  xxn(3,l)=xxn0(3,l)+aux*(
     &	      x(2*l -1)*ve1(3,l )+x(2*l )*ve2(3,l )
     &	     +rexp*(x(2*l2-1)*ve1(3,l2)+x(2*l2)*ve2(3,l2)))
c  apply factor aux so that the node is above the boundary
c
	endif
cc
	if(numdif.and.iabs(idif1).eq.ldpeek
     &	.and.l.eq.lpeek) then
	  write(lst,*) 
	  write(lst,*) 'djxb: l,idif1,noddif,isw=',l,idif1,noddif,isw
	  write(lst,*) 'n,ls,le=',n,ls(n),le(n)
	  write(lst,*) 'xxn0=',(xxn0(m,l),m=1,3)
	  write(lst,*) 'xxn=',(xxn(m,l),m=1,3)
	endif
   	if(.not.numdif.and.iabs(idif0).eq.ldpeek
     &	.and. l.eq.lpeek) then
	  write(lst,*) 
	  write(lst,*) 'jxb : l,idif0=',l,idif0
	  write(lst,*) 'n,ls,le=',n,ls(n),le(n)
	  write(lst,*) 'xxn0=',(xxn0(m,l),m=1,3)
	  write(lst,*) 'xxn=',(xxn(m,l),m=1,3)
	  write(lst,*) 've1=',(ve1(m,l),m=1,3)
	  write(lst,*) 've2=',(ve2(m,l),m=1,3)
	  write(lst,*) 'xxs=',(xxs(m,n),m=1,3)
	endif
 1100	continue
 1000	continue
c
c  calculate s3-source parameters
c
	do 2000 n=1,nff
	l1=ls(n)
	l2=le(n)
	ell1=0.0
c
	do 2100 l=l1,l2
	if(ksw3(l).eq.0) go to 2100
c
	if(l.eq.l1) then
	  xxs3(1,l)=0.5*(xxn(1,l)+xxs(1,n))
	  xxs3(2,l)=0.5*(xxn(2,l)+xxs(2,n))
	  xxs3(3,l)=0.5*(xxn(3,l)+xxs(3,n))
	  dd(1)=xxn(1,l)-xxs(1,n)
	  dd(2)=xxn(2,l)-xxs(2,n)
	  dd(3)=xxn(3,l)-xxs(3,n)
	else
	  xxs3(1,l)=0.5*(xxn(1,l)+xxn(1,l-1))
	  xxs3(2,l)=0.5*(xxn(2,l)+xxn(2,l-1))
	  xxs3(3,l)=0.5*(xxn(3,l)+xxn(3,l-1))
	  dd(1)=xxn(1,l)-xxn(1,l-1)
	  dd(2)=xxn(2,l)-xxn(2,l-1)
	  dd(3)=xxn(3,l)-xxn(3,l-1)
	endif
c
	d=sqrt(dd(1)**2+dd(2)**2+dd(3)**2)
	direc3(1,l)=dd(1)/d
	direc3(2,l)=dd(2)/d
	direc3(3,l)=dd(3)/d
	el3(l)=d
	ell1=ell1+d
c
c  cj3 =total current
c      =(abs.rotb)/(4*pi)*(tube area)
c      =(z-comp of rotb)/(4*pi)*(dx*dy)
	cj3(l)=rotb(n)/(4.0*3.141592)*ss0(n)
c
c  reflection symmetry
	call mirror(xxs3(1,l),direc3(1,l),cj3(l),el3(l),
     &	      xxs3(1,l+lmax),direc3(1,l+lmax),
     &	      cj3(l+lmax),el3(l+lmax))
	aa3(l+lmax)=aa3(l)
cc
cc	write(6,*) 'n,l,cj3=',n,l,cj3(l),cj3(l+lmax)
cc
 2100	continue
	ell(n)=ell1
 2000	continue
c
c  calculate new base vectors and residual forces
c
	if(idif.lt.0) return
	do 3000 n=1,nff
	l1=ls(n)
	l2=le(n)
	do 3100 l=l1,l2
	isw3=isw
c  if the field is evaluated on the moved elements, all the elements 
c  have to be turned on
	if(ksw3(l).eq.1) isw3=1
c
	dd(1)=direc3(1,l)
	dd(2)=direc3(2,l)
	dd(3)=direc3(3,l)
	costh=dd(1)*direc0(1,l)+dd(2)*direc0(2,l)+dd(3)*direc0(3,l)
	sinth2=1.0-costh*costh
	cph=dd(1)*vf1(1,l)+dd(2)*vf1(2,l)+dd(3)*vf1(3,l)
	sph=dd(1)*vf2(1,l)+dd(2)*vf2(2,l)+dd(3)*vf2(3,l)
	scph=cph*sph
	sph2=sph*sph
	if(sinth2.ne.0.0) then
	  scph=scph/sinth2
	  sph2=sph2/sinth2
	else
	  scph=0.0
	  sph2=0.0
	endif
	cph2=1.0-sph2
	vvf1(1,l)=(costh*cph2+sph2)*vf1(1,l)+scph*(costh-1.0)*vf2(1,l)
     &	         -cph*direc0(1,l)
	vvf1(2,l)=(costh*cph2+sph2)*vf1(2,l)+scph*(costh-1.0)*vf2(2,l)
     &	         -cph*direc0(2,l)
	vvf1(3,l)=(costh*cph2+sph2)*vf1(3,l)+scph*(costh-1.0)*vf2(3,l)
     &	         -cph*direc0(3,l)
	vvf2(1,l)=scph*(costh-1.0)*vf1(1,l)+(costh*sph2+cph2)*vf2(1,l)
     &	         -sph*direc0(1,l)
	vvf2(2,l)=scph*(costh-1.0)*vf1(2,l)+(costh*sph2+cph2)*vf2(2,l)
     &	         -sph*direc0(2,l)
	vvf2(3,l)=scph*(costh-1.0)*vf1(3,l)+(costh*sph2+cph2)*vf2(3,l)
     &	 -sph*direc0(3,l)
c
	if(isw3.eq.0) then
	  isw1=-1
	  isw2=-1
	else
	  isw1=1
	  isw2=1
	endif
c
	call field(xxs3(1,l),bb,isw1,isw2,isw3)
	if(idif.eq.0) then
	  bbn(1,l)=bb(1)
	  bbn(2,l)=bb(2)
	  bbn(3,l)=bb(3)
	endif
c  normalization should be by bs0. bb is not a full field vector when
c  the entry point is djxb
	g(2*l-1)=(bb(1)*vvf1(1,l)+bb(2)*vvf1(2,l)+bb(3)*vvf1(3,l))
     &	    /bs0(l)
	g(2*l  )=(bb(1)*vvf2(1,l)+bb(2)*vvf2(2,l)+bb(3)*vvf2(3,l))
     &	    /bs0(l)
c
cc
	if(bb(1).ne.bb(1)) then
	  write(6,*) 'bb=',bb
	  write(6,*) 'aa3=',(aa3(ll),ll=1,2*lmax)
	  write(6,*) 'el3=',(el3(ll),ll=1,2*lmax)
	  write(6,*) 'cj3=',(cj3(ll),ll=1,2*lmax)
	  write(6,*) 'xxs3(z)=',(xxs3(3,ll),ll=1,2*lmax)
	  write(6,*) 'direc3=',((direc3(m,ll),m=1,3),ll=1,2*lmax)
	  stop 'abort'
	endif
cc
	if(numdif.and.iabs(idif1).eq.ldpeek
     &	 .and. l.eq.lpeek) then
	  write(lst,*) 
	  write(lst,*) 'djxb: l,idif1,n=',l,idif1,n
	  write(lst,*) 'isw1/2/3=',isw1,isw2,isw3
	  write(lst,*) 'x,g=',x(2*l-1),x(2*l),g(2*l-1),g(2*l)
	  write(lst,*) 'vvf1=',(vvf1(m,l),m=1,3)
	  write(lst,*) 'vvf2=',(vvf2(m,l),m=1,3)
	  write(lst,*) 'cj3 =',cj3(l),cj3(l+lmax)
	  write(lst,*) 'xx  =',(xxs3(m,l),m=1,3)
	  write(lst,*) 'bb  =',(bb  (m),m=1,3)
	endif
   	if(.not.numdif.and.iabs(idif0).eq.ldpeek
     &	 .and. l.eq.lpeek) then
	  write(lst,*) 
	  write(lst,*) 'jxb : l,idif0,n=',l,idif0,n
	  write(lst,*) 'x,g=',x(2*l-1),x(2*l),g(2*l-1),g(2*l)
	  write(lst,*) 'vvf1=',(vvf1(m,l),m=1,3)
	  write(lst,*) 'vvf2=',(vvf2(m,l),m=1,3)
	  write(lst,*) 'cj3 =',cj3(l),cj3(l+lmax)
	  write(lst,*) 'xx  =',(xxs3(m,l),m=1,3)
	  write(lst,*) 'bb  =',(bb  (m),m=1,3)
	endif
c
 3100	continue
 3000	continue
c
c  calculation of curl[bn(bh-bhp)]
c
	if(modeff.eq.2 .and. (idif.eq.0 .or. idif.gt.lmax2 ) ) then
	  do 4000 n=1,nff
	  call field(xxs(1,n),bb,-1,-1,1)
	  call vectoc(bb,b,mesh,xxs(1,n))
	  bhx=b(1)
	  bhy=b(2)
	  bn =b(3)
c  bhx and bhy only include contributions from s3 sources
c  whose currents are reduced by factor of facta
	  rotbb(n)=bngx0(n)*bhy - bngy0(n)*bhx + bn0(n)*rotb(n)
	  g(lmax2+n)=rotbb(n)-facta*rotbb0(n)
   	if(msglvl.gt.2 .and. .not.numdif) then
	  write(lst,*) 
	  write(lst,*) 'jxb : facta,idif,n,ns3=',facta,idif,n,ns3
	  write(lst,*) 'x,g=',x(lmax2+n),g(lmax2+n)
	  write(lst,*) 'xxs=',(xxs(m,n),m=1,3)
	  write(lst,*) 'bb=',bb,bhx,bhy,bn
	  write(lst,*) 'bngrad=',bngx0(n),bngy0(n)
	  write(lst,*) 'rotb,rotb0=',rotb(n),rotb0(n)
	  write(lst,*) 'rotbb,rotbb0=',rotbb(n),rotbb0(n)
	endif
 4000	  continue
	endif 
c
	gnorm=0.0
	do 8000 l=1,lmax2
 8000	gnorm=gnorm + g(l)**2
	if( modeff.eq.2 ) then
	  do 8100 n=1,nff
 8100	  gnorm=gnorm + g(lmax2+n)**2
	endif
c
	return
	end
c
	subroutine sets3
c
	include 'sys.fc'
	include 'ff0.fc'
	include 'fff.fc'
c
	call jxb(0, xvect, gnorm, gvect)
	nvar=2*lmax+nff*(modeff-1)
	if(msglvl.gt.1) write(lst,*) '(subr.sets3 ) nvar=',nvar
	return
	end
c
c  mirror reflection of s3 sources
c
	subroutine mirror(xxs,direc,cj,el,xxsm,direcm,cjm,elm)
c
	include 'lparam.fc'
	include 'coord.fc'
	integer*4 kindl1
	dimension xxs(3),direc(3),xxsm(3),direcm(3)
	dimension apu(3),alu(3),hu(3),xxt(3)
c
	kindl1=mod(kindl,1000)
	if(kindl1.eq.0) then
	  xxsm(1)= xxs(1)
	  xxsm(2)= xxs(2)
	  xxsm(3)=-xxs(3)
	  direcm(1)=-direc(1)
	  direcm(2)=-direc(2)
	  direcm(3)= direc(3)
	  elm=el
	  cjm=cj
c
	else if(kindl1.eq.1) then
	  call ctot(xxs,xxt)
	  xxt(3)=-xxt(3)
	  call ttoc(xxt,xxsm)
	  elm=el
	  cjm=cj
c
	  direcx=direc(1)*xtu(1)+direc(2)*xtu(2)+direc(3)*xtu(3)
	  direcy=direc(1)*ytu(1)+direc(2)*ytu(2)+direc(3)*ytu(3)
	  direcz=direc(1)*ztu(1)+direc(2)*ztu(2)+direc(3)*ztu(3)
	  direcx=-direcx
	  direcy=-direcy
	  direcm(1)=direcx*xtu(1)+direcy*ytu(1)+direcz*ztu(1)
	  direcm(2)=direcx*xtu(2)+direcy*ytu(2)+direcz*ztu(2)
	  direcm(3)=direcx*xtu(3)+direcy*ytu(3)+direcz*ztu(3)
c
	else if(kindl1.eq.2 .or. kindl1.eq.102) then
	  call ctos(xxs,ap,al,h)
	  r=rsp+h
	  rm=rsp**2/r
	  hm=rm-rsp
	  call stoc(ap,al,hm,xxsm)
	  elm=el*rm/r
	  cjm=cj*r/rsp
c  need to check ; cj is total current
c
	  call svu(ap,al,apu,alu,hu)
	  direcp=direc(1)*apu(1)+direc(2)*apu(2)+direc(3)*apu(3)
	  direcl=direc(1)*alu(1)+direc(2)*alu(2)+direc(3)*alu(3)
	  direch=direc(1)*hu (1)+direc(2)*hu (2)+direc(3)*hu (3)
	  ajp=-cjm*direcp
	  ajl=-cjm*direcl
	  ajh= cjm*direch
	  aj=sqrt(ajp**2+ajl**2+ajh**2)
	  direcp=ajp/aj
	  direcl=ajl/aj
	  direch=ajh/aj
	  direc(1)=direcp*apu(1)+direcl*alu(1)+direch*hu(1)
	  direc(2)=direcp*apu(2)+direcl*alu(2)+direch*hu(2)
	  direc(3)=direcp*apu(3)+direcl*alu(3)+direch*hu(3)
	endif
	return
	end
