c  field line by spline curve
c
	subroutine spllof ( ounit )
c
	integer ounit
	include 'sys.fc'
	include 'fline.fc'
	include 'lparam.fc'
	include 'ff0.fc'
	include 'fff.fc'
	include 's3.fc'
c
c  ML is defined in fline.fc
c
	logical range0,ldummy
	dimension a0(ML,3),a1(ML,3),a2(ML,3),a3(ML,3),
     &	          a(ML),b(ML),c(ML),ss(ML)
	dimension xx(3,ML)
	equivalence (xyzr(1,1),a0(1,1)),
     &	            (xyzr(1,4),a1(1,1)),
     &	            (xyzr(1,7),a(1)),
     &	            (xyzr(1,8),b(1)),
     &              (xyz2r(1,1),a2(1,1)),
     &              (xyz2r(1,4),a3(1,1)),
     &              (xyz2r(1,7),c(1)),
     &              (xyz2r(1,8),ss(1)),
     &              (xyzp(1,1),xx(1,1))
c
	dimension xxw(3),bb(3)
c
	call umake(kindl, l5,l4,l3,l2,l1)
	kindl=make(l5,2*modeff  ,l3,l2,l1)
	call writlh( ounit )
c
	ds=ds0
	do 10 n=1,nff
c  approximate a field line with a spline curve
c
	do 20 m=1,3
 20	xx(m,1)=xxs(m,n)
	l1=ls(n)
	ss(1)=0.0
	l2=le(n)
	do 30 ll=l1,l2
	ss(ll-l1+2)=ss(ll-l1+1)+el3(ll)
	do 30 m=1,3
 30	xx(m,ll-l1+2)=xxn(m,ll)
c
	call spline(3,ML,l2-l1+2,0,ss,xx,a0,a1,a2,a3,a,b,c)
c
c  calculate coordinates along the spline curve
c
	l=1
	xyzp(4,l)=0.0
	do 40 m=1,3
	xxw(m)=xxs(m,n)
 40	xyzp(m,l)=xxw(m)
	call field( xxw, bb, 1, 1, 1)
	do 45 m=1,3
 45	xyzp(m+4,l)=bb(m)
	xyzp(8,l)=sqrt(bb(1)**2+bb(2)**2+bb(3)**2)
c
	do 50 ll=l1,l2
	ns=el3(ll)/ds+1.0
c
	do 60 nn=1,ns
	t=float(nn)/float(ns)
	l=l+1
	xyzp(4,l)=xyzp(4,l-1)+el3(ll)/float(ns)
	ll1=ll-l1+1
	do 65 m=1,3
 65	xxw(m)=((a3(ll1,m)*t+a2(ll1,m))*t+a1(ll1,m))*t+a0(ll1,m)
	ldummy = range0(xxw,h)
c  range0 forces xxw to lie on the boundary if h<0
	if(h.lt.0.0) then
	  write(lst,*)
     &	'(subr.spllof) warning: nodal point below the boundary,',
     &		       ' n,l,h=',n,l,h
	endif
	do 66 m=1,3
 66	xyzp(m,l)=xxw(m)
	call field( xxw, bb, 1, 1, 1)
	do 70 m=1,3
 70	xyzp(m+4,l)=bb(m)
	xyzp(8,l)=sqrt(bb(1)**2+bb(2)**2+bb(3)**2)
 60	continue
 50	continue
c
	np=l
	call writel( ounit, np, xyzp )
 10	continue
c
cx	call writel( ounit, 0, xyzp )
c
	if(msglvl.gt.0) write(lst,*) '(subr.spllof) nff=',nff
	return
	end
