c  write fieldline file
c
c  write header
	subroutine writlh(ounit)
c
	include 'sys.fc'
	include 'string.fc'
	include 'fileio.fc'
	include 'fcntl.fc'
	include 'mparam.fc'
	include 'lparam.fc'
	include 'fline.fc'
	include 'ff0.fc'
	include 'ss.fc'
c
	integer ounit
	character buf*80
	real facts(8)
	dimension xyz(8,ML)
c  ML is defined in fline.fc
c  necessary dimensions: xyz(8,np), ixyz4(8,np), ixyz2(8,np)
	save facts,loc,nlof
c
	call umake(kindl, l5,l4,l3,l2,l1)
	if(ns3.gt.0) kindl=make(l5,2*modeff-1,l3,l2,l1)
	if(modelf.ne.0) kindl=make(l5,modelf,l3,l2,l1)
c
	lrec0=80
	loc=1
	nlof=0
	mtag=ftag
	ltag=mktag()
cx	if(iabs(nbytel).eq.2) then
cx 32767*0.02=650, which is larger than 2*3.14*rsp(=70)
cx	  factx=0.02
cx	  factb=0.2
cx	else
cx	  factx=0.01*1.0e-4
cx	  factb=0.1 *1.0e-4
cx	endif
cx  nbytel and ncomp should be set by the calling program
cx  factx and factb are set by initc
c
	lfile=mfile
	do 10 i=7,1,-1
	if(mfile(i:i).eq.'.') then
	  lfile(i+1:i+1)='L'
	  go to 11
	endif
 10	continue
 11	continue
c
	if(msglvl.gt.0) then
	  write(lst,*) '(subr.writlh)'
	  write(lst,*) '  kindl,nbyte,ncomp=',kindl,nbytel,ncomp
	  if(l3.eq.1) write(lst,*) '  rrss=',rrss
	  if(msglvl.gt.1) then
	    write(lst,*) '  factx,factb=',factx,factb
	    write(lst,*) '  fileid=',lfile
	    write(lst,*) '  mtag=',mtag
	    write(lst,*) '  ltag=',ltag
	  endif
	endif
c
	if( l3.eq.1 .and. rrss.gt.1.0) then
	  nex=1
	else if(ns1.gt.0) then
	  nex=1
	else
	  nex=0
	endif
	do 20 m=1,4
	facts(m)=factx
 20	facts(m+4)=factb
c
	np1=1
	write(buf,210) np1,nex,nf,ns1,ns2,ns3,bmin1,bmin2,flxpwr
 210	format(i8,i4,2x,i4,3i8,3f12.5,2x)
	if (ocode.ne.0) call cconv(ocode, buf)
	call outs( ounit, loc, buf, lrec0 )
	write(buf,220) kindl,nbytel,ncomp,factx,factb,
     &                       lfile,mtag,ltag
 220	format(i8,2i4,1p2e12.5,a8,2a16)
	if (ocode.ne.0) call cconv(ocode, buf)
	call outs( ounit, loc, buf, lrec0 )
	if(nex.eq.1) then
	  write(buf,230) rrss,chksum
 230	  format(f12.5,i12,56x)
	  if (ocode.ne.0) call cconv(ocode, buf)
	  call outs( ounit, loc, buf, lrec0 )
	endif
	return
c
c  np > 1: write one field line data
c  np = 0: end of record
c
	entry writel(ounit,np,xyz)
c
	lrec0=80
	if(np.eq.0) then
c  end of file
	  write(buf,215) np,nlof
 215	  format(i8,i4,68x)
	  if (ocode.ne.0) call cconv(ocode, buf)
	  call outs( ounit, loc, buf, lrec0)
	  return
	endif
c
c  field line data
c
	if (iabs(nbytel) .eq. 2) then
      do 30 n=1,np
      do 30 m=1,ncomp
	  if(abs(xyz(m,n)/facts(m)).gt.float(maxi2)) then
	    write(msg,*) '(subr.writel) error: overflow in real->i2'
	    write(msg,*) '  n=',n,', xyz=',(xyz(m1,n),m1=1,ncomp)
	    write(msg,*) '  m=',m,', facts(m)=',facts(m)
	    errflg=2
	    return
	  endif
 30   ixyz2(m,n)=xyz(m,n)/facts(m)
c
	  write(buf,215) np
	  if (ocode.ne.0) call cconv(ocode, buf)
	  call outs( ounit, loc, buf, lrec0)
	  call out2( ounit, loc, ixyz2, lrec0, ncomp, np, 8 )
c
	elseif (iabs(nbytel) .eq. 4) then
      do 40 n=1,np
      do 40 m=1,ncomp
	  if(abs(xyz(m,n)/facts(m)).gt.float(maxi4)) then
	    write(msg,*) '(subr.writel) error: overflow in real->i4'
	    write(msg,*) '  n=',n,', xyz=',(xyz(m1,n),m1=1,ncomp)
	    write(msg,*) '  m=',m,', facts(m)=',facts(m)
	    errflg=2
	    return
	  endif
 40	  ixyz4(m,n)=xyz(m,n)/facts(m)
c
	  write(buf,215) np
	  if (ocode.ne.0) call cconv(ocode, buf)
	  call outs( ounit, loc, buf, lrec0)
	  call out4( ounit, loc, ixyz4, lrec0, ncomp, np, 8 )
	endif
c
	if (np.gt.1) nlof=nlof+1
c
	return
c
c  write end-of-file record
c
	entry weof(ounit)
c
	lrec0=80
	write(buf,240) np,nlof
 240	format(i8,i4,68x)
	if (ocode.ne.0) call cconv(ocode, buf)
	call outs( ounit, loc, buf, lrec0)
	return
	end
