;  determine whether a point (x,y) is inside a rectangle whose four corners
;  are (xc4,yc4) as viewed from the z-axis

function inside, x,y, xc4,yc4, loc=loc

	xc4s = shift(xc4,-1)-xc4
	yc4s = shift(yc4,-1)-yc4
	loc = where( $
		xc4s(0)*(y-yc4(0)) - yc4s(0)*(x-xc4(0)) gt 0 and $
		xc4s(1)*(y-yc4(1)) - yc4s(1)*(x-xc4(1)) gt 0 and $
		xc4s(2)*(y-yc4(2)) - yc4s(2)*(x-xc4(2)) gt 0 and $
		xc4s(3)*(y-yc4(3)) - yc4s(3)*(x-xc4(3)) gt 0, count)
	if count gt 0 then return, 1 else return, 0
end

