;+
; NAME :	jn
; PURPOSE :
;	show electric current distribution based on 
;	vector magnetograms
; CATEGORY :
; 	solar magnetic field computation package (MAGPACK2)
; CALLING SEQUENCE :
;	.run jn
; INPUTS :
;	mparam and rdata should be on the memory
; OPTIONAL INPUT PARAMETERS : 
;	none
; KEYWORD PARAMETERS :
; OUTPUTS :
;	electric currents (Jn) will be displayed
; COMMON BLOCKS : 	none
; SIDE EFFECTS :	arrays mparam and rdata will be created
; RESTRICTIONS :	X-window environment is assumed
; PROCEDURE :
;
; MODIFICATION HISTORY :
;	T.Sakurai, 1992
;-
;------------------------------------------------------------------------
;
; @transc
print,'It will take a minute or so.'
curlb1, mparam, rdata, /keep_bp
magplot, mparam, rdata, /nomenu
end

